#ifndef _H_8435D437C1EC777758B89B071B7DED9F_AcceleratorPedalCmd__H_
#define _H_8435D437C1EC777758B89B071B7DED9F_AcceleratorPedalCmd__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "raptor_dbw_msgs/msg/dds_opensplice/ActuatorControlMode_.h"


namespace raptor_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  AcceleratorPedalCmd_
            {
                ::DDS::Float pedal_cmd_;
                ::DDS::Float torque_cmd_;
                ::DDS::Float speed_cmd_;
                ::DDS::Boolean enable_;
                ::DDS::Boolean ignore_;
                ::DDS::Octet rolling_counter_;
                ::DDS::Float road_slope_;
                ::raptor_dbw_msgs::msg::dds_::ActuatorControlMode_ control_type_;
                ::DDS::Float accel_limit_;
                ::DDS::Float accel_positive_jerk_limit_;
            };

            typedef DDS_DCPSStruct_var<AcceleratorPedalCmd_> AcceleratorPedalCmd__var;
            typedef AcceleratorPedalCmd_& AcceleratorPedalCmd__out;

        }

    }

}

#endif /* _H_8435D437C1EC777758B89B071B7DED9F_AcceleratorPedalCmd__H_ */
