#ifndef _H_8435D437C1EC777758B89B071B7DED9F_AcceleratorPedalCmd_DCPS_H_
#define _H_8435D437C1EC777758B89B071B7DED9F_AcceleratorPedalCmd_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "AcceleratorPedalCmd_.h"


namespace raptor_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class AcceleratorPedalCmd_TypeSupportInterface;

            typedef AcceleratorPedalCmd_TypeSupportInterface * AcceleratorPedalCmd_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < AcceleratorPedalCmd_TypeSupportInterface> AcceleratorPedalCmd_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < AcceleratorPedalCmd_TypeSupportInterface> AcceleratorPedalCmd_TypeSupportInterface_out;


            class AcceleratorPedalCmd_DataWriter;

            typedef AcceleratorPedalCmd_DataWriter * AcceleratorPedalCmd_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < AcceleratorPedalCmd_DataWriter> AcceleratorPedalCmd_DataWriter_var;
            typedef DDS_DCPSInterface_out < AcceleratorPedalCmd_DataWriter> AcceleratorPedalCmd_DataWriter_out;


            class AcceleratorPedalCmd_DataReader;

            typedef AcceleratorPedalCmd_DataReader * AcceleratorPedalCmd_DataReader_ptr;
            typedef DDS_DCPSInterface_var < AcceleratorPedalCmd_DataReader> AcceleratorPedalCmd_DataReader_var;
            typedef DDS_DCPSInterface_out < AcceleratorPedalCmd_DataReader> AcceleratorPedalCmd_DataReader_out;


            class AcceleratorPedalCmd_DataReaderView;

            typedef AcceleratorPedalCmd_DataReaderView * AcceleratorPedalCmd_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < AcceleratorPedalCmd_DataReaderView> AcceleratorPedalCmd_DataReaderView_var;
            typedef DDS_DCPSInterface_out < AcceleratorPedalCmd_DataReaderView> AcceleratorPedalCmd_DataReaderView_out;

            struct AcceleratorPedalCmd_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < AcceleratorPedalCmd_, struct AcceleratorPedalCmd_Seq_uniq_> AcceleratorPedalCmd_Seq;
            typedef DDS_DCPSSequence_var < AcceleratorPedalCmd_Seq> AcceleratorPedalCmd_Seq_var;
            typedef DDS_DCPSSequence_out < AcceleratorPedalCmd_Seq> AcceleratorPedalCmd_Seq_out;

            class  AcceleratorPedalCmd_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef AcceleratorPedalCmd_TypeSupportInterface_ptr _ptr_type;
                typedef AcceleratorPedalCmd_TypeSupportInterface_var _var_type;

                static AcceleratorPedalCmd_TypeSupportInterface_ptr _duplicate (AcceleratorPedalCmd_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AcceleratorPedalCmd_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static AcceleratorPedalCmd_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AcceleratorPedalCmd_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                AcceleratorPedalCmd_TypeSupportInterface_ptr _this () { return this; }


            protected:
                AcceleratorPedalCmd_TypeSupportInterface () {};
                ~AcceleratorPedalCmd_TypeSupportInterface () {};
            private:
                AcceleratorPedalCmd_TypeSupportInterface (const AcceleratorPedalCmd_TypeSupportInterface &);
                AcceleratorPedalCmd_TypeSupportInterface & operator = (const AcceleratorPedalCmd_TypeSupportInterface &);
            };

            class  AcceleratorPedalCmd_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef AcceleratorPedalCmd_DataWriter_ptr _ptr_type;
                typedef AcceleratorPedalCmd_DataWriter_var _var_type;

                static AcceleratorPedalCmd_DataWriter_ptr _duplicate (AcceleratorPedalCmd_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AcceleratorPedalCmd_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static AcceleratorPedalCmd_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AcceleratorPedalCmd_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                AcceleratorPedalCmd_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const AcceleratorPedalCmd_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const AcceleratorPedalCmd_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const AcceleratorPedalCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const AcceleratorPedalCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const AcceleratorPedalCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const AcceleratorPedalCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const AcceleratorPedalCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const AcceleratorPedalCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const AcceleratorPedalCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const AcceleratorPedalCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (AcceleratorPedalCmd_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AcceleratorPedalCmd_& instance_data) = 0;

            protected:
                AcceleratorPedalCmd_DataWriter () {};
                ~AcceleratorPedalCmd_DataWriter () {};
            private:
                AcceleratorPedalCmd_DataWriter (const AcceleratorPedalCmd_DataWriter &);
                AcceleratorPedalCmd_DataWriter & operator = (const AcceleratorPedalCmd_DataWriter &);
            };

            class  AcceleratorPedalCmd_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef AcceleratorPedalCmd_DataReader_ptr _ptr_type;
                typedef AcceleratorPedalCmd_DataReader_var _var_type;

                static AcceleratorPedalCmd_DataReader_ptr _duplicate (AcceleratorPedalCmd_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AcceleratorPedalCmd_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static AcceleratorPedalCmd_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AcceleratorPedalCmd_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                AcceleratorPedalCmd_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (AcceleratorPedalCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AcceleratorPedalCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AcceleratorPedalCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AcceleratorPedalCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AcceleratorPedalCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AcceleratorPedalCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AcceleratorPedalCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AcceleratorPedalCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AcceleratorPedalCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AcceleratorPedalCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AcceleratorPedalCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AcceleratorPedalCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AcceleratorPedalCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AcceleratorPedalCmd_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AcceleratorPedalCmd_& instance) = 0;

            protected:
                AcceleratorPedalCmd_DataReader () {};
                ~AcceleratorPedalCmd_DataReader () {};
            private:
                AcceleratorPedalCmd_DataReader (const AcceleratorPedalCmd_DataReader &);
                AcceleratorPedalCmd_DataReader & operator = (const AcceleratorPedalCmd_DataReader &);
            };

            class  AcceleratorPedalCmd_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef AcceleratorPedalCmd_DataReaderView_ptr _ptr_type;
                typedef AcceleratorPedalCmd_DataReaderView_var _var_type;

                static AcceleratorPedalCmd_DataReaderView_ptr _duplicate (AcceleratorPedalCmd_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AcceleratorPedalCmd_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static AcceleratorPedalCmd_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AcceleratorPedalCmd_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                AcceleratorPedalCmd_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (AcceleratorPedalCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AcceleratorPedalCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AcceleratorPedalCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AcceleratorPedalCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AcceleratorPedalCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AcceleratorPedalCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AcceleratorPedalCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AcceleratorPedalCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AcceleratorPedalCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AcceleratorPedalCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AcceleratorPedalCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AcceleratorPedalCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AcceleratorPedalCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AcceleratorPedalCmd_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AcceleratorPedalCmd_& instance) = 0;

            protected:
                AcceleratorPedalCmd_DataReaderView () {};
                ~AcceleratorPedalCmd_DataReaderView () {};
            private:
                AcceleratorPedalCmd_DataReaderView (const AcceleratorPedalCmd_DataReaderView &);
                AcceleratorPedalCmd_DataReaderView & operator = (const AcceleratorPedalCmd_DataReaderView &);
            };
        }

    }

}

#endif
