#ifndef H_1FA7B7FCE7520A758AA787BEE4562B72_AcceleratorPedalReport_SPLTYPES_H
#define H_1FA7B7FCE7520A758AA787BEE4562B72_AcceleratorPedalReport_SPLTYPES_H

#include <c_base.h>
#include <c_misc.h>
#include <c_sync.h>
#include <c_collection.h>
#include <c_field.h>
#include <v_copyIn.h>

#include "ccpp_AcceleratorPedalReport_.h"
#include "std_msgs/msg/dds_opensplice/Header_SplDcps.h"
#include "raptor_dbw_msgs/msg/dds_opensplice/ActuatorControlMode_SplDcps.h"



extern c_metaObject __AcceleratorPedalReport__raptor_dbw_msgs__load (c_base base);

extern c_metaObject __AcceleratorPedalReport__raptor_dbw_msgs_msg__load (c_base base);

extern c_metaObject __AcceleratorPedalReport__raptor_dbw_msgs_msg_dds___load (c_base base);

extern const char *raptor_dbw_msgs_msg_dds__AcceleratorPedalReport__metaDescriptor[];
extern const int raptor_dbw_msgs_msg_dds__AcceleratorPedalReport__metaDescriptorArrLength;
extern const int raptor_dbw_msgs_msg_dds__AcceleratorPedalReport__metaDescriptorLength;
extern c_metaObject __raptor_dbw_msgs_msg_dds__AcceleratorPedalReport___load (c_base base);
struct _raptor_dbw_msgs_msg_dds__AcceleratorPedalReport_ ;
extern  v_copyin_result __raptor_dbw_msgs_msg_dds__AcceleratorPedalReport___copyIn(c_base base, const struct raptor_dbw_msgs::msg::dds_::AcceleratorPedalReport_ *from, struct _raptor_dbw_msgs_msg_dds__AcceleratorPedalReport_ *to);
extern  void __raptor_dbw_msgs_msg_dds__AcceleratorPedalReport___copyOut(const void *_from, void *_to);
struct _raptor_dbw_msgs_msg_dds__AcceleratorPedalReport_ {
    struct _std_msgs_msg_dds__Header_ header_;
    c_float pedal_input_;
    c_float pedal_output_;
    c_bool enabled_;
    c_bool ignore_driver_;
    c_bool driver_activity_;
    c_bool fault_accel_pedal_system_;
    c_bool fault_ch1_;
    c_bool fault_ch2_;
    c_octet rolling_counter_;
    c_float torque_actual_;
    struct _raptor_dbw_msgs_msg_dds__ActuatorControlMode_ control_type_;
};

#undef OS_API
#endif
