#ifndef _H_4883CF740A6BA77D4BDC202B307E6DEF_ActuatorControlMode_DCPS_H_
#define _H_4883CF740A6BA77D4BDC202B307E6DEF_ActuatorControlMode_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ActuatorControlMode_.h"


namespace raptor_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ActuatorControlMode_TypeSupportInterface;

            typedef ActuatorControlMode_TypeSupportInterface * ActuatorControlMode_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ActuatorControlMode_TypeSupportInterface> ActuatorControlMode_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ActuatorControlMode_TypeSupportInterface> ActuatorControlMode_TypeSupportInterface_out;


            class ActuatorControlMode_DataWriter;

            typedef ActuatorControlMode_DataWriter * ActuatorControlMode_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ActuatorControlMode_DataWriter> ActuatorControlMode_DataWriter_var;
            typedef DDS_DCPSInterface_out < ActuatorControlMode_DataWriter> ActuatorControlMode_DataWriter_out;


            class ActuatorControlMode_DataReader;

            typedef ActuatorControlMode_DataReader * ActuatorControlMode_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ActuatorControlMode_DataReader> ActuatorControlMode_DataReader_var;
            typedef DDS_DCPSInterface_out < ActuatorControlMode_DataReader> ActuatorControlMode_DataReader_out;


            class ActuatorControlMode_DataReaderView;

            typedef ActuatorControlMode_DataReaderView * ActuatorControlMode_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ActuatorControlMode_DataReaderView> ActuatorControlMode_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ActuatorControlMode_DataReaderView> ActuatorControlMode_DataReaderView_out;

            struct ActuatorControlMode_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < ActuatorControlMode_, struct ActuatorControlMode_Seq_uniq_> ActuatorControlMode_Seq;
            typedef DDS_DCPSSequence_var < ActuatorControlMode_Seq> ActuatorControlMode_Seq_var;
            typedef DDS_DCPSSequence_out < ActuatorControlMode_Seq> ActuatorControlMode_Seq_out;

            class  ActuatorControlMode_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ActuatorControlMode_TypeSupportInterface_ptr _ptr_type;
                typedef ActuatorControlMode_TypeSupportInterface_var _var_type;

                static ActuatorControlMode_TypeSupportInterface_ptr _duplicate (ActuatorControlMode_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ActuatorControlMode_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ActuatorControlMode_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ActuatorControlMode_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ActuatorControlMode_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ActuatorControlMode_TypeSupportInterface () {};
                ~ActuatorControlMode_TypeSupportInterface () {};
            private:
                ActuatorControlMode_TypeSupportInterface (const ActuatorControlMode_TypeSupportInterface &);
                ActuatorControlMode_TypeSupportInterface & operator = (const ActuatorControlMode_TypeSupportInterface &);
            };

            class  ActuatorControlMode_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ActuatorControlMode_DataWriter_ptr _ptr_type;
                typedef ActuatorControlMode_DataWriter_var _var_type;

                static ActuatorControlMode_DataWriter_ptr _duplicate (ActuatorControlMode_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ActuatorControlMode_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ActuatorControlMode_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ActuatorControlMode_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ActuatorControlMode_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ActuatorControlMode_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ActuatorControlMode_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ActuatorControlMode_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ActuatorControlMode_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ActuatorControlMode_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ActuatorControlMode_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ActuatorControlMode_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ActuatorControlMode_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ActuatorControlMode_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ActuatorControlMode_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ActuatorControlMode_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ActuatorControlMode_& instance_data) = 0;

            protected:
                ActuatorControlMode_DataWriter () {};
                ~ActuatorControlMode_DataWriter () {};
            private:
                ActuatorControlMode_DataWriter (const ActuatorControlMode_DataWriter &);
                ActuatorControlMode_DataWriter & operator = (const ActuatorControlMode_DataWriter &);
            };

            class  ActuatorControlMode_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ActuatorControlMode_DataReader_ptr _ptr_type;
                typedef ActuatorControlMode_DataReader_var _var_type;

                static ActuatorControlMode_DataReader_ptr _duplicate (ActuatorControlMode_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ActuatorControlMode_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ActuatorControlMode_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ActuatorControlMode_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ActuatorControlMode_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ActuatorControlMode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ActuatorControlMode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ActuatorControlMode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ActuatorControlMode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ActuatorControlMode_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ActuatorControlMode_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ActuatorControlMode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ActuatorControlMode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ActuatorControlMode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ActuatorControlMode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ActuatorControlMode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ActuatorControlMode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ActuatorControlMode_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ActuatorControlMode_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ActuatorControlMode_& instance) = 0;

            protected:
                ActuatorControlMode_DataReader () {};
                ~ActuatorControlMode_DataReader () {};
            private:
                ActuatorControlMode_DataReader (const ActuatorControlMode_DataReader &);
                ActuatorControlMode_DataReader & operator = (const ActuatorControlMode_DataReader &);
            };

            class  ActuatorControlMode_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ActuatorControlMode_DataReaderView_ptr _ptr_type;
                typedef ActuatorControlMode_DataReaderView_var _var_type;

                static ActuatorControlMode_DataReaderView_ptr _duplicate (ActuatorControlMode_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ActuatorControlMode_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ActuatorControlMode_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ActuatorControlMode_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ActuatorControlMode_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ActuatorControlMode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ActuatorControlMode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ActuatorControlMode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ActuatorControlMode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ActuatorControlMode_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ActuatorControlMode_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ActuatorControlMode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ActuatorControlMode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ActuatorControlMode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ActuatorControlMode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ActuatorControlMode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ActuatorControlMode_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ActuatorControlMode_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ActuatorControlMode_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ActuatorControlMode_& instance) = 0;

            protected:
                ActuatorControlMode_DataReaderView () {};
                ~ActuatorControlMode_DataReaderView () {};
            private:
                ActuatorControlMode_DataReaderView (const ActuatorControlMode_DataReaderView &);
                ActuatorControlMode_DataReaderView & operator = (const ActuatorControlMode_DataReaderView &);
            };
        }

    }

}

#endif
