#ifndef _H_47BE5DCCA6F3B57529DFA4635782DF76_Brake2Report_DCPS_H_
#define _H_47BE5DCCA6F3B57529DFA4635782DF76_Brake2Report_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Brake2Report_.h"


namespace raptor_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class Brake2Report_TypeSupportInterface;

            typedef Brake2Report_TypeSupportInterface * Brake2Report_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Brake2Report_TypeSupportInterface> Brake2Report_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Brake2Report_TypeSupportInterface> Brake2Report_TypeSupportInterface_out;


            class Brake2Report_DataWriter;

            typedef Brake2Report_DataWriter * Brake2Report_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Brake2Report_DataWriter> Brake2Report_DataWriter_var;
            typedef DDS_DCPSInterface_out < Brake2Report_DataWriter> Brake2Report_DataWriter_out;


            class Brake2Report_DataReader;

            typedef Brake2Report_DataReader * Brake2Report_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Brake2Report_DataReader> Brake2Report_DataReader_var;
            typedef DDS_DCPSInterface_out < Brake2Report_DataReader> Brake2Report_DataReader_out;


            class Brake2Report_DataReaderView;

            typedef Brake2Report_DataReaderView * Brake2Report_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Brake2Report_DataReaderView> Brake2Report_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Brake2Report_DataReaderView> Brake2Report_DataReaderView_out;

            struct Brake2Report_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Brake2Report_, struct Brake2Report_Seq_uniq_> Brake2Report_Seq;
            typedef DDS_DCPSSequence_var < Brake2Report_Seq> Brake2Report_Seq_var;
            typedef DDS_DCPSSequence_out < Brake2Report_Seq> Brake2Report_Seq_out;

            class  Brake2Report_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Brake2Report_TypeSupportInterface_ptr _ptr_type;
                typedef Brake2Report_TypeSupportInterface_var _var_type;

                static Brake2Report_TypeSupportInterface_ptr _duplicate (Brake2Report_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Brake2Report_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Brake2Report_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Brake2Report_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Brake2Report_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Brake2Report_TypeSupportInterface () {};
                ~Brake2Report_TypeSupportInterface () {};
            private:
                Brake2Report_TypeSupportInterface (const Brake2Report_TypeSupportInterface &);
                Brake2Report_TypeSupportInterface & operator = (const Brake2Report_TypeSupportInterface &);
            };

            class  Brake2Report_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Brake2Report_DataWriter_ptr _ptr_type;
                typedef Brake2Report_DataWriter_var _var_type;

                static Brake2Report_DataWriter_ptr _duplicate (Brake2Report_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Brake2Report_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Brake2Report_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Brake2Report_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Brake2Report_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Brake2Report_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Brake2Report_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Brake2Report_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Brake2Report_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Brake2Report_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Brake2Report_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Brake2Report_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Brake2Report_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Brake2Report_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Brake2Report_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Brake2Report_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Brake2Report_& instance_data) = 0;

            protected:
                Brake2Report_DataWriter () {};
                ~Brake2Report_DataWriter () {};
            private:
                Brake2Report_DataWriter (const Brake2Report_DataWriter &);
                Brake2Report_DataWriter & operator = (const Brake2Report_DataWriter &);
            };

            class  Brake2Report_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Brake2Report_DataReader_ptr _ptr_type;
                typedef Brake2Report_DataReader_var _var_type;

                static Brake2Report_DataReader_ptr _duplicate (Brake2Report_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Brake2Report_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Brake2Report_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Brake2Report_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Brake2Report_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Brake2Report_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Brake2Report_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Brake2Report_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Brake2Report_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Brake2Report_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Brake2Report_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Brake2Report_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Brake2Report_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Brake2Report_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Brake2Report_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Brake2Report_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Brake2Report_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Brake2Report_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Brake2Report_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Brake2Report_& instance) = 0;

            protected:
                Brake2Report_DataReader () {};
                ~Brake2Report_DataReader () {};
            private:
                Brake2Report_DataReader (const Brake2Report_DataReader &);
                Brake2Report_DataReader & operator = (const Brake2Report_DataReader &);
            };

            class  Brake2Report_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Brake2Report_DataReaderView_ptr _ptr_type;
                typedef Brake2Report_DataReaderView_var _var_type;

                static Brake2Report_DataReaderView_ptr _duplicate (Brake2Report_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Brake2Report_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Brake2Report_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Brake2Report_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Brake2Report_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Brake2Report_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Brake2Report_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Brake2Report_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Brake2Report_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Brake2Report_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Brake2Report_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Brake2Report_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Brake2Report_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Brake2Report_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Brake2Report_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Brake2Report_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Brake2Report_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Brake2Report_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Brake2Report_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Brake2Report_& instance) = 0;

            protected:
                Brake2Report_DataReaderView () {};
                ~Brake2Report_DataReaderView () {};
            private:
                Brake2Report_DataReaderView (const Brake2Report_DataReaderView &);
                Brake2Report_DataReaderView & operator = (const Brake2Report_DataReaderView &);
            };
        }

    }

}

#endif
