#ifndef _H_C3A3070A620EED02B108DA9FA7D0EBB2_BrakeCmd__H_
#define _H_C3A3070A620EED02B108DA9FA7D0EBB2_BrakeCmd__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "raptor_dbw_msgs/msg/dds_opensplice/ActuatorControlMode_.h"
#include "raptor_dbw_msgs/msg/dds_opensplice/ParkingBrake_.h"


namespace raptor_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  BrakeCmd_
            {
                ::DDS::Float pedal_cmd_;
                ::DDS::Boolean enable_;
                ::DDS::Octet rolling_counter_;
                ::DDS::Float torque_cmd_;
                ::DDS::Float decel_limit_;
                ::raptor_dbw_msgs::msg::dds_::ActuatorControlMode_ control_type_;
                ::DDS::Float decel_negative_jerk_limit_;
                ::raptor_dbw_msgs::msg::dds_::ParkingBrake_ park_brake_cmd_;
            };

            typedef DDS_DCPSStruct_var<BrakeCmd_> BrakeCmd__var;
            typedef BrakeCmd_& BrakeCmd__out;

        }

    }

}

#endif /* _H_C3A3070A620EED02B108DA9FA7D0EBB2_BrakeCmd__H_ */
