#ifndef _H_C3A3070A620EED02B108DA9FA7D0EBB2_BrakeCmd_DCPS_H_
#define _H_C3A3070A620EED02B108DA9FA7D0EBB2_BrakeCmd_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "BrakeCmd_.h"


namespace raptor_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class BrakeCmd_TypeSupportInterface;

            typedef BrakeCmd_TypeSupportInterface * BrakeCmd_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < BrakeCmd_TypeSupportInterface> BrakeCmd_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < BrakeCmd_TypeSupportInterface> BrakeCmd_TypeSupportInterface_out;


            class BrakeCmd_DataWriter;

            typedef BrakeCmd_DataWriter * BrakeCmd_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < BrakeCmd_DataWriter> BrakeCmd_DataWriter_var;
            typedef DDS_DCPSInterface_out < BrakeCmd_DataWriter> BrakeCmd_DataWriter_out;


            class BrakeCmd_DataReader;

            typedef BrakeCmd_DataReader * BrakeCmd_DataReader_ptr;
            typedef DDS_DCPSInterface_var < BrakeCmd_DataReader> BrakeCmd_DataReader_var;
            typedef DDS_DCPSInterface_out < BrakeCmd_DataReader> BrakeCmd_DataReader_out;


            class BrakeCmd_DataReaderView;

            typedef BrakeCmd_DataReaderView * BrakeCmd_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < BrakeCmd_DataReaderView> BrakeCmd_DataReaderView_var;
            typedef DDS_DCPSInterface_out < BrakeCmd_DataReaderView> BrakeCmd_DataReaderView_out;

            struct BrakeCmd_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < BrakeCmd_, struct BrakeCmd_Seq_uniq_> BrakeCmd_Seq;
            typedef DDS_DCPSSequence_var < BrakeCmd_Seq> BrakeCmd_Seq_var;
            typedef DDS_DCPSSequence_out < BrakeCmd_Seq> BrakeCmd_Seq_out;

            class  BrakeCmd_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef BrakeCmd_TypeSupportInterface_ptr _ptr_type;
                typedef BrakeCmd_TypeSupportInterface_var _var_type;

                static BrakeCmd_TypeSupportInterface_ptr _duplicate (BrakeCmd_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BrakeCmd_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static BrakeCmd_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BrakeCmd_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                BrakeCmd_TypeSupportInterface_ptr _this () { return this; }


            protected:
                BrakeCmd_TypeSupportInterface () {};
                ~BrakeCmd_TypeSupportInterface () {};
            private:
                BrakeCmd_TypeSupportInterface (const BrakeCmd_TypeSupportInterface &);
                BrakeCmd_TypeSupportInterface & operator = (const BrakeCmd_TypeSupportInterface &);
            };

            class  BrakeCmd_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef BrakeCmd_DataWriter_ptr _ptr_type;
                typedef BrakeCmd_DataWriter_var _var_type;

                static BrakeCmd_DataWriter_ptr _duplicate (BrakeCmd_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BrakeCmd_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static BrakeCmd_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BrakeCmd_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                BrakeCmd_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const BrakeCmd_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const BrakeCmd_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const BrakeCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const BrakeCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const BrakeCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const BrakeCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const BrakeCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const BrakeCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const BrakeCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const BrakeCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (BrakeCmd_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const BrakeCmd_& instance_data) = 0;

            protected:
                BrakeCmd_DataWriter () {};
                ~BrakeCmd_DataWriter () {};
            private:
                BrakeCmd_DataWriter (const BrakeCmd_DataWriter &);
                BrakeCmd_DataWriter & operator = (const BrakeCmd_DataWriter &);
            };

            class  BrakeCmd_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef BrakeCmd_DataReader_ptr _ptr_type;
                typedef BrakeCmd_DataReader_var _var_type;

                static BrakeCmd_DataReader_ptr _duplicate (BrakeCmd_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BrakeCmd_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static BrakeCmd_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BrakeCmd_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                BrakeCmd_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (BrakeCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (BrakeCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (BrakeCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (BrakeCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (BrakeCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (BrakeCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (BrakeCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (BrakeCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (BrakeCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (BrakeCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (BrakeCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (BrakeCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (BrakeCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (BrakeCmd_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const BrakeCmd_& instance) = 0;

            protected:
                BrakeCmd_DataReader () {};
                ~BrakeCmd_DataReader () {};
            private:
                BrakeCmd_DataReader (const BrakeCmd_DataReader &);
                BrakeCmd_DataReader & operator = (const BrakeCmd_DataReader &);
            };

            class  BrakeCmd_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef BrakeCmd_DataReaderView_ptr _ptr_type;
                typedef BrakeCmd_DataReaderView_var _var_type;

                static BrakeCmd_DataReaderView_ptr _duplicate (BrakeCmd_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BrakeCmd_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static BrakeCmd_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BrakeCmd_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                BrakeCmd_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (BrakeCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (BrakeCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (BrakeCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (BrakeCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (BrakeCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (BrakeCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (BrakeCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (BrakeCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (BrakeCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (BrakeCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (BrakeCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (BrakeCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (BrakeCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (BrakeCmd_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const BrakeCmd_& instance) = 0;

            protected:
                BrakeCmd_DataReaderView () {};
                ~BrakeCmd_DataReaderView () {};
            private:
                BrakeCmd_DataReaderView (const BrakeCmd_DataReaderView &);
                BrakeCmd_DataReaderView & operator = (const BrakeCmd_DataReaderView &);
            };
        }

    }

}

#endif
