#ifndef _H_8B942F34C0439C7A30C29C7DE5D96570_BrakeReport_DCPS_H_
#define _H_8B942F34C0439C7A30C29C7DE5D96570_BrakeReport_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "BrakeReport_.h"


namespace raptor_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class BrakeReport_TypeSupportInterface;

            typedef BrakeReport_TypeSupportInterface * BrakeReport_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < BrakeReport_TypeSupportInterface> BrakeReport_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < BrakeReport_TypeSupportInterface> BrakeReport_TypeSupportInterface_out;


            class BrakeReport_DataWriter;

            typedef BrakeReport_DataWriter * BrakeReport_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < BrakeReport_DataWriter> BrakeReport_DataWriter_var;
            typedef DDS_DCPSInterface_out < BrakeReport_DataWriter> BrakeReport_DataWriter_out;


            class BrakeReport_DataReader;

            typedef BrakeReport_DataReader * BrakeReport_DataReader_ptr;
            typedef DDS_DCPSInterface_var < BrakeReport_DataReader> BrakeReport_DataReader_var;
            typedef DDS_DCPSInterface_out < BrakeReport_DataReader> BrakeReport_DataReader_out;


            class BrakeReport_DataReaderView;

            typedef BrakeReport_DataReaderView * BrakeReport_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < BrakeReport_DataReaderView> BrakeReport_DataReaderView_var;
            typedef DDS_DCPSInterface_out < BrakeReport_DataReaderView> BrakeReport_DataReaderView_out;

            struct BrakeReport_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < BrakeReport_, struct BrakeReport_Seq_uniq_> BrakeReport_Seq;
            typedef DDS_DCPSSequence_var < BrakeReport_Seq> BrakeReport_Seq_var;
            typedef DDS_DCPSSequence_out < BrakeReport_Seq> BrakeReport_Seq_out;

            class  BrakeReport_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef BrakeReport_TypeSupportInterface_ptr _ptr_type;
                typedef BrakeReport_TypeSupportInterface_var _var_type;

                static BrakeReport_TypeSupportInterface_ptr _duplicate (BrakeReport_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BrakeReport_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static BrakeReport_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BrakeReport_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                BrakeReport_TypeSupportInterface_ptr _this () { return this; }


            protected:
                BrakeReport_TypeSupportInterface () {};
                ~BrakeReport_TypeSupportInterface () {};
            private:
                BrakeReport_TypeSupportInterface (const BrakeReport_TypeSupportInterface &);
                BrakeReport_TypeSupportInterface & operator = (const BrakeReport_TypeSupportInterface &);
            };

            class  BrakeReport_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef BrakeReport_DataWriter_ptr _ptr_type;
                typedef BrakeReport_DataWriter_var _var_type;

                static BrakeReport_DataWriter_ptr _duplicate (BrakeReport_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BrakeReport_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static BrakeReport_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BrakeReport_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                BrakeReport_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const BrakeReport_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const BrakeReport_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const BrakeReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const BrakeReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const BrakeReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const BrakeReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const BrakeReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const BrakeReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const BrakeReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const BrakeReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (BrakeReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const BrakeReport_& instance_data) = 0;

            protected:
                BrakeReport_DataWriter () {};
                ~BrakeReport_DataWriter () {};
            private:
                BrakeReport_DataWriter (const BrakeReport_DataWriter &);
                BrakeReport_DataWriter & operator = (const BrakeReport_DataWriter &);
            };

            class  BrakeReport_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef BrakeReport_DataReader_ptr _ptr_type;
                typedef BrakeReport_DataReader_var _var_type;

                static BrakeReport_DataReader_ptr _duplicate (BrakeReport_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BrakeReport_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static BrakeReport_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BrakeReport_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                BrakeReport_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (BrakeReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (BrakeReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (BrakeReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (BrakeReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (BrakeReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (BrakeReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (BrakeReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (BrakeReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (BrakeReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (BrakeReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (BrakeReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (BrakeReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (BrakeReport_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (BrakeReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const BrakeReport_& instance) = 0;

            protected:
                BrakeReport_DataReader () {};
                ~BrakeReport_DataReader () {};
            private:
                BrakeReport_DataReader (const BrakeReport_DataReader &);
                BrakeReport_DataReader & operator = (const BrakeReport_DataReader &);
            };

            class  BrakeReport_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef BrakeReport_DataReaderView_ptr _ptr_type;
                typedef BrakeReport_DataReaderView_var _var_type;

                static BrakeReport_DataReaderView_ptr _duplicate (BrakeReport_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static BrakeReport_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static BrakeReport_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static BrakeReport_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                BrakeReport_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (BrakeReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (BrakeReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (BrakeReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (BrakeReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (BrakeReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (BrakeReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (BrakeReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (BrakeReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (BrakeReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (BrakeReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (BrakeReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (BrakeReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (BrakeReport_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (BrakeReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const BrakeReport_& instance) = 0;

            protected:
                BrakeReport_DataReaderView () {};
                ~BrakeReport_DataReaderView () {};
            private:
                BrakeReport_DataReaderView (const BrakeReport_DataReaderView &);
                BrakeReport_DataReaderView & operator = (const BrakeReport_DataReaderView &);
            };
        }

    }

}

#endif
