#ifndef H_8B942F34C0439C7A30C29C7DE5D96570_BrakeReport_SPLTYPES_H
#define H_8B942F34C0439C7A30C29C7DE5D96570_BrakeReport_SPLTYPES_H

#include <c_base.h>
#include <c_misc.h>
#include <c_sync.h>
#include <c_collection.h>
#include <c_field.h>
#include <v_copyIn.h>

#include "ccpp_BrakeReport_.h"
#include "std_msgs/msg/dds_opensplice/Header_SplDcps.h"
#include "raptor_dbw_msgs/msg/dds_opensplice/ParkingBrake_SplDcps.h"
#include "raptor_dbw_msgs/msg/dds_opensplice/ActuatorControlMode_SplDcps.h"



extern c_metaObject __BrakeReport__raptor_dbw_msgs__load (c_base base);

extern c_metaObject __BrakeReport__raptor_dbw_msgs_msg__load (c_base base);

extern c_metaObject __BrakeReport__raptor_dbw_msgs_msg_dds___load (c_base base);

extern const char *raptor_dbw_msgs_msg_dds__BrakeReport__metaDescriptor[];
extern const int raptor_dbw_msgs_msg_dds__BrakeReport__metaDescriptorArrLength;
extern const int raptor_dbw_msgs_msg_dds__BrakeReport__metaDescriptorLength;
extern c_metaObject __raptor_dbw_msgs_msg_dds__BrakeReport___load (c_base base);
struct _raptor_dbw_msgs_msg_dds__BrakeReport_ ;
extern  v_copyin_result __raptor_dbw_msgs_msg_dds__BrakeReport___copyIn(c_base base, const struct raptor_dbw_msgs::msg::dds_::BrakeReport_ *from, struct _raptor_dbw_msgs_msg_dds__BrakeReport_ *to);
extern  void __raptor_dbw_msgs_msg_dds__BrakeReport___copyOut(const void *_from, void *_to);
struct _raptor_dbw_msgs_msg_dds__BrakeReport_ {
    struct _std_msgs_msg_dds__Header_ header_;
    c_float pedal_position_;
    c_float pedal_output_;
    c_bool enabled_;
    c_bool driver_activity_;
    c_bool fault_brake_system_;
    c_octet rolling_counter_;
    c_float brake_torque_actual_;
    c_bool intervention_active_;
    c_bool intervention_ready_;
    struct _raptor_dbw_msgs_msg_dds__ParkingBrake_ parking_brake_;
    struct _raptor_dbw_msgs_msg_dds__ActuatorControlMode_ control_type_;
};

#undef OS_API
#endif
