#ifndef _H_EA3D4179263DDC45586CD6E71163A4DA_DoorRequest_DCPS_H_
#define _H_EA3D4179263DDC45586CD6E71163A4DA_DoorRequest_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "DoorRequest_.h"


namespace raptor_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class DoorRequest_TypeSupportInterface;

            typedef DoorRequest_TypeSupportInterface * DoorRequest_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < DoorRequest_TypeSupportInterface> DoorRequest_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < DoorRequest_TypeSupportInterface> DoorRequest_TypeSupportInterface_out;


            class DoorRequest_DataWriter;

            typedef DoorRequest_DataWriter * DoorRequest_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < DoorRequest_DataWriter> DoorRequest_DataWriter_var;
            typedef DDS_DCPSInterface_out < DoorRequest_DataWriter> DoorRequest_DataWriter_out;


            class DoorRequest_DataReader;

            typedef DoorRequest_DataReader * DoorRequest_DataReader_ptr;
            typedef DDS_DCPSInterface_var < DoorRequest_DataReader> DoorRequest_DataReader_var;
            typedef DDS_DCPSInterface_out < DoorRequest_DataReader> DoorRequest_DataReader_out;


            class DoorRequest_DataReaderView;

            typedef DoorRequest_DataReaderView * DoorRequest_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < DoorRequest_DataReaderView> DoorRequest_DataReaderView_var;
            typedef DDS_DCPSInterface_out < DoorRequest_DataReaderView> DoorRequest_DataReaderView_out;

            struct DoorRequest_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < DoorRequest_, struct DoorRequest_Seq_uniq_> DoorRequest_Seq;
            typedef DDS_DCPSSequence_var < DoorRequest_Seq> DoorRequest_Seq_var;
            typedef DDS_DCPSSequence_out < DoorRequest_Seq> DoorRequest_Seq_out;

            class  DoorRequest_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef DoorRequest_TypeSupportInterface_ptr _ptr_type;
                typedef DoorRequest_TypeSupportInterface_var _var_type;

                static DoorRequest_TypeSupportInterface_ptr _duplicate (DoorRequest_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DoorRequest_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static DoorRequest_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DoorRequest_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                DoorRequest_TypeSupportInterface_ptr _this () { return this; }


            protected:
                DoorRequest_TypeSupportInterface () {};
                ~DoorRequest_TypeSupportInterface () {};
            private:
                DoorRequest_TypeSupportInterface (const DoorRequest_TypeSupportInterface &);
                DoorRequest_TypeSupportInterface & operator = (const DoorRequest_TypeSupportInterface &);
            };

            class  DoorRequest_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef DoorRequest_DataWriter_ptr _ptr_type;
                typedef DoorRequest_DataWriter_var _var_type;

                static DoorRequest_DataWriter_ptr _duplicate (DoorRequest_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DoorRequest_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static DoorRequest_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DoorRequest_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                DoorRequest_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const DoorRequest_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const DoorRequest_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const DoorRequest_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const DoorRequest_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const DoorRequest_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const DoorRequest_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const DoorRequest_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const DoorRequest_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const DoorRequest_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const DoorRequest_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (DoorRequest_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DoorRequest_& instance_data) = 0;

            protected:
                DoorRequest_DataWriter () {};
                ~DoorRequest_DataWriter () {};
            private:
                DoorRequest_DataWriter (const DoorRequest_DataWriter &);
                DoorRequest_DataWriter & operator = (const DoorRequest_DataWriter &);
            };

            class  DoorRequest_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef DoorRequest_DataReader_ptr _ptr_type;
                typedef DoorRequest_DataReader_var _var_type;

                static DoorRequest_DataReader_ptr _duplicate (DoorRequest_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DoorRequest_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static DoorRequest_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DoorRequest_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                DoorRequest_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (DoorRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DoorRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DoorRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DoorRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DoorRequest_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DoorRequest_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DoorRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DoorRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DoorRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DoorRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DoorRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DoorRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DoorRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DoorRequest_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DoorRequest_& instance) = 0;

            protected:
                DoorRequest_DataReader () {};
                ~DoorRequest_DataReader () {};
            private:
                DoorRequest_DataReader (const DoorRequest_DataReader &);
                DoorRequest_DataReader & operator = (const DoorRequest_DataReader &);
            };

            class  DoorRequest_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef DoorRequest_DataReaderView_ptr _ptr_type;
                typedef DoorRequest_DataReaderView_var _var_type;

                static DoorRequest_DataReaderView_ptr _duplicate (DoorRequest_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DoorRequest_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static DoorRequest_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DoorRequest_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                DoorRequest_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (DoorRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DoorRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DoorRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DoorRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DoorRequest_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DoorRequest_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DoorRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DoorRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DoorRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DoorRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DoorRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DoorRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DoorRequest_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DoorRequest_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DoorRequest_& instance) = 0;

            protected:
                DoorRequest_DataReaderView () {};
                ~DoorRequest_DataReaderView () {};
            private:
                DoorRequest_DataReaderView (const DoorRequest_DataReaderView &);
                DoorRequest_DataReaderView & operator = (const DoorRequest_DataReaderView &);
            };
        }

    }

}

#endif
