#ifndef _H_480C00FFEFA883604CF35CF730A3CF78_DoorState_DCPS_H_
#define _H_480C00FFEFA883604CF35CF730A3CF78_DoorState_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "DoorState_.h"


namespace raptor_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class DoorState_TypeSupportInterface;

            typedef DoorState_TypeSupportInterface * DoorState_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < DoorState_TypeSupportInterface> DoorState_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < DoorState_TypeSupportInterface> DoorState_TypeSupportInterface_out;


            class DoorState_DataWriter;

            typedef DoorState_DataWriter * DoorState_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < DoorState_DataWriter> DoorState_DataWriter_var;
            typedef DDS_DCPSInterface_out < DoorState_DataWriter> DoorState_DataWriter_out;


            class DoorState_DataReader;

            typedef DoorState_DataReader * DoorState_DataReader_ptr;
            typedef DDS_DCPSInterface_var < DoorState_DataReader> DoorState_DataReader_var;
            typedef DDS_DCPSInterface_out < DoorState_DataReader> DoorState_DataReader_out;


            class DoorState_DataReaderView;

            typedef DoorState_DataReaderView * DoorState_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < DoorState_DataReaderView> DoorState_DataReaderView_var;
            typedef DDS_DCPSInterface_out < DoorState_DataReaderView> DoorState_DataReaderView_out;

            struct DoorState_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < DoorState_, struct DoorState_Seq_uniq_> DoorState_Seq;
            typedef DDS_DCPSSequence_var < DoorState_Seq> DoorState_Seq_var;
            typedef DDS_DCPSSequence_out < DoorState_Seq> DoorState_Seq_out;

            class  DoorState_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef DoorState_TypeSupportInterface_ptr _ptr_type;
                typedef DoorState_TypeSupportInterface_var _var_type;

                static DoorState_TypeSupportInterface_ptr _duplicate (DoorState_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DoorState_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static DoorState_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DoorState_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                DoorState_TypeSupportInterface_ptr _this () { return this; }


            protected:
                DoorState_TypeSupportInterface () {};
                ~DoorState_TypeSupportInterface () {};
            private:
                DoorState_TypeSupportInterface (const DoorState_TypeSupportInterface &);
                DoorState_TypeSupportInterface & operator = (const DoorState_TypeSupportInterface &);
            };

            class  DoorState_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef DoorState_DataWriter_ptr _ptr_type;
                typedef DoorState_DataWriter_var _var_type;

                static DoorState_DataWriter_ptr _duplicate (DoorState_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DoorState_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static DoorState_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DoorState_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                DoorState_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const DoorState_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const DoorState_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const DoorState_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const DoorState_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const DoorState_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const DoorState_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const DoorState_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const DoorState_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const DoorState_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const DoorState_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (DoorState_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DoorState_& instance_data) = 0;

            protected:
                DoorState_DataWriter () {};
                ~DoorState_DataWriter () {};
            private:
                DoorState_DataWriter (const DoorState_DataWriter &);
                DoorState_DataWriter & operator = (const DoorState_DataWriter &);
            };

            class  DoorState_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef DoorState_DataReader_ptr _ptr_type;
                typedef DoorState_DataReader_var _var_type;

                static DoorState_DataReader_ptr _duplicate (DoorState_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DoorState_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static DoorState_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DoorState_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                DoorState_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (DoorState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DoorState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DoorState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DoorState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DoorState_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DoorState_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DoorState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DoorState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DoorState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DoorState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DoorState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DoorState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DoorState_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DoorState_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DoorState_& instance) = 0;

            protected:
                DoorState_DataReader () {};
                ~DoorState_DataReader () {};
            private:
                DoorState_DataReader (const DoorState_DataReader &);
                DoorState_DataReader & operator = (const DoorState_DataReader &);
            };

            class  DoorState_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef DoorState_DataReaderView_ptr _ptr_type;
                typedef DoorState_DataReaderView_var _var_type;

                static DoorState_DataReaderView_ptr _duplicate (DoorState_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DoorState_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static DoorState_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DoorState_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                DoorState_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (DoorState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DoorState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DoorState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DoorState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DoorState_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DoorState_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DoorState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DoorState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DoorState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DoorState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DoorState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DoorState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DoorState_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DoorState_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DoorState_& instance) = 0;

            protected:
                DoorState_DataReaderView () {};
                ~DoorState_DataReaderView () {};
            private:
                DoorState_DataReaderView (const DoorState_DataReaderView &);
                DoorState_DataReaderView & operator = (const DoorState_DataReaderView &);
            };
        }

    }

}

#endif
