#ifndef _H_B3735AF513CFC597AF5537DCBBC694D0_DriverInputReport_DCPS_H_
#define _H_B3735AF513CFC597AF5537DCBBC694D0_DriverInputReport_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "DriverInputReport_.h"


namespace raptor_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class DriverInputReport_TypeSupportInterface;

            typedef DriverInputReport_TypeSupportInterface * DriverInputReport_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < DriverInputReport_TypeSupportInterface> DriverInputReport_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < DriverInputReport_TypeSupportInterface> DriverInputReport_TypeSupportInterface_out;


            class DriverInputReport_DataWriter;

            typedef DriverInputReport_DataWriter * DriverInputReport_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < DriverInputReport_DataWriter> DriverInputReport_DataWriter_var;
            typedef DDS_DCPSInterface_out < DriverInputReport_DataWriter> DriverInputReport_DataWriter_out;


            class DriverInputReport_DataReader;

            typedef DriverInputReport_DataReader * DriverInputReport_DataReader_ptr;
            typedef DDS_DCPSInterface_var < DriverInputReport_DataReader> DriverInputReport_DataReader_var;
            typedef DDS_DCPSInterface_out < DriverInputReport_DataReader> DriverInputReport_DataReader_out;


            class DriverInputReport_DataReaderView;

            typedef DriverInputReport_DataReaderView * DriverInputReport_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < DriverInputReport_DataReaderView> DriverInputReport_DataReaderView_var;
            typedef DDS_DCPSInterface_out < DriverInputReport_DataReaderView> DriverInputReport_DataReaderView_out;

            struct DriverInputReport_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < DriverInputReport_, struct DriverInputReport_Seq_uniq_> DriverInputReport_Seq;
            typedef DDS_DCPSSequence_var < DriverInputReport_Seq> DriverInputReport_Seq_var;
            typedef DDS_DCPSSequence_out < DriverInputReport_Seq> DriverInputReport_Seq_out;

            class  DriverInputReport_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef DriverInputReport_TypeSupportInterface_ptr _ptr_type;
                typedef DriverInputReport_TypeSupportInterface_var _var_type;

                static DriverInputReport_TypeSupportInterface_ptr _duplicate (DriverInputReport_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DriverInputReport_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static DriverInputReport_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DriverInputReport_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                DriverInputReport_TypeSupportInterface_ptr _this () { return this; }


            protected:
                DriverInputReport_TypeSupportInterface () {};
                ~DriverInputReport_TypeSupportInterface () {};
            private:
                DriverInputReport_TypeSupportInterface (const DriverInputReport_TypeSupportInterface &);
                DriverInputReport_TypeSupportInterface & operator = (const DriverInputReport_TypeSupportInterface &);
            };

            class  DriverInputReport_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef DriverInputReport_DataWriter_ptr _ptr_type;
                typedef DriverInputReport_DataWriter_var _var_type;

                static DriverInputReport_DataWriter_ptr _duplicate (DriverInputReport_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DriverInputReport_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static DriverInputReport_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DriverInputReport_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                DriverInputReport_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const DriverInputReport_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const DriverInputReport_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const DriverInputReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const DriverInputReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const DriverInputReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const DriverInputReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const DriverInputReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const DriverInputReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const DriverInputReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const DriverInputReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (DriverInputReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DriverInputReport_& instance_data) = 0;

            protected:
                DriverInputReport_DataWriter () {};
                ~DriverInputReport_DataWriter () {};
            private:
                DriverInputReport_DataWriter (const DriverInputReport_DataWriter &);
                DriverInputReport_DataWriter & operator = (const DriverInputReport_DataWriter &);
            };

            class  DriverInputReport_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef DriverInputReport_DataReader_ptr _ptr_type;
                typedef DriverInputReport_DataReader_var _var_type;

                static DriverInputReport_DataReader_ptr _duplicate (DriverInputReport_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DriverInputReport_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static DriverInputReport_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DriverInputReport_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                DriverInputReport_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (DriverInputReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DriverInputReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DriverInputReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DriverInputReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DriverInputReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DriverInputReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DriverInputReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DriverInputReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DriverInputReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DriverInputReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DriverInputReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DriverInputReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DriverInputReport_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DriverInputReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DriverInputReport_& instance) = 0;

            protected:
                DriverInputReport_DataReader () {};
                ~DriverInputReport_DataReader () {};
            private:
                DriverInputReport_DataReader (const DriverInputReport_DataReader &);
                DriverInputReport_DataReader & operator = (const DriverInputReport_DataReader &);
            };

            class  DriverInputReport_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef DriverInputReport_DataReaderView_ptr _ptr_type;
                typedef DriverInputReport_DataReaderView_var _var_type;

                static DriverInputReport_DataReaderView_ptr _duplicate (DriverInputReport_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DriverInputReport_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static DriverInputReport_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DriverInputReport_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                DriverInputReport_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (DriverInputReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DriverInputReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DriverInputReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DriverInputReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DriverInputReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DriverInputReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DriverInputReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DriverInputReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DriverInputReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DriverInputReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DriverInputReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DriverInputReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DriverInputReport_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DriverInputReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DriverInputReport_& instance) = 0;

            protected:
                DriverInputReport_DataReaderView () {};
                ~DriverInputReport_DataReaderView () {};
            private:
                DriverInputReport_DataReaderView (const DriverInputReport_DataReaderView &);
                DriverInputReport_DataReaderView & operator = (const DriverInputReport_DataReaderView &);
            };
        }

    }

}

#endif
