#ifndef _H_5170496EC58D079F2D4D36934C7A5EA3_FaultActionsReport__H_
#define _H_5170496EC58D079F2D4D36934C7A5EA3_FaultActionsReport__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace raptor_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  FaultActionsReport_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Boolean autonomous_disabled_no_brakes_;
                ::DDS::Boolean autonomous_disabled_apply_brakes_;
                ::DDS::Boolean can_gateway_disabled_;
                ::DDS::Boolean inverter_contactor_disabled_;
                ::DDS::Boolean prevent_enter_autonomous_mode_;
                ::DDS::Boolean warn_driver_only_;
                ::DDS::Boolean chime_fcw_beeps_;
            };

            typedef DDS_DCPSStruct_var<FaultActionsReport_> FaultActionsReport__var;
            typedef DDS_DCPSStruct_out < FaultActionsReport_> FaultActionsReport__out;

        }

    }

}

#endif /* _H_5170496EC58D079F2D4D36934C7A5EA3_FaultActionsReport__H_ */
