#ifndef _H_5170496EC58D079F2D4D36934C7A5EA3_FaultActionsReport_DCPS_H_
#define _H_5170496EC58D079F2D4D36934C7A5EA3_FaultActionsReport_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "FaultActionsReport_.h"


namespace raptor_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class FaultActionsReport_TypeSupportInterface;

            typedef FaultActionsReport_TypeSupportInterface * FaultActionsReport_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < FaultActionsReport_TypeSupportInterface> FaultActionsReport_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < FaultActionsReport_TypeSupportInterface> FaultActionsReport_TypeSupportInterface_out;


            class FaultActionsReport_DataWriter;

            typedef FaultActionsReport_DataWriter * FaultActionsReport_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < FaultActionsReport_DataWriter> FaultActionsReport_DataWriter_var;
            typedef DDS_DCPSInterface_out < FaultActionsReport_DataWriter> FaultActionsReport_DataWriter_out;


            class FaultActionsReport_DataReader;

            typedef FaultActionsReport_DataReader * FaultActionsReport_DataReader_ptr;
            typedef DDS_DCPSInterface_var < FaultActionsReport_DataReader> FaultActionsReport_DataReader_var;
            typedef DDS_DCPSInterface_out < FaultActionsReport_DataReader> FaultActionsReport_DataReader_out;


            class FaultActionsReport_DataReaderView;

            typedef FaultActionsReport_DataReaderView * FaultActionsReport_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < FaultActionsReport_DataReaderView> FaultActionsReport_DataReaderView_var;
            typedef DDS_DCPSInterface_out < FaultActionsReport_DataReaderView> FaultActionsReport_DataReaderView_out;

            struct FaultActionsReport_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < FaultActionsReport_, struct FaultActionsReport_Seq_uniq_> FaultActionsReport_Seq;
            typedef DDS_DCPSSequence_var < FaultActionsReport_Seq> FaultActionsReport_Seq_var;
            typedef DDS_DCPSSequence_out < FaultActionsReport_Seq> FaultActionsReport_Seq_out;

            class  FaultActionsReport_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef FaultActionsReport_TypeSupportInterface_ptr _ptr_type;
                typedef FaultActionsReport_TypeSupportInterface_var _var_type;

                static FaultActionsReport_TypeSupportInterface_ptr _duplicate (FaultActionsReport_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FaultActionsReport_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static FaultActionsReport_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FaultActionsReport_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                FaultActionsReport_TypeSupportInterface_ptr _this () { return this; }


            protected:
                FaultActionsReport_TypeSupportInterface () {};
                ~FaultActionsReport_TypeSupportInterface () {};
            private:
                FaultActionsReport_TypeSupportInterface (const FaultActionsReport_TypeSupportInterface &);
                FaultActionsReport_TypeSupportInterface & operator = (const FaultActionsReport_TypeSupportInterface &);
            };

            class  FaultActionsReport_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef FaultActionsReport_DataWriter_ptr _ptr_type;
                typedef FaultActionsReport_DataWriter_var _var_type;

                static FaultActionsReport_DataWriter_ptr _duplicate (FaultActionsReport_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FaultActionsReport_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static FaultActionsReport_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FaultActionsReport_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                FaultActionsReport_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const FaultActionsReport_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const FaultActionsReport_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const FaultActionsReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const FaultActionsReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const FaultActionsReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const FaultActionsReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const FaultActionsReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const FaultActionsReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const FaultActionsReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const FaultActionsReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (FaultActionsReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const FaultActionsReport_& instance_data) = 0;

            protected:
                FaultActionsReport_DataWriter () {};
                ~FaultActionsReport_DataWriter () {};
            private:
                FaultActionsReport_DataWriter (const FaultActionsReport_DataWriter &);
                FaultActionsReport_DataWriter & operator = (const FaultActionsReport_DataWriter &);
            };

            class  FaultActionsReport_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef FaultActionsReport_DataReader_ptr _ptr_type;
                typedef FaultActionsReport_DataReader_var _var_type;

                static FaultActionsReport_DataReader_ptr _duplicate (FaultActionsReport_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FaultActionsReport_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static FaultActionsReport_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FaultActionsReport_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                FaultActionsReport_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (FaultActionsReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (FaultActionsReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (FaultActionsReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (FaultActionsReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (FaultActionsReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (FaultActionsReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (FaultActionsReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (FaultActionsReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (FaultActionsReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (FaultActionsReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (FaultActionsReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (FaultActionsReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (FaultActionsReport_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (FaultActionsReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const FaultActionsReport_& instance) = 0;

            protected:
                FaultActionsReport_DataReader () {};
                ~FaultActionsReport_DataReader () {};
            private:
                FaultActionsReport_DataReader (const FaultActionsReport_DataReader &);
                FaultActionsReport_DataReader & operator = (const FaultActionsReport_DataReader &);
            };

            class  FaultActionsReport_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef FaultActionsReport_DataReaderView_ptr _ptr_type;
                typedef FaultActionsReport_DataReaderView_var _var_type;

                static FaultActionsReport_DataReaderView_ptr _duplicate (FaultActionsReport_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static FaultActionsReport_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static FaultActionsReport_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static FaultActionsReport_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                FaultActionsReport_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (FaultActionsReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (FaultActionsReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (FaultActionsReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (FaultActionsReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (FaultActionsReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (FaultActionsReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (FaultActionsReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (FaultActionsReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (FaultActionsReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (FaultActionsReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (FaultActionsReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (FaultActionsReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (FaultActionsReport_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (FaultActionsReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const FaultActionsReport_& instance) = 0;

            protected:
                FaultActionsReport_DataReaderView () {};
                ~FaultActionsReport_DataReaderView () {};
            private:
                FaultActionsReport_DataReaderView (const FaultActionsReport_DataReaderView &);
                FaultActionsReport_DataReaderView & operator = (const FaultActionsReport_DataReaderView &);
            };
        }

    }

}

#endif
