#ifndef _H_7111B50CF00319DF53E8D58AA187893A_GearCmd_DCPS_H_
#define _H_7111B50CF00319DF53E8D58AA187893A_GearCmd_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "GearCmd_.h"


namespace raptor_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class GearCmd_TypeSupportInterface;

            typedef GearCmd_TypeSupportInterface * GearCmd_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GearCmd_TypeSupportInterface> GearCmd_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GearCmd_TypeSupportInterface> GearCmd_TypeSupportInterface_out;


            class GearCmd_DataWriter;

            typedef GearCmd_DataWriter * GearCmd_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GearCmd_DataWriter> GearCmd_DataWriter_var;
            typedef DDS_DCPSInterface_out < GearCmd_DataWriter> GearCmd_DataWriter_out;


            class GearCmd_DataReader;

            typedef GearCmd_DataReader * GearCmd_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GearCmd_DataReader> GearCmd_DataReader_var;
            typedef DDS_DCPSInterface_out < GearCmd_DataReader> GearCmd_DataReader_out;


            class GearCmd_DataReaderView;

            typedef GearCmd_DataReaderView * GearCmd_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GearCmd_DataReaderView> GearCmd_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GearCmd_DataReaderView> GearCmd_DataReaderView_out;

            struct GearCmd_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < GearCmd_, struct GearCmd_Seq_uniq_> GearCmd_Seq;
            typedef DDS_DCPSSequence_var < GearCmd_Seq> GearCmd_Seq_var;
            typedef DDS_DCPSSequence_out < GearCmd_Seq> GearCmd_Seq_out;

            class  GearCmd_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GearCmd_TypeSupportInterface_ptr _ptr_type;
                typedef GearCmd_TypeSupportInterface_var _var_type;

                static GearCmd_TypeSupportInterface_ptr _duplicate (GearCmd_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GearCmd_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GearCmd_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GearCmd_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GearCmd_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GearCmd_TypeSupportInterface () {};
                ~GearCmd_TypeSupportInterface () {};
            private:
                GearCmd_TypeSupportInterface (const GearCmd_TypeSupportInterface &);
                GearCmd_TypeSupportInterface & operator = (const GearCmd_TypeSupportInterface &);
            };

            class  GearCmd_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GearCmd_DataWriter_ptr _ptr_type;
                typedef GearCmd_DataWriter_var _var_type;

                static GearCmd_DataWriter_ptr _duplicate (GearCmd_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GearCmd_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GearCmd_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GearCmd_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GearCmd_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GearCmd_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GearCmd_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GearCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GearCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GearCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GearCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GearCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GearCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GearCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GearCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GearCmd_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GearCmd_& instance_data) = 0;

            protected:
                GearCmd_DataWriter () {};
                ~GearCmd_DataWriter () {};
            private:
                GearCmd_DataWriter (const GearCmd_DataWriter &);
                GearCmd_DataWriter & operator = (const GearCmd_DataWriter &);
            };

            class  GearCmd_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GearCmd_DataReader_ptr _ptr_type;
                typedef GearCmd_DataReader_var _var_type;

                static GearCmd_DataReader_ptr _duplicate (GearCmd_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GearCmd_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GearCmd_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GearCmd_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GearCmd_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GearCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GearCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GearCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GearCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GearCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GearCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GearCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GearCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GearCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GearCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GearCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GearCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GearCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GearCmd_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GearCmd_& instance) = 0;

            protected:
                GearCmd_DataReader () {};
                ~GearCmd_DataReader () {};
            private:
                GearCmd_DataReader (const GearCmd_DataReader &);
                GearCmd_DataReader & operator = (const GearCmd_DataReader &);
            };

            class  GearCmd_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GearCmd_DataReaderView_ptr _ptr_type;
                typedef GearCmd_DataReaderView_var _var_type;

                static GearCmd_DataReaderView_ptr _duplicate (GearCmd_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GearCmd_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GearCmd_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GearCmd_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GearCmd_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GearCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GearCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GearCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GearCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GearCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GearCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GearCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GearCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GearCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GearCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GearCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GearCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GearCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GearCmd_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GearCmd_& instance) = 0;

            protected:
                GearCmd_DataReaderView () {};
                ~GearCmd_DataReaderView () {};
            private:
                GearCmd_DataReaderView (const GearCmd_DataReaderView &);
                GearCmd_DataReaderView & operator = (const GearCmd_DataReaderView &);
            };
        }

    }

}

#endif
