#ifndef _H_19331608B487DBCBAC03E9BB4256FBBD_GearReport__H_
#define _H_19331608B487DBCBAC03E9BB4256FBBD_GearReport__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"
#include "raptor_dbw_msgs/msg/dds_opensplice/Gear_.h"


namespace raptor_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  GearReport_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::raptor_dbw_msgs::msg::dds_::Gear_ state_;
                ::DDS::Boolean reject_;
                ::DDS::Boolean driver_activity_;
                ::DDS::Boolean enabled_;
                ::DDS::Octet trans_curr_gear_;
                ::DDS::Boolean gear_select_system_fault_;
                ::DDS::Boolean gear_mismatch_flash_;
            };

            typedef DDS_DCPSStruct_var<GearReport_> GearReport__var;
            typedef DDS_DCPSStruct_out < GearReport_> GearReport__out;

        }

    }

}

#endif /* _H_19331608B487DBCBAC03E9BB4256FBBD_GearReport__H_ */
