#ifndef _H_741EF6C23F60A72096DBDA079413745B_GpsReferenceReport_DCPS_H_
#define _H_741EF6C23F60A72096DBDA079413745B_GpsReferenceReport_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "GpsReferenceReport_.h"


namespace raptor_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class GpsReferenceReport_TypeSupportInterface;

            typedef GpsReferenceReport_TypeSupportInterface * GpsReferenceReport_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GpsReferenceReport_TypeSupportInterface> GpsReferenceReport_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GpsReferenceReport_TypeSupportInterface> GpsReferenceReport_TypeSupportInterface_out;


            class GpsReferenceReport_DataWriter;

            typedef GpsReferenceReport_DataWriter * GpsReferenceReport_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GpsReferenceReport_DataWriter> GpsReferenceReport_DataWriter_var;
            typedef DDS_DCPSInterface_out < GpsReferenceReport_DataWriter> GpsReferenceReport_DataWriter_out;


            class GpsReferenceReport_DataReader;

            typedef GpsReferenceReport_DataReader * GpsReferenceReport_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GpsReferenceReport_DataReader> GpsReferenceReport_DataReader_var;
            typedef DDS_DCPSInterface_out < GpsReferenceReport_DataReader> GpsReferenceReport_DataReader_out;


            class GpsReferenceReport_DataReaderView;

            typedef GpsReferenceReport_DataReaderView * GpsReferenceReport_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GpsReferenceReport_DataReaderView> GpsReferenceReport_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GpsReferenceReport_DataReaderView> GpsReferenceReport_DataReaderView_out;

            struct GpsReferenceReport_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < GpsReferenceReport_, struct GpsReferenceReport_Seq_uniq_> GpsReferenceReport_Seq;
            typedef DDS_DCPSSequence_var < GpsReferenceReport_Seq> GpsReferenceReport_Seq_var;
            typedef DDS_DCPSSequence_out < GpsReferenceReport_Seq> GpsReferenceReport_Seq_out;

            class  GpsReferenceReport_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GpsReferenceReport_TypeSupportInterface_ptr _ptr_type;
                typedef GpsReferenceReport_TypeSupportInterface_var _var_type;

                static GpsReferenceReport_TypeSupportInterface_ptr _duplicate (GpsReferenceReport_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GpsReferenceReport_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GpsReferenceReport_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GpsReferenceReport_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GpsReferenceReport_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GpsReferenceReport_TypeSupportInterface () {};
                ~GpsReferenceReport_TypeSupportInterface () {};
            private:
                GpsReferenceReport_TypeSupportInterface (const GpsReferenceReport_TypeSupportInterface &);
                GpsReferenceReport_TypeSupportInterface & operator = (const GpsReferenceReport_TypeSupportInterface &);
            };

            class  GpsReferenceReport_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GpsReferenceReport_DataWriter_ptr _ptr_type;
                typedef GpsReferenceReport_DataWriter_var _var_type;

                static GpsReferenceReport_DataWriter_ptr _duplicate (GpsReferenceReport_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GpsReferenceReport_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GpsReferenceReport_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GpsReferenceReport_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GpsReferenceReport_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GpsReferenceReport_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GpsReferenceReport_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GpsReferenceReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GpsReferenceReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GpsReferenceReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GpsReferenceReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GpsReferenceReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GpsReferenceReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GpsReferenceReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GpsReferenceReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GpsReferenceReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GpsReferenceReport_& instance_data) = 0;

            protected:
                GpsReferenceReport_DataWriter () {};
                ~GpsReferenceReport_DataWriter () {};
            private:
                GpsReferenceReport_DataWriter (const GpsReferenceReport_DataWriter &);
                GpsReferenceReport_DataWriter & operator = (const GpsReferenceReport_DataWriter &);
            };

            class  GpsReferenceReport_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GpsReferenceReport_DataReader_ptr _ptr_type;
                typedef GpsReferenceReport_DataReader_var _var_type;

                static GpsReferenceReport_DataReader_ptr _duplicate (GpsReferenceReport_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GpsReferenceReport_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GpsReferenceReport_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GpsReferenceReport_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GpsReferenceReport_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GpsReferenceReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GpsReferenceReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GpsReferenceReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GpsReferenceReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GpsReferenceReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GpsReferenceReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GpsReferenceReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GpsReferenceReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GpsReferenceReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GpsReferenceReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GpsReferenceReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GpsReferenceReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GpsReferenceReport_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GpsReferenceReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GpsReferenceReport_& instance) = 0;

            protected:
                GpsReferenceReport_DataReader () {};
                ~GpsReferenceReport_DataReader () {};
            private:
                GpsReferenceReport_DataReader (const GpsReferenceReport_DataReader &);
                GpsReferenceReport_DataReader & operator = (const GpsReferenceReport_DataReader &);
            };

            class  GpsReferenceReport_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GpsReferenceReport_DataReaderView_ptr _ptr_type;
                typedef GpsReferenceReport_DataReaderView_var _var_type;

                static GpsReferenceReport_DataReaderView_ptr _duplicate (GpsReferenceReport_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GpsReferenceReport_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GpsReferenceReport_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GpsReferenceReport_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GpsReferenceReport_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GpsReferenceReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GpsReferenceReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GpsReferenceReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GpsReferenceReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GpsReferenceReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GpsReferenceReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GpsReferenceReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GpsReferenceReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GpsReferenceReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GpsReferenceReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GpsReferenceReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GpsReferenceReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GpsReferenceReport_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GpsReferenceReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GpsReferenceReport_& instance) = 0;

            protected:
                GpsReferenceReport_DataReaderView () {};
                ~GpsReferenceReport_DataReaderView () {};
            private:
                GpsReferenceReport_DataReaderView (const GpsReferenceReport_DataReaderView &);
                GpsReferenceReport_DataReaderView & operator = (const GpsReferenceReport_DataReaderView &);
            };
        }

    }

}

#endif
