#ifndef _H_7CE9872E541A6F0477222F6B4059E6F7_HmiGlobalEnableReport_DCPS_H_
#define _H_7CE9872E541A6F0477222F6B4059E6F7_HmiGlobalEnableReport_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "HmiGlobalEnableReport_.h"


namespace raptor_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class HmiGlobalEnableReport_TypeSupportInterface;

            typedef HmiGlobalEnableReport_TypeSupportInterface * HmiGlobalEnableReport_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < HmiGlobalEnableReport_TypeSupportInterface> HmiGlobalEnableReport_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < HmiGlobalEnableReport_TypeSupportInterface> HmiGlobalEnableReport_TypeSupportInterface_out;


            class HmiGlobalEnableReport_DataWriter;

            typedef HmiGlobalEnableReport_DataWriter * HmiGlobalEnableReport_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < HmiGlobalEnableReport_DataWriter> HmiGlobalEnableReport_DataWriter_var;
            typedef DDS_DCPSInterface_out < HmiGlobalEnableReport_DataWriter> HmiGlobalEnableReport_DataWriter_out;


            class HmiGlobalEnableReport_DataReader;

            typedef HmiGlobalEnableReport_DataReader * HmiGlobalEnableReport_DataReader_ptr;
            typedef DDS_DCPSInterface_var < HmiGlobalEnableReport_DataReader> HmiGlobalEnableReport_DataReader_var;
            typedef DDS_DCPSInterface_out < HmiGlobalEnableReport_DataReader> HmiGlobalEnableReport_DataReader_out;


            class HmiGlobalEnableReport_DataReaderView;

            typedef HmiGlobalEnableReport_DataReaderView * HmiGlobalEnableReport_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < HmiGlobalEnableReport_DataReaderView> HmiGlobalEnableReport_DataReaderView_var;
            typedef DDS_DCPSInterface_out < HmiGlobalEnableReport_DataReaderView> HmiGlobalEnableReport_DataReaderView_out;

            struct HmiGlobalEnableReport_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < HmiGlobalEnableReport_, struct HmiGlobalEnableReport_Seq_uniq_> HmiGlobalEnableReport_Seq;
            typedef DDS_DCPSSequence_var < HmiGlobalEnableReport_Seq> HmiGlobalEnableReport_Seq_var;
            typedef DDS_DCPSSequence_out < HmiGlobalEnableReport_Seq> HmiGlobalEnableReport_Seq_out;

            class  HmiGlobalEnableReport_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef HmiGlobalEnableReport_TypeSupportInterface_ptr _ptr_type;
                typedef HmiGlobalEnableReport_TypeSupportInterface_var _var_type;

                static HmiGlobalEnableReport_TypeSupportInterface_ptr _duplicate (HmiGlobalEnableReport_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HmiGlobalEnableReport_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static HmiGlobalEnableReport_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HmiGlobalEnableReport_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                HmiGlobalEnableReport_TypeSupportInterface_ptr _this () { return this; }


            protected:
                HmiGlobalEnableReport_TypeSupportInterface () {};
                ~HmiGlobalEnableReport_TypeSupportInterface () {};
            private:
                HmiGlobalEnableReport_TypeSupportInterface (const HmiGlobalEnableReport_TypeSupportInterface &);
                HmiGlobalEnableReport_TypeSupportInterface & operator = (const HmiGlobalEnableReport_TypeSupportInterface &);
            };

            class  HmiGlobalEnableReport_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef HmiGlobalEnableReport_DataWriter_ptr _ptr_type;
                typedef HmiGlobalEnableReport_DataWriter_var _var_type;

                static HmiGlobalEnableReport_DataWriter_ptr _duplicate (HmiGlobalEnableReport_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HmiGlobalEnableReport_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static HmiGlobalEnableReport_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HmiGlobalEnableReport_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                HmiGlobalEnableReport_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const HmiGlobalEnableReport_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const HmiGlobalEnableReport_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const HmiGlobalEnableReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const HmiGlobalEnableReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const HmiGlobalEnableReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const HmiGlobalEnableReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const HmiGlobalEnableReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const HmiGlobalEnableReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const HmiGlobalEnableReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const HmiGlobalEnableReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (HmiGlobalEnableReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const HmiGlobalEnableReport_& instance_data) = 0;

            protected:
                HmiGlobalEnableReport_DataWriter () {};
                ~HmiGlobalEnableReport_DataWriter () {};
            private:
                HmiGlobalEnableReport_DataWriter (const HmiGlobalEnableReport_DataWriter &);
                HmiGlobalEnableReport_DataWriter & operator = (const HmiGlobalEnableReport_DataWriter &);
            };

            class  HmiGlobalEnableReport_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef HmiGlobalEnableReport_DataReader_ptr _ptr_type;
                typedef HmiGlobalEnableReport_DataReader_var _var_type;

                static HmiGlobalEnableReport_DataReader_ptr _duplicate (HmiGlobalEnableReport_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HmiGlobalEnableReport_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static HmiGlobalEnableReport_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HmiGlobalEnableReport_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                HmiGlobalEnableReport_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (HmiGlobalEnableReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (HmiGlobalEnableReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (HmiGlobalEnableReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (HmiGlobalEnableReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (HmiGlobalEnableReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (HmiGlobalEnableReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (HmiGlobalEnableReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (HmiGlobalEnableReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (HmiGlobalEnableReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (HmiGlobalEnableReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (HmiGlobalEnableReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (HmiGlobalEnableReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (HmiGlobalEnableReport_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (HmiGlobalEnableReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const HmiGlobalEnableReport_& instance) = 0;

            protected:
                HmiGlobalEnableReport_DataReader () {};
                ~HmiGlobalEnableReport_DataReader () {};
            private:
                HmiGlobalEnableReport_DataReader (const HmiGlobalEnableReport_DataReader &);
                HmiGlobalEnableReport_DataReader & operator = (const HmiGlobalEnableReport_DataReader &);
            };

            class  HmiGlobalEnableReport_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef HmiGlobalEnableReport_DataReaderView_ptr _ptr_type;
                typedef HmiGlobalEnableReport_DataReaderView_var _var_type;

                static HmiGlobalEnableReport_DataReaderView_ptr _duplicate (HmiGlobalEnableReport_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HmiGlobalEnableReport_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static HmiGlobalEnableReport_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HmiGlobalEnableReport_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                HmiGlobalEnableReport_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (HmiGlobalEnableReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (HmiGlobalEnableReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (HmiGlobalEnableReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (HmiGlobalEnableReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (HmiGlobalEnableReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (HmiGlobalEnableReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (HmiGlobalEnableReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (HmiGlobalEnableReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (HmiGlobalEnableReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (HmiGlobalEnableReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (HmiGlobalEnableReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (HmiGlobalEnableReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (HmiGlobalEnableReport_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (HmiGlobalEnableReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const HmiGlobalEnableReport_& instance) = 0;

            protected:
                HmiGlobalEnableReport_DataReaderView () {};
                ~HmiGlobalEnableReport_DataReaderView () {};
            private:
                HmiGlobalEnableReport_DataReaderView (const HmiGlobalEnableReport_DataReaderView &);
                HmiGlobalEnableReport_DataReaderView & operator = (const HmiGlobalEnableReport_DataReaderView &);
            };
        }

    }

}

#endif
