#ifndef _H_9A8069B8CAE62CF7F7078CF4C20885A4_LowVoltageSystemReport__H_
#define _H_9A8069B8CAE62CF7F7078CF4C20885A4_LowVoltageSystemReport__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace raptor_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  LowVoltageSystemReport_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Float dbw_battery_volts_;
                ::DDS::Float vehicle_battery_volts_;
                ::DDS::Float vehicle_battery_current_;
                ::DDS::Float vehicle_alternator_current_;
                ::DDS::Float dcdc_current_;
                ::DDS::Float alternator_current_;
                ::DDS::Boolean aux_inverter_contactor_;
            };

            typedef DDS_DCPSStruct_var<LowVoltageSystemReport_> LowVoltageSystemReport__var;
            typedef DDS_DCPSStruct_out < LowVoltageSystemReport_> LowVoltageSystemReport__out;

        }

    }

}

#endif /* _H_9A8069B8CAE62CF7F7078CF4C20885A4_LowVoltageSystemReport__H_ */
