#ifndef _H_8FCE6EE21CD59528432E9D6E09608209_MiscCmd__H_
#define _H_8FCE6EE21CD59528432E9D6E09608209_MiscCmd__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "raptor_dbw_msgs/msg/dds_opensplice/TurnSignal_.h"
#include "raptor_dbw_msgs/msg/dds_opensplice/DoorRequest_.h"
#include "raptor_dbw_msgs/msg/dds_opensplice/HighBeam_.h"
#include "raptor_dbw_msgs/msg/dds_opensplice/WiperFront_.h"
#include "raptor_dbw_msgs/msg/dds_opensplice/WiperRear_.h"
#include "raptor_dbw_msgs/msg/dds_opensplice/Ignition_.h"
#include "raptor_dbw_msgs/msg/dds_opensplice/DoorLock_.h"
#include "raptor_dbw_msgs/msg/dds_opensplice/LowBeam_.h"


namespace raptor_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  MiscCmd_
            {
                ::raptor_dbw_msgs::msg::dds_::TurnSignal_ cmd_;
                ::raptor_dbw_msgs::msg::dds_::DoorRequest_ door_request_right_rear_;
                ::DDS::Octet rolling_counter_;
                ::raptor_dbw_msgs::msg::dds_::HighBeam_ high_beam_cmd_;
                ::raptor_dbw_msgs::msg::dds_::WiperFront_ front_wiper_cmd_;
                ::raptor_dbw_msgs::msg::dds_::WiperRear_ rear_wiper_cmd_;
                ::raptor_dbw_msgs::msg::dds_::Ignition_ ignition_cmd_;
                ::raptor_dbw_msgs::msg::dds_::DoorRequest_ door_request_left_rear_;
                ::raptor_dbw_msgs::msg::dds_::DoorRequest_ door_request_lift_gate_;
                ::raptor_dbw_msgs::msg::dds_::DoorLock_ door_lock_cmd_;
                ::DDS::Boolean block_standard_cruise_buttons_;
                ::DDS::Boolean block_adaptive_cruise_buttons_;
                ::DDS::Boolean block_turn_signal_stalk_;
                ::DDS::Boolean horn_cmd_;
                ::raptor_dbw_msgs::msg::dds_::LowBeam_ low_beam_cmd_;
            };

            typedef DDS_DCPSStruct_var<MiscCmd_> MiscCmd__var;
            typedef MiscCmd_& MiscCmd__out;

        }

    }

}

#endif /* _H_8FCE6EE21CD59528432E9D6E09608209_MiscCmd__H_ */
