#ifndef _H_A99F9946507D0922F86D5E664F4AA707_OtherActuatorsReport__H_
#define _H_A99F9946507D0922F86D5E664F4AA707_OtherActuatorsReport__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"
#include "raptor_dbw_msgs/msg/dds_opensplice/Ignition_.h"
#include "raptor_dbw_msgs/msg/dds_opensplice/HornState_.h"
#include "raptor_dbw_msgs/msg/dds_opensplice/TurnSignal_.h"
#include "raptor_dbw_msgs/msg/dds_opensplice/HighBeamState_.h"
#include "raptor_dbw_msgs/msg/dds_opensplice/LowBeam_.h"
#include "raptor_dbw_msgs/msg/dds_opensplice/WiperFront_.h"
#include "raptor_dbw_msgs/msg/dds_opensplice/WiperRear_.h"
#include "raptor_dbw_msgs/msg/dds_opensplice/DoorState_.h"
#include "raptor_dbw_msgs/msg/dds_opensplice/DoorLock_.h"


namespace raptor_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  OtherActuatorsReport_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::raptor_dbw_msgs::msg::dds_::Ignition_ ignition_state_;
                ::raptor_dbw_msgs::msg::dds_::HornState_ horn_state_;
                ::raptor_dbw_msgs::msg::dds_::TurnSignal_ turn_signal_state_;
                ::DDS::Boolean turn_signal_sync_;
                ::raptor_dbw_msgs::msg::dds_::HighBeamState_ high_beam_state_;
                ::raptor_dbw_msgs::msg::dds_::LowBeam_ low_beam_state_;
                ::raptor_dbw_msgs::msg::dds_::WiperFront_ front_wiper_state_;
                ::raptor_dbw_msgs::msg::dds_::WiperRear_ rear_wiper_state_;
                ::raptor_dbw_msgs::msg::dds_::DoorState_ right_rear_door_state_;
                ::raptor_dbw_msgs::msg::dds_::DoorState_ left_rear_door_state_;
                ::raptor_dbw_msgs::msg::dds_::DoorState_ liftgate_door_state_;
                ::raptor_dbw_msgs::msg::dds_::DoorLock_ door_lock_state_;
                ::DDS::Octet rolling_counter_;
            };

            typedef DDS_DCPSStruct_var<OtherActuatorsReport_> OtherActuatorsReport__var;
            typedef DDS_DCPSStruct_out < OtherActuatorsReport_> OtherActuatorsReport__out;

        }

    }

}

#endif /* _H_A99F9946507D0922F86D5E664F4AA707_OtherActuatorsReport__H_ */
