#ifndef _H_7910772254A71F9D776F5069ACEF26B6_ParkingBrake_DCPS_H_
#define _H_7910772254A71F9D776F5069ACEF26B6_ParkingBrake_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ParkingBrake_.h"


namespace raptor_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ParkingBrake_TypeSupportInterface;

            typedef ParkingBrake_TypeSupportInterface * ParkingBrake_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ParkingBrake_TypeSupportInterface> ParkingBrake_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ParkingBrake_TypeSupportInterface> ParkingBrake_TypeSupportInterface_out;


            class ParkingBrake_DataWriter;

            typedef ParkingBrake_DataWriter * ParkingBrake_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ParkingBrake_DataWriter> ParkingBrake_DataWriter_var;
            typedef DDS_DCPSInterface_out < ParkingBrake_DataWriter> ParkingBrake_DataWriter_out;


            class ParkingBrake_DataReader;

            typedef ParkingBrake_DataReader * ParkingBrake_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ParkingBrake_DataReader> ParkingBrake_DataReader_var;
            typedef DDS_DCPSInterface_out < ParkingBrake_DataReader> ParkingBrake_DataReader_out;


            class ParkingBrake_DataReaderView;

            typedef ParkingBrake_DataReaderView * ParkingBrake_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ParkingBrake_DataReaderView> ParkingBrake_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ParkingBrake_DataReaderView> ParkingBrake_DataReaderView_out;

            struct ParkingBrake_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < ParkingBrake_, struct ParkingBrake_Seq_uniq_> ParkingBrake_Seq;
            typedef DDS_DCPSSequence_var < ParkingBrake_Seq> ParkingBrake_Seq_var;
            typedef DDS_DCPSSequence_out < ParkingBrake_Seq> ParkingBrake_Seq_out;

            class  ParkingBrake_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ParkingBrake_TypeSupportInterface_ptr _ptr_type;
                typedef ParkingBrake_TypeSupportInterface_var _var_type;

                static ParkingBrake_TypeSupportInterface_ptr _duplicate (ParkingBrake_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ParkingBrake_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ParkingBrake_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ParkingBrake_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ParkingBrake_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ParkingBrake_TypeSupportInterface () {};
                ~ParkingBrake_TypeSupportInterface () {};
            private:
                ParkingBrake_TypeSupportInterface (const ParkingBrake_TypeSupportInterface &);
                ParkingBrake_TypeSupportInterface & operator = (const ParkingBrake_TypeSupportInterface &);
            };

            class  ParkingBrake_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ParkingBrake_DataWriter_ptr _ptr_type;
                typedef ParkingBrake_DataWriter_var _var_type;

                static ParkingBrake_DataWriter_ptr _duplicate (ParkingBrake_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ParkingBrake_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ParkingBrake_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ParkingBrake_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ParkingBrake_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ParkingBrake_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ParkingBrake_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ParkingBrake_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ParkingBrake_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ParkingBrake_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ParkingBrake_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ParkingBrake_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ParkingBrake_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ParkingBrake_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ParkingBrake_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ParkingBrake_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ParkingBrake_& instance_data) = 0;

            protected:
                ParkingBrake_DataWriter () {};
                ~ParkingBrake_DataWriter () {};
            private:
                ParkingBrake_DataWriter (const ParkingBrake_DataWriter &);
                ParkingBrake_DataWriter & operator = (const ParkingBrake_DataWriter &);
            };

            class  ParkingBrake_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ParkingBrake_DataReader_ptr _ptr_type;
                typedef ParkingBrake_DataReader_var _var_type;

                static ParkingBrake_DataReader_ptr _duplicate (ParkingBrake_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ParkingBrake_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ParkingBrake_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ParkingBrake_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ParkingBrake_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ParkingBrake_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ParkingBrake_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ParkingBrake_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ParkingBrake_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ParkingBrake_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ParkingBrake_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ParkingBrake_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ParkingBrake_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ParkingBrake_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ParkingBrake_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ParkingBrake_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ParkingBrake_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ParkingBrake_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ParkingBrake_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ParkingBrake_& instance) = 0;

            protected:
                ParkingBrake_DataReader () {};
                ~ParkingBrake_DataReader () {};
            private:
                ParkingBrake_DataReader (const ParkingBrake_DataReader &);
                ParkingBrake_DataReader & operator = (const ParkingBrake_DataReader &);
            };

            class  ParkingBrake_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ParkingBrake_DataReaderView_ptr _ptr_type;
                typedef ParkingBrake_DataReaderView_var _var_type;

                static ParkingBrake_DataReaderView_ptr _duplicate (ParkingBrake_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ParkingBrake_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ParkingBrake_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ParkingBrake_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ParkingBrake_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ParkingBrake_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ParkingBrake_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ParkingBrake_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ParkingBrake_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ParkingBrake_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ParkingBrake_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ParkingBrake_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ParkingBrake_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ParkingBrake_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ParkingBrake_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ParkingBrake_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ParkingBrake_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ParkingBrake_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ParkingBrake_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ParkingBrake_& instance) = 0;

            protected:
                ParkingBrake_DataReaderView () {};
                ~ParkingBrake_DataReaderView () {};
            private:
                ParkingBrake_DataReaderView (const ParkingBrake_DataReaderView &);
                ParkingBrake_DataReaderView & operator = (const ParkingBrake_DataReaderView &);
            };
        }

    }

}

#endif
