#ifndef _H_2AE857D43BD942A16116D38B3A19D0DD_SonarArcNum_DCPS_H_
#define _H_2AE857D43BD942A16116D38B3A19D0DD_SonarArcNum_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SonarArcNum_.h"


namespace raptor_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class SonarArcNum_TypeSupportInterface;

            typedef SonarArcNum_TypeSupportInterface * SonarArcNum_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SonarArcNum_TypeSupportInterface> SonarArcNum_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SonarArcNum_TypeSupportInterface> SonarArcNum_TypeSupportInterface_out;


            class SonarArcNum_DataWriter;

            typedef SonarArcNum_DataWriter * SonarArcNum_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SonarArcNum_DataWriter> SonarArcNum_DataWriter_var;
            typedef DDS_DCPSInterface_out < SonarArcNum_DataWriter> SonarArcNum_DataWriter_out;


            class SonarArcNum_DataReader;

            typedef SonarArcNum_DataReader * SonarArcNum_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SonarArcNum_DataReader> SonarArcNum_DataReader_var;
            typedef DDS_DCPSInterface_out < SonarArcNum_DataReader> SonarArcNum_DataReader_out;


            class SonarArcNum_DataReaderView;

            typedef SonarArcNum_DataReaderView * SonarArcNum_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SonarArcNum_DataReaderView> SonarArcNum_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SonarArcNum_DataReaderView> SonarArcNum_DataReaderView_out;

            struct SonarArcNum_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < SonarArcNum_, struct SonarArcNum_Seq_uniq_> SonarArcNum_Seq;
            typedef DDS_DCPSSequence_var < SonarArcNum_Seq> SonarArcNum_Seq_var;
            typedef DDS_DCPSSequence_out < SonarArcNum_Seq> SonarArcNum_Seq_out;

            class  SonarArcNum_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SonarArcNum_TypeSupportInterface_ptr _ptr_type;
                typedef SonarArcNum_TypeSupportInterface_var _var_type;

                static SonarArcNum_TypeSupportInterface_ptr _duplicate (SonarArcNum_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SonarArcNum_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SonarArcNum_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SonarArcNum_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SonarArcNum_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SonarArcNum_TypeSupportInterface () {};
                ~SonarArcNum_TypeSupportInterface () {};
            private:
                SonarArcNum_TypeSupportInterface (const SonarArcNum_TypeSupportInterface &);
                SonarArcNum_TypeSupportInterface & operator = (const SonarArcNum_TypeSupportInterface &);
            };

            class  SonarArcNum_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SonarArcNum_DataWriter_ptr _ptr_type;
                typedef SonarArcNum_DataWriter_var _var_type;

                static SonarArcNum_DataWriter_ptr _duplicate (SonarArcNum_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SonarArcNum_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SonarArcNum_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SonarArcNum_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SonarArcNum_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SonarArcNum_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SonarArcNum_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SonarArcNum_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SonarArcNum_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SonarArcNum_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SonarArcNum_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SonarArcNum_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SonarArcNum_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SonarArcNum_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SonarArcNum_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SonarArcNum_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SonarArcNum_& instance_data) = 0;

            protected:
                SonarArcNum_DataWriter () {};
                ~SonarArcNum_DataWriter () {};
            private:
                SonarArcNum_DataWriter (const SonarArcNum_DataWriter &);
                SonarArcNum_DataWriter & operator = (const SonarArcNum_DataWriter &);
            };

            class  SonarArcNum_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SonarArcNum_DataReader_ptr _ptr_type;
                typedef SonarArcNum_DataReader_var _var_type;

                static SonarArcNum_DataReader_ptr _duplicate (SonarArcNum_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SonarArcNum_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SonarArcNum_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SonarArcNum_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SonarArcNum_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SonarArcNum_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SonarArcNum_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SonarArcNum_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SonarArcNum_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SonarArcNum_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SonarArcNum_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SonarArcNum_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SonarArcNum_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SonarArcNum_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SonarArcNum_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SonarArcNum_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SonarArcNum_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SonarArcNum_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SonarArcNum_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SonarArcNum_& instance) = 0;

            protected:
                SonarArcNum_DataReader () {};
                ~SonarArcNum_DataReader () {};
            private:
                SonarArcNum_DataReader (const SonarArcNum_DataReader &);
                SonarArcNum_DataReader & operator = (const SonarArcNum_DataReader &);
            };

            class  SonarArcNum_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SonarArcNum_DataReaderView_ptr _ptr_type;
                typedef SonarArcNum_DataReaderView_var _var_type;

                static SonarArcNum_DataReaderView_ptr _duplicate (SonarArcNum_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SonarArcNum_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SonarArcNum_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SonarArcNum_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SonarArcNum_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SonarArcNum_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SonarArcNum_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SonarArcNum_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SonarArcNum_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SonarArcNum_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SonarArcNum_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SonarArcNum_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SonarArcNum_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SonarArcNum_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SonarArcNum_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SonarArcNum_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SonarArcNum_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SonarArcNum_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SonarArcNum_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SonarArcNum_& instance) = 0;

            protected:
                SonarArcNum_DataReaderView () {};
                ~SonarArcNum_DataReaderView () {};
            private:
                SonarArcNum_DataReaderView (const SonarArcNum_DataReaderView &);
                SonarArcNum_DataReaderView & operator = (const SonarArcNum_DataReaderView &);
            };
        }

    }

}

#endif
