#ifndef _H_89F1B5171B91E5F3683B0F56B09B7F7C_Steering2Report_DCPS_H_
#define _H_89F1B5171B91E5F3683B0F56B09B7F7C_Steering2Report_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Steering2Report_.h"


namespace raptor_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class Steering2Report_TypeSupportInterface;

            typedef Steering2Report_TypeSupportInterface * Steering2Report_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Steering2Report_TypeSupportInterface> Steering2Report_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Steering2Report_TypeSupportInterface> Steering2Report_TypeSupportInterface_out;


            class Steering2Report_DataWriter;

            typedef Steering2Report_DataWriter * Steering2Report_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Steering2Report_DataWriter> Steering2Report_DataWriter_var;
            typedef DDS_DCPSInterface_out < Steering2Report_DataWriter> Steering2Report_DataWriter_out;


            class Steering2Report_DataReader;

            typedef Steering2Report_DataReader * Steering2Report_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Steering2Report_DataReader> Steering2Report_DataReader_var;
            typedef DDS_DCPSInterface_out < Steering2Report_DataReader> Steering2Report_DataReader_out;


            class Steering2Report_DataReaderView;

            typedef Steering2Report_DataReaderView * Steering2Report_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Steering2Report_DataReaderView> Steering2Report_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Steering2Report_DataReaderView> Steering2Report_DataReaderView_out;

            struct Steering2Report_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Steering2Report_, struct Steering2Report_Seq_uniq_> Steering2Report_Seq;
            typedef DDS_DCPSSequence_var < Steering2Report_Seq> Steering2Report_Seq_var;
            typedef DDS_DCPSSequence_out < Steering2Report_Seq> Steering2Report_Seq_out;

            class  Steering2Report_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Steering2Report_TypeSupportInterface_ptr _ptr_type;
                typedef Steering2Report_TypeSupportInterface_var _var_type;

                static Steering2Report_TypeSupportInterface_ptr _duplicate (Steering2Report_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Steering2Report_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Steering2Report_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Steering2Report_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Steering2Report_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Steering2Report_TypeSupportInterface () {};
                ~Steering2Report_TypeSupportInterface () {};
            private:
                Steering2Report_TypeSupportInterface (const Steering2Report_TypeSupportInterface &);
                Steering2Report_TypeSupportInterface & operator = (const Steering2Report_TypeSupportInterface &);
            };

            class  Steering2Report_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Steering2Report_DataWriter_ptr _ptr_type;
                typedef Steering2Report_DataWriter_var _var_type;

                static Steering2Report_DataWriter_ptr _duplicate (Steering2Report_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Steering2Report_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Steering2Report_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Steering2Report_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Steering2Report_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Steering2Report_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Steering2Report_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Steering2Report_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Steering2Report_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Steering2Report_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Steering2Report_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Steering2Report_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Steering2Report_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Steering2Report_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Steering2Report_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Steering2Report_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Steering2Report_& instance_data) = 0;

            protected:
                Steering2Report_DataWriter () {};
                ~Steering2Report_DataWriter () {};
            private:
                Steering2Report_DataWriter (const Steering2Report_DataWriter &);
                Steering2Report_DataWriter & operator = (const Steering2Report_DataWriter &);
            };

            class  Steering2Report_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Steering2Report_DataReader_ptr _ptr_type;
                typedef Steering2Report_DataReader_var _var_type;

                static Steering2Report_DataReader_ptr _duplicate (Steering2Report_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Steering2Report_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Steering2Report_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Steering2Report_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Steering2Report_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Steering2Report_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Steering2Report_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Steering2Report_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Steering2Report_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Steering2Report_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Steering2Report_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Steering2Report_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Steering2Report_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Steering2Report_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Steering2Report_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Steering2Report_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Steering2Report_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Steering2Report_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Steering2Report_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Steering2Report_& instance) = 0;

            protected:
                Steering2Report_DataReader () {};
                ~Steering2Report_DataReader () {};
            private:
                Steering2Report_DataReader (const Steering2Report_DataReader &);
                Steering2Report_DataReader & operator = (const Steering2Report_DataReader &);
            };

            class  Steering2Report_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Steering2Report_DataReaderView_ptr _ptr_type;
                typedef Steering2Report_DataReaderView_var _var_type;

                static Steering2Report_DataReaderView_ptr _duplicate (Steering2Report_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Steering2Report_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Steering2Report_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Steering2Report_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Steering2Report_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Steering2Report_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Steering2Report_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Steering2Report_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Steering2Report_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Steering2Report_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Steering2Report_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Steering2Report_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Steering2Report_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Steering2Report_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Steering2Report_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Steering2Report_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Steering2Report_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Steering2Report_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Steering2Report_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Steering2Report_& instance) = 0;

            protected:
                Steering2Report_DataReaderView () {};
                ~Steering2Report_DataReaderView () {};
            private:
                Steering2Report_DataReaderView (const Steering2Report_DataReaderView &);
                Steering2Report_DataReaderView & operator = (const Steering2Report_DataReaderView &);
            };
        }

    }

}

#endif
