#ifndef _H_62EF939043A1192BF0244982F275F495_SteeringCmd__H_
#define _H_62EF939043A1192BF0244982F275F495_SteeringCmd__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "raptor_dbw_msgs/msg/dds_opensplice/ActuatorControlMode_.h"


namespace raptor_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  SteeringCmd_
            {
                ::DDS::Float angle_cmd_;
                ::DDS::Float angle_velocity_;
                ::DDS::Boolean enable_;
                ::DDS::Boolean ignore_;
                ::DDS::Octet rolling_counter_;
                ::DDS::Float torque_cmd_;
                ::DDS::Float vehicle_curvature_cmd_;
                ::raptor_dbw_msgs::msg::dds_::ActuatorControlMode_ control_type_;
            };

            typedef DDS_DCPSStruct_var<SteeringCmd_> SteeringCmd__var;
            typedef SteeringCmd_& SteeringCmd__out;

        }

    }

}

#endif /* _H_62EF939043A1192BF0244982F275F495_SteeringCmd__H_ */
