#ifndef _H_1E4E9D6B506B26DC80967F294F288A85_SteeringReport__H_
#define _H_1E4E9D6B506B26DC80967F294F288A85_SteeringReport__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"
#include "raptor_dbw_msgs/msg/dds_opensplice/ActuatorControlMode_.h"


namespace raptor_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  SteeringReport_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Float steering_wheel_angle_;
                ::DDS::Float steering_wheel_angle_cmd_;
                ::DDS::Float steering_wheel_torque_;
                ::DDS::Boolean enabled_;
                ::DDS::Boolean driver_activity_;
                ::DDS::Boolean fault_steering_system_;
                ::DDS::Boolean overheat_prevention_mode_;
                ::DDS::Octet rolling_counter_;
                ::raptor_dbw_msgs::msg::dds_::ActuatorControlMode_ control_type_;
                ::DDS::Boolean steering_overheat_warning_;
            };

            typedef DDS_DCPSStruct_var<SteeringReport_> SteeringReport__var;
            typedef DDS_DCPSStruct_out < SteeringReport_> SteeringReport__out;

        }

    }

}

#endif /* _H_1E4E9D6B506B26DC80967F294F288A85_SteeringReport__H_ */
