#ifndef _H_1E4E9D6B506B26DC80967F294F288A85_SteeringReport_DCPS_H_
#define _H_1E4E9D6B506B26DC80967F294F288A85_SteeringReport_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SteeringReport_.h"


namespace raptor_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class SteeringReport_TypeSupportInterface;

            typedef SteeringReport_TypeSupportInterface * SteeringReport_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SteeringReport_TypeSupportInterface> SteeringReport_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SteeringReport_TypeSupportInterface> SteeringReport_TypeSupportInterface_out;


            class SteeringReport_DataWriter;

            typedef SteeringReport_DataWriter * SteeringReport_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SteeringReport_DataWriter> SteeringReport_DataWriter_var;
            typedef DDS_DCPSInterface_out < SteeringReport_DataWriter> SteeringReport_DataWriter_out;


            class SteeringReport_DataReader;

            typedef SteeringReport_DataReader * SteeringReport_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SteeringReport_DataReader> SteeringReport_DataReader_var;
            typedef DDS_DCPSInterface_out < SteeringReport_DataReader> SteeringReport_DataReader_out;


            class SteeringReport_DataReaderView;

            typedef SteeringReport_DataReaderView * SteeringReport_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SteeringReport_DataReaderView> SteeringReport_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SteeringReport_DataReaderView> SteeringReport_DataReaderView_out;

            struct SteeringReport_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SteeringReport_, struct SteeringReport_Seq_uniq_> SteeringReport_Seq;
            typedef DDS_DCPSSequence_var < SteeringReport_Seq> SteeringReport_Seq_var;
            typedef DDS_DCPSSequence_out < SteeringReport_Seq> SteeringReport_Seq_out;

            class  SteeringReport_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SteeringReport_TypeSupportInterface_ptr _ptr_type;
                typedef SteeringReport_TypeSupportInterface_var _var_type;

                static SteeringReport_TypeSupportInterface_ptr _duplicate (SteeringReport_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SteeringReport_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SteeringReport_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SteeringReport_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SteeringReport_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SteeringReport_TypeSupportInterface () {};
                ~SteeringReport_TypeSupportInterface () {};
            private:
                SteeringReport_TypeSupportInterface (const SteeringReport_TypeSupportInterface &);
                SteeringReport_TypeSupportInterface & operator = (const SteeringReport_TypeSupportInterface &);
            };

            class  SteeringReport_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SteeringReport_DataWriter_ptr _ptr_type;
                typedef SteeringReport_DataWriter_var _var_type;

                static SteeringReport_DataWriter_ptr _duplicate (SteeringReport_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SteeringReport_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SteeringReport_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SteeringReport_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SteeringReport_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SteeringReport_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SteeringReport_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SteeringReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SteeringReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SteeringReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SteeringReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SteeringReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SteeringReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SteeringReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SteeringReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SteeringReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SteeringReport_& instance_data) = 0;

            protected:
                SteeringReport_DataWriter () {};
                ~SteeringReport_DataWriter () {};
            private:
                SteeringReport_DataWriter (const SteeringReport_DataWriter &);
                SteeringReport_DataWriter & operator = (const SteeringReport_DataWriter &);
            };

            class  SteeringReport_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SteeringReport_DataReader_ptr _ptr_type;
                typedef SteeringReport_DataReader_var _var_type;

                static SteeringReport_DataReader_ptr _duplicate (SteeringReport_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SteeringReport_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SteeringReport_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SteeringReport_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SteeringReport_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SteeringReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SteeringReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SteeringReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SteeringReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SteeringReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SteeringReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SteeringReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SteeringReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SteeringReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SteeringReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SteeringReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SteeringReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SteeringReport_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SteeringReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SteeringReport_& instance) = 0;

            protected:
                SteeringReport_DataReader () {};
                ~SteeringReport_DataReader () {};
            private:
                SteeringReport_DataReader (const SteeringReport_DataReader &);
                SteeringReport_DataReader & operator = (const SteeringReport_DataReader &);
            };

            class  SteeringReport_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SteeringReport_DataReaderView_ptr _ptr_type;
                typedef SteeringReport_DataReaderView_var _var_type;

                static SteeringReport_DataReaderView_ptr _duplicate (SteeringReport_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SteeringReport_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SteeringReport_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SteeringReport_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SteeringReport_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SteeringReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SteeringReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SteeringReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SteeringReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SteeringReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SteeringReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SteeringReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SteeringReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SteeringReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SteeringReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SteeringReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SteeringReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SteeringReport_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SteeringReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SteeringReport_& instance) = 0;

            protected:
                SteeringReport_DataReaderView () {};
                ~SteeringReport_DataReaderView () {};
            private:
                SteeringReport_DataReaderView (const SteeringReport_DataReaderView &);
                SteeringReport_DataReaderView & operator = (const SteeringReport_DataReaderView &);
            };
        }

    }

}

#endif
