#ifndef _H_CC55B9808B7A630AC32816223829AD1F_SurroundReport__H_
#define _H_CC55B9808B7A630AC32816223829AD1F_SurroundReport__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"
#include "raptor_dbw_msgs/msg/dds_opensplice/SonarArcNum_.h"


namespace raptor_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  SurroundReport_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Float front_radar_object_distance_;
                ::DDS::Float rear_radar_object_distance_;
                ::raptor_dbw_msgs::msg::dds_::SonarArcNum_ rear_right_;
                ::raptor_dbw_msgs::msg::dds_::SonarArcNum_ rear_left_;
                ::raptor_dbw_msgs::msg::dds_::SonarArcNum_ rear_center_;
                ::raptor_dbw_msgs::msg::dds_::SonarArcNum_ front_right_;
                ::raptor_dbw_msgs::msg::dds_::SonarArcNum_ front_left_;
                ::raptor_dbw_msgs::msg::dds_::SonarArcNum_ front_center_;
                ::DDS::Boolean front_radar_distance_valid_;
                ::DDS::Boolean parking_sonar_data_valid_;
            };

            typedef DDS_DCPSStruct_var<SurroundReport_> SurroundReport__var;
            typedef DDS_DCPSStruct_out < SurroundReport_> SurroundReport__out;

        }

    }

}

#endif /* _H_CC55B9808B7A630AC32816223829AD1F_SurroundReport__H_ */
