#ifndef _H_CC55B9808B7A630AC32816223829AD1F_SurroundReport_DCPS_H_
#define _H_CC55B9808B7A630AC32816223829AD1F_SurroundReport_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SurroundReport_.h"


namespace raptor_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class SurroundReport_TypeSupportInterface;

            typedef SurroundReport_TypeSupportInterface * SurroundReport_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SurroundReport_TypeSupportInterface> SurroundReport_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SurroundReport_TypeSupportInterface> SurroundReport_TypeSupportInterface_out;


            class SurroundReport_DataWriter;

            typedef SurroundReport_DataWriter * SurroundReport_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SurroundReport_DataWriter> SurroundReport_DataWriter_var;
            typedef DDS_DCPSInterface_out < SurroundReport_DataWriter> SurroundReport_DataWriter_out;


            class SurroundReport_DataReader;

            typedef SurroundReport_DataReader * SurroundReport_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SurroundReport_DataReader> SurroundReport_DataReader_var;
            typedef DDS_DCPSInterface_out < SurroundReport_DataReader> SurroundReport_DataReader_out;


            class SurroundReport_DataReaderView;

            typedef SurroundReport_DataReaderView * SurroundReport_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SurroundReport_DataReaderView> SurroundReport_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SurroundReport_DataReaderView> SurroundReport_DataReaderView_out;

            struct SurroundReport_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SurroundReport_, struct SurroundReport_Seq_uniq_> SurroundReport_Seq;
            typedef DDS_DCPSSequence_var < SurroundReport_Seq> SurroundReport_Seq_var;
            typedef DDS_DCPSSequence_out < SurroundReport_Seq> SurroundReport_Seq_out;

            class  SurroundReport_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SurroundReport_TypeSupportInterface_ptr _ptr_type;
                typedef SurroundReport_TypeSupportInterface_var _var_type;

                static SurroundReport_TypeSupportInterface_ptr _duplicate (SurroundReport_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SurroundReport_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SurroundReport_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SurroundReport_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SurroundReport_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SurroundReport_TypeSupportInterface () {};
                ~SurroundReport_TypeSupportInterface () {};
            private:
                SurroundReport_TypeSupportInterface (const SurroundReport_TypeSupportInterface &);
                SurroundReport_TypeSupportInterface & operator = (const SurroundReport_TypeSupportInterface &);
            };

            class  SurroundReport_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SurroundReport_DataWriter_ptr _ptr_type;
                typedef SurroundReport_DataWriter_var _var_type;

                static SurroundReport_DataWriter_ptr _duplicate (SurroundReport_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SurroundReport_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SurroundReport_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SurroundReport_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SurroundReport_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SurroundReport_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SurroundReport_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SurroundReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SurroundReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SurroundReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SurroundReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SurroundReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SurroundReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SurroundReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SurroundReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SurroundReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SurroundReport_& instance_data) = 0;

            protected:
                SurroundReport_DataWriter () {};
                ~SurroundReport_DataWriter () {};
            private:
                SurroundReport_DataWriter (const SurroundReport_DataWriter &);
                SurroundReport_DataWriter & operator = (const SurroundReport_DataWriter &);
            };

            class  SurroundReport_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SurroundReport_DataReader_ptr _ptr_type;
                typedef SurroundReport_DataReader_var _var_type;

                static SurroundReport_DataReader_ptr _duplicate (SurroundReport_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SurroundReport_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SurroundReport_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SurroundReport_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SurroundReport_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SurroundReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SurroundReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SurroundReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SurroundReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SurroundReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SurroundReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SurroundReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SurroundReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SurroundReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SurroundReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SurroundReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SurroundReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SurroundReport_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SurroundReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SurroundReport_& instance) = 0;

            protected:
                SurroundReport_DataReader () {};
                ~SurroundReport_DataReader () {};
            private:
                SurroundReport_DataReader (const SurroundReport_DataReader &);
                SurroundReport_DataReader & operator = (const SurroundReport_DataReader &);
            };

            class  SurroundReport_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SurroundReport_DataReaderView_ptr _ptr_type;
                typedef SurroundReport_DataReaderView_var _var_type;

                static SurroundReport_DataReaderView_ptr _duplicate (SurroundReport_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SurroundReport_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SurroundReport_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SurroundReport_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SurroundReport_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SurroundReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SurroundReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SurroundReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SurroundReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SurroundReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SurroundReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SurroundReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SurroundReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SurroundReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SurroundReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SurroundReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SurroundReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SurroundReport_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SurroundReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SurroundReport_& instance) = 0;

            protected:
                SurroundReport_DataReaderView () {};
                ~SurroundReport_DataReaderView () {};
            private:
                SurroundReport_DataReaderView (const SurroundReport_DataReaderView &);
                SurroundReport_DataReaderView & operator = (const SurroundReport_DataReaderView &);
            };
        }

    }

}

#endif
