#ifndef _H_08CC7E31FF0F6854F57BDA030325E5C0_TirePressureReport_DCPS_H_
#define _H_08CC7E31FF0F6854F57BDA030325E5C0_TirePressureReport_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "TirePressureReport_.h"


namespace raptor_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class TirePressureReport_TypeSupportInterface;

            typedef TirePressureReport_TypeSupportInterface * TirePressureReport_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < TirePressureReport_TypeSupportInterface> TirePressureReport_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < TirePressureReport_TypeSupportInterface> TirePressureReport_TypeSupportInterface_out;


            class TirePressureReport_DataWriter;

            typedef TirePressureReport_DataWriter * TirePressureReport_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < TirePressureReport_DataWriter> TirePressureReport_DataWriter_var;
            typedef DDS_DCPSInterface_out < TirePressureReport_DataWriter> TirePressureReport_DataWriter_out;


            class TirePressureReport_DataReader;

            typedef TirePressureReport_DataReader * TirePressureReport_DataReader_ptr;
            typedef DDS_DCPSInterface_var < TirePressureReport_DataReader> TirePressureReport_DataReader_var;
            typedef DDS_DCPSInterface_out < TirePressureReport_DataReader> TirePressureReport_DataReader_out;


            class TirePressureReport_DataReaderView;

            typedef TirePressureReport_DataReaderView * TirePressureReport_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < TirePressureReport_DataReaderView> TirePressureReport_DataReaderView_var;
            typedef DDS_DCPSInterface_out < TirePressureReport_DataReaderView> TirePressureReport_DataReaderView_out;

            struct TirePressureReport_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < TirePressureReport_, struct TirePressureReport_Seq_uniq_> TirePressureReport_Seq;
            typedef DDS_DCPSSequence_var < TirePressureReport_Seq> TirePressureReport_Seq_var;
            typedef DDS_DCPSSequence_out < TirePressureReport_Seq> TirePressureReport_Seq_out;

            class  TirePressureReport_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef TirePressureReport_TypeSupportInterface_ptr _ptr_type;
                typedef TirePressureReport_TypeSupportInterface_var _var_type;

                static TirePressureReport_TypeSupportInterface_ptr _duplicate (TirePressureReport_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TirePressureReport_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static TirePressureReport_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TirePressureReport_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                TirePressureReport_TypeSupportInterface_ptr _this () { return this; }


            protected:
                TirePressureReport_TypeSupportInterface () {};
                ~TirePressureReport_TypeSupportInterface () {};
            private:
                TirePressureReport_TypeSupportInterface (const TirePressureReport_TypeSupportInterface &);
                TirePressureReport_TypeSupportInterface & operator = (const TirePressureReport_TypeSupportInterface &);
            };

            class  TirePressureReport_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef TirePressureReport_DataWriter_ptr _ptr_type;
                typedef TirePressureReport_DataWriter_var _var_type;

                static TirePressureReport_DataWriter_ptr _duplicate (TirePressureReport_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TirePressureReport_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static TirePressureReport_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TirePressureReport_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                TirePressureReport_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const TirePressureReport_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const TirePressureReport_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const TirePressureReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const TirePressureReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const TirePressureReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const TirePressureReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const TirePressureReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const TirePressureReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const TirePressureReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const TirePressureReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (TirePressureReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TirePressureReport_& instance_data) = 0;

            protected:
                TirePressureReport_DataWriter () {};
                ~TirePressureReport_DataWriter () {};
            private:
                TirePressureReport_DataWriter (const TirePressureReport_DataWriter &);
                TirePressureReport_DataWriter & operator = (const TirePressureReport_DataWriter &);
            };

            class  TirePressureReport_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef TirePressureReport_DataReader_ptr _ptr_type;
                typedef TirePressureReport_DataReader_var _var_type;

                static TirePressureReport_DataReader_ptr _duplicate (TirePressureReport_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TirePressureReport_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static TirePressureReport_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TirePressureReport_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                TirePressureReport_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (TirePressureReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TirePressureReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TirePressureReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TirePressureReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TirePressureReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TirePressureReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TirePressureReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TirePressureReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TirePressureReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TirePressureReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TirePressureReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TirePressureReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TirePressureReport_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TirePressureReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TirePressureReport_& instance) = 0;

            protected:
                TirePressureReport_DataReader () {};
                ~TirePressureReport_DataReader () {};
            private:
                TirePressureReport_DataReader (const TirePressureReport_DataReader &);
                TirePressureReport_DataReader & operator = (const TirePressureReport_DataReader &);
            };

            class  TirePressureReport_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef TirePressureReport_DataReaderView_ptr _ptr_type;
                typedef TirePressureReport_DataReaderView_var _var_type;

                static TirePressureReport_DataReaderView_ptr _duplicate (TirePressureReport_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TirePressureReport_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static TirePressureReport_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TirePressureReport_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                TirePressureReport_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (TirePressureReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TirePressureReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TirePressureReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TirePressureReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TirePressureReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TirePressureReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TirePressureReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TirePressureReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TirePressureReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TirePressureReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TirePressureReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TirePressureReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TirePressureReport_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TirePressureReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TirePressureReport_& instance) = 0;

            protected:
                TirePressureReport_DataReaderView () {};
                ~TirePressureReport_DataReaderView () {};
            private:
                TirePressureReport_DataReaderView (const TirePressureReport_DataReaderView &);
                TirePressureReport_DataReaderView & operator = (const TirePressureReport_DataReaderView &);
            };
        }

    }

}

#endif
