#ifndef _H_AE391205615E9D09093DBF387EA88FE9_TurnSignal_DCPS_H_
#define _H_AE391205615E9D09093DBF387EA88FE9_TurnSignal_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "TurnSignal_.h"


namespace raptor_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class TurnSignal_TypeSupportInterface;

            typedef TurnSignal_TypeSupportInterface * TurnSignal_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < TurnSignal_TypeSupportInterface> TurnSignal_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < TurnSignal_TypeSupportInterface> TurnSignal_TypeSupportInterface_out;


            class TurnSignal_DataWriter;

            typedef TurnSignal_DataWriter * TurnSignal_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < TurnSignal_DataWriter> TurnSignal_DataWriter_var;
            typedef DDS_DCPSInterface_out < TurnSignal_DataWriter> TurnSignal_DataWriter_out;


            class TurnSignal_DataReader;

            typedef TurnSignal_DataReader * TurnSignal_DataReader_ptr;
            typedef DDS_DCPSInterface_var < TurnSignal_DataReader> TurnSignal_DataReader_var;
            typedef DDS_DCPSInterface_out < TurnSignal_DataReader> TurnSignal_DataReader_out;


            class TurnSignal_DataReaderView;

            typedef TurnSignal_DataReaderView * TurnSignal_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < TurnSignal_DataReaderView> TurnSignal_DataReaderView_var;
            typedef DDS_DCPSInterface_out < TurnSignal_DataReaderView> TurnSignal_DataReaderView_out;

            struct TurnSignal_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < TurnSignal_, struct TurnSignal_Seq_uniq_> TurnSignal_Seq;
            typedef DDS_DCPSSequence_var < TurnSignal_Seq> TurnSignal_Seq_var;
            typedef DDS_DCPSSequence_out < TurnSignal_Seq> TurnSignal_Seq_out;

            class  TurnSignal_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef TurnSignal_TypeSupportInterface_ptr _ptr_type;
                typedef TurnSignal_TypeSupportInterface_var _var_type;

                static TurnSignal_TypeSupportInterface_ptr _duplicate (TurnSignal_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TurnSignal_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static TurnSignal_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TurnSignal_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                TurnSignal_TypeSupportInterface_ptr _this () { return this; }


            protected:
                TurnSignal_TypeSupportInterface () {};
                ~TurnSignal_TypeSupportInterface () {};
            private:
                TurnSignal_TypeSupportInterface (const TurnSignal_TypeSupportInterface &);
                TurnSignal_TypeSupportInterface & operator = (const TurnSignal_TypeSupportInterface &);
            };

            class  TurnSignal_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef TurnSignal_DataWriter_ptr _ptr_type;
                typedef TurnSignal_DataWriter_var _var_type;

                static TurnSignal_DataWriter_ptr _duplicate (TurnSignal_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TurnSignal_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static TurnSignal_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TurnSignal_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                TurnSignal_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const TurnSignal_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const TurnSignal_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const TurnSignal_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const TurnSignal_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const TurnSignal_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const TurnSignal_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const TurnSignal_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const TurnSignal_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const TurnSignal_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const TurnSignal_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (TurnSignal_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TurnSignal_& instance_data) = 0;

            protected:
                TurnSignal_DataWriter () {};
                ~TurnSignal_DataWriter () {};
            private:
                TurnSignal_DataWriter (const TurnSignal_DataWriter &);
                TurnSignal_DataWriter & operator = (const TurnSignal_DataWriter &);
            };

            class  TurnSignal_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef TurnSignal_DataReader_ptr _ptr_type;
                typedef TurnSignal_DataReader_var _var_type;

                static TurnSignal_DataReader_ptr _duplicate (TurnSignal_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TurnSignal_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static TurnSignal_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TurnSignal_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                TurnSignal_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (TurnSignal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TurnSignal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TurnSignal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TurnSignal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TurnSignal_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TurnSignal_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TurnSignal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TurnSignal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TurnSignal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TurnSignal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TurnSignal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TurnSignal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TurnSignal_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TurnSignal_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TurnSignal_& instance) = 0;

            protected:
                TurnSignal_DataReader () {};
                ~TurnSignal_DataReader () {};
            private:
                TurnSignal_DataReader (const TurnSignal_DataReader &);
                TurnSignal_DataReader & operator = (const TurnSignal_DataReader &);
            };

            class  TurnSignal_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef TurnSignal_DataReaderView_ptr _ptr_type;
                typedef TurnSignal_DataReaderView_var _var_type;

                static TurnSignal_DataReaderView_ptr _duplicate (TurnSignal_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TurnSignal_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static TurnSignal_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TurnSignal_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                TurnSignal_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (TurnSignal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TurnSignal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TurnSignal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TurnSignal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TurnSignal_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TurnSignal_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TurnSignal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TurnSignal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TurnSignal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TurnSignal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TurnSignal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TurnSignal_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TurnSignal_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TurnSignal_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TurnSignal_& instance) = 0;

            protected:
                TurnSignal_DataReaderView () {};
                ~TurnSignal_DataReaderView () {};
            private:
                TurnSignal_DataReaderView (const TurnSignal_DataReaderView &);
                TurnSignal_DataReaderView & operator = (const TurnSignal_DataReaderView &);
            };
        }

    }

}

#endif
