#ifndef _H_07148FA347790FD41F6056080CA4CE51_WheelSpeedReport_DCPS_H_
#define _H_07148FA347790FD41F6056080CA4CE51_WheelSpeedReport_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "WheelSpeedReport_.h"


namespace raptor_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class WheelSpeedReport_TypeSupportInterface;

            typedef WheelSpeedReport_TypeSupportInterface * WheelSpeedReport_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < WheelSpeedReport_TypeSupportInterface> WheelSpeedReport_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < WheelSpeedReport_TypeSupportInterface> WheelSpeedReport_TypeSupportInterface_out;


            class WheelSpeedReport_DataWriter;

            typedef WheelSpeedReport_DataWriter * WheelSpeedReport_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < WheelSpeedReport_DataWriter> WheelSpeedReport_DataWriter_var;
            typedef DDS_DCPSInterface_out < WheelSpeedReport_DataWriter> WheelSpeedReport_DataWriter_out;


            class WheelSpeedReport_DataReader;

            typedef WheelSpeedReport_DataReader * WheelSpeedReport_DataReader_ptr;
            typedef DDS_DCPSInterface_var < WheelSpeedReport_DataReader> WheelSpeedReport_DataReader_var;
            typedef DDS_DCPSInterface_out < WheelSpeedReport_DataReader> WheelSpeedReport_DataReader_out;


            class WheelSpeedReport_DataReaderView;

            typedef WheelSpeedReport_DataReaderView * WheelSpeedReport_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < WheelSpeedReport_DataReaderView> WheelSpeedReport_DataReaderView_var;
            typedef DDS_DCPSInterface_out < WheelSpeedReport_DataReaderView> WheelSpeedReport_DataReaderView_out;

            struct WheelSpeedReport_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < WheelSpeedReport_, struct WheelSpeedReport_Seq_uniq_> WheelSpeedReport_Seq;
            typedef DDS_DCPSSequence_var < WheelSpeedReport_Seq> WheelSpeedReport_Seq_var;
            typedef DDS_DCPSSequence_out < WheelSpeedReport_Seq> WheelSpeedReport_Seq_out;

            class  WheelSpeedReport_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef WheelSpeedReport_TypeSupportInterface_ptr _ptr_type;
                typedef WheelSpeedReport_TypeSupportInterface_var _var_type;

                static WheelSpeedReport_TypeSupportInterface_ptr _duplicate (WheelSpeedReport_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static WheelSpeedReport_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static WheelSpeedReport_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static WheelSpeedReport_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                WheelSpeedReport_TypeSupportInterface_ptr _this () { return this; }


            protected:
                WheelSpeedReport_TypeSupportInterface () {};
                ~WheelSpeedReport_TypeSupportInterface () {};
            private:
                WheelSpeedReport_TypeSupportInterface (const WheelSpeedReport_TypeSupportInterface &);
                WheelSpeedReport_TypeSupportInterface & operator = (const WheelSpeedReport_TypeSupportInterface &);
            };

            class  WheelSpeedReport_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef WheelSpeedReport_DataWriter_ptr _ptr_type;
                typedef WheelSpeedReport_DataWriter_var _var_type;

                static WheelSpeedReport_DataWriter_ptr _duplicate (WheelSpeedReport_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static WheelSpeedReport_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static WheelSpeedReport_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static WheelSpeedReport_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                WheelSpeedReport_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const WheelSpeedReport_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const WheelSpeedReport_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const WheelSpeedReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const WheelSpeedReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const WheelSpeedReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const WheelSpeedReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const WheelSpeedReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const WheelSpeedReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const WheelSpeedReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const WheelSpeedReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (WheelSpeedReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const WheelSpeedReport_& instance_data) = 0;

            protected:
                WheelSpeedReport_DataWriter () {};
                ~WheelSpeedReport_DataWriter () {};
            private:
                WheelSpeedReport_DataWriter (const WheelSpeedReport_DataWriter &);
                WheelSpeedReport_DataWriter & operator = (const WheelSpeedReport_DataWriter &);
            };

            class  WheelSpeedReport_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef WheelSpeedReport_DataReader_ptr _ptr_type;
                typedef WheelSpeedReport_DataReader_var _var_type;

                static WheelSpeedReport_DataReader_ptr _duplicate (WheelSpeedReport_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static WheelSpeedReport_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static WheelSpeedReport_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static WheelSpeedReport_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                WheelSpeedReport_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (WheelSpeedReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (WheelSpeedReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (WheelSpeedReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (WheelSpeedReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (WheelSpeedReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (WheelSpeedReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (WheelSpeedReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (WheelSpeedReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (WheelSpeedReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (WheelSpeedReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (WheelSpeedReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (WheelSpeedReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (WheelSpeedReport_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (WheelSpeedReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const WheelSpeedReport_& instance) = 0;

            protected:
                WheelSpeedReport_DataReader () {};
                ~WheelSpeedReport_DataReader () {};
            private:
                WheelSpeedReport_DataReader (const WheelSpeedReport_DataReader &);
                WheelSpeedReport_DataReader & operator = (const WheelSpeedReport_DataReader &);
            };

            class  WheelSpeedReport_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef WheelSpeedReport_DataReaderView_ptr _ptr_type;
                typedef WheelSpeedReport_DataReaderView_var _var_type;

                static WheelSpeedReport_DataReaderView_ptr _duplicate (WheelSpeedReport_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static WheelSpeedReport_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static WheelSpeedReport_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static WheelSpeedReport_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                WheelSpeedReport_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (WheelSpeedReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (WheelSpeedReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (WheelSpeedReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (WheelSpeedReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (WheelSpeedReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (WheelSpeedReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (WheelSpeedReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (WheelSpeedReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (WheelSpeedReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (WheelSpeedReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (WheelSpeedReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (WheelSpeedReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (WheelSpeedReport_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (WheelSpeedReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const WheelSpeedReport_& instance) = 0;

            protected:
                WheelSpeedReport_DataReaderView () {};
                ~WheelSpeedReport_DataReaderView () {};
            private:
                WheelSpeedReport_DataReaderView (const WheelSpeedReport_DataReaderView &);
                WheelSpeedReport_DataReaderView & operator = (const WheelSpeedReport_DataReaderView &);
            };
        }

    }

}

#endif
