#ifndef _H_4BB2948FA1128E2325FED18D64A54E7B_WheelSpeedType_DCPS_H_
#define _H_4BB2948FA1128E2325FED18D64A54E7B_WheelSpeedType_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "WheelSpeedType_.h"


namespace raptor_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class WheelSpeedType_TypeSupportInterface;

            typedef WheelSpeedType_TypeSupportInterface * WheelSpeedType_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < WheelSpeedType_TypeSupportInterface> WheelSpeedType_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < WheelSpeedType_TypeSupportInterface> WheelSpeedType_TypeSupportInterface_out;


            class WheelSpeedType_DataWriter;

            typedef WheelSpeedType_DataWriter * WheelSpeedType_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < WheelSpeedType_DataWriter> WheelSpeedType_DataWriter_var;
            typedef DDS_DCPSInterface_out < WheelSpeedType_DataWriter> WheelSpeedType_DataWriter_out;


            class WheelSpeedType_DataReader;

            typedef WheelSpeedType_DataReader * WheelSpeedType_DataReader_ptr;
            typedef DDS_DCPSInterface_var < WheelSpeedType_DataReader> WheelSpeedType_DataReader_var;
            typedef DDS_DCPSInterface_out < WheelSpeedType_DataReader> WheelSpeedType_DataReader_out;


            class WheelSpeedType_DataReaderView;

            typedef WheelSpeedType_DataReaderView * WheelSpeedType_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < WheelSpeedType_DataReaderView> WheelSpeedType_DataReaderView_var;
            typedef DDS_DCPSInterface_out < WheelSpeedType_DataReaderView> WheelSpeedType_DataReaderView_out;

            struct WheelSpeedType_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < WheelSpeedType_, struct WheelSpeedType_Seq_uniq_> WheelSpeedType_Seq;
            typedef DDS_DCPSSequence_var < WheelSpeedType_Seq> WheelSpeedType_Seq_var;
            typedef DDS_DCPSSequence_out < WheelSpeedType_Seq> WheelSpeedType_Seq_out;

            class  WheelSpeedType_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef WheelSpeedType_TypeSupportInterface_ptr _ptr_type;
                typedef WheelSpeedType_TypeSupportInterface_var _var_type;

                static WheelSpeedType_TypeSupportInterface_ptr _duplicate (WheelSpeedType_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static WheelSpeedType_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static WheelSpeedType_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static WheelSpeedType_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                WheelSpeedType_TypeSupportInterface_ptr _this () { return this; }


            protected:
                WheelSpeedType_TypeSupportInterface () {};
                ~WheelSpeedType_TypeSupportInterface () {};
            private:
                WheelSpeedType_TypeSupportInterface (const WheelSpeedType_TypeSupportInterface &);
                WheelSpeedType_TypeSupportInterface & operator = (const WheelSpeedType_TypeSupportInterface &);
            };

            class  WheelSpeedType_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef WheelSpeedType_DataWriter_ptr _ptr_type;
                typedef WheelSpeedType_DataWriter_var _var_type;

                static WheelSpeedType_DataWriter_ptr _duplicate (WheelSpeedType_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static WheelSpeedType_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static WheelSpeedType_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static WheelSpeedType_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                WheelSpeedType_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const WheelSpeedType_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const WheelSpeedType_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const WheelSpeedType_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const WheelSpeedType_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const WheelSpeedType_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const WheelSpeedType_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const WheelSpeedType_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const WheelSpeedType_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const WheelSpeedType_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const WheelSpeedType_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (WheelSpeedType_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const WheelSpeedType_& instance_data) = 0;

            protected:
                WheelSpeedType_DataWriter () {};
                ~WheelSpeedType_DataWriter () {};
            private:
                WheelSpeedType_DataWriter (const WheelSpeedType_DataWriter &);
                WheelSpeedType_DataWriter & operator = (const WheelSpeedType_DataWriter &);
            };

            class  WheelSpeedType_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef WheelSpeedType_DataReader_ptr _ptr_type;
                typedef WheelSpeedType_DataReader_var _var_type;

                static WheelSpeedType_DataReader_ptr _duplicate (WheelSpeedType_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static WheelSpeedType_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static WheelSpeedType_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static WheelSpeedType_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                WheelSpeedType_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (WheelSpeedType_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (WheelSpeedType_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (WheelSpeedType_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (WheelSpeedType_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (WheelSpeedType_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (WheelSpeedType_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (WheelSpeedType_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (WheelSpeedType_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (WheelSpeedType_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (WheelSpeedType_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (WheelSpeedType_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (WheelSpeedType_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (WheelSpeedType_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (WheelSpeedType_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const WheelSpeedType_& instance) = 0;

            protected:
                WheelSpeedType_DataReader () {};
                ~WheelSpeedType_DataReader () {};
            private:
                WheelSpeedType_DataReader (const WheelSpeedType_DataReader &);
                WheelSpeedType_DataReader & operator = (const WheelSpeedType_DataReader &);
            };

            class  WheelSpeedType_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef WheelSpeedType_DataReaderView_ptr _ptr_type;
                typedef WheelSpeedType_DataReaderView_var _var_type;

                static WheelSpeedType_DataReaderView_ptr _duplicate (WheelSpeedType_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static WheelSpeedType_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static WheelSpeedType_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static WheelSpeedType_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                WheelSpeedType_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (WheelSpeedType_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (WheelSpeedType_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (WheelSpeedType_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (WheelSpeedType_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (WheelSpeedType_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (WheelSpeedType_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (WheelSpeedType_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (WheelSpeedType_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (WheelSpeedType_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (WheelSpeedType_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (WheelSpeedType_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (WheelSpeedType_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (WheelSpeedType_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (WheelSpeedType_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const WheelSpeedType_& instance) = 0;

            protected:
                WheelSpeedType_DataReaderView () {};
                ~WheelSpeedType_DataReaderView () {};
            private:
                WheelSpeedType_DataReaderView (const WheelSpeedType_DataReaderView &);
                WheelSpeedType_DataReaderView & operator = (const WheelSpeedType_DataReaderView &);
            };
        }

    }

}

#endif
