#ifndef _H_EF9230C93AA5985F94561989FF3F44E2_WiperRear_DCPS_H_
#define _H_EF9230C93AA5985F94561989FF3F44E2_WiperRear_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "WiperRear_.h"


namespace raptor_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class WiperRear_TypeSupportInterface;

            typedef WiperRear_TypeSupportInterface * WiperRear_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < WiperRear_TypeSupportInterface> WiperRear_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < WiperRear_TypeSupportInterface> WiperRear_TypeSupportInterface_out;


            class WiperRear_DataWriter;

            typedef WiperRear_DataWriter * WiperRear_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < WiperRear_DataWriter> WiperRear_DataWriter_var;
            typedef DDS_DCPSInterface_out < WiperRear_DataWriter> WiperRear_DataWriter_out;


            class WiperRear_DataReader;

            typedef WiperRear_DataReader * WiperRear_DataReader_ptr;
            typedef DDS_DCPSInterface_var < WiperRear_DataReader> WiperRear_DataReader_var;
            typedef DDS_DCPSInterface_out < WiperRear_DataReader> WiperRear_DataReader_out;


            class WiperRear_DataReaderView;

            typedef WiperRear_DataReaderView * WiperRear_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < WiperRear_DataReaderView> WiperRear_DataReaderView_var;
            typedef DDS_DCPSInterface_out < WiperRear_DataReaderView> WiperRear_DataReaderView_out;

            struct WiperRear_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < WiperRear_, struct WiperRear_Seq_uniq_> WiperRear_Seq;
            typedef DDS_DCPSSequence_var < WiperRear_Seq> WiperRear_Seq_var;
            typedef DDS_DCPSSequence_out < WiperRear_Seq> WiperRear_Seq_out;

            class  WiperRear_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef WiperRear_TypeSupportInterface_ptr _ptr_type;
                typedef WiperRear_TypeSupportInterface_var _var_type;

                static WiperRear_TypeSupportInterface_ptr _duplicate (WiperRear_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static WiperRear_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static WiperRear_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static WiperRear_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                WiperRear_TypeSupportInterface_ptr _this () { return this; }


            protected:
                WiperRear_TypeSupportInterface () {};
                ~WiperRear_TypeSupportInterface () {};
            private:
                WiperRear_TypeSupportInterface (const WiperRear_TypeSupportInterface &);
                WiperRear_TypeSupportInterface & operator = (const WiperRear_TypeSupportInterface &);
            };

            class  WiperRear_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef WiperRear_DataWriter_ptr _ptr_type;
                typedef WiperRear_DataWriter_var _var_type;

                static WiperRear_DataWriter_ptr _duplicate (WiperRear_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static WiperRear_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static WiperRear_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static WiperRear_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                WiperRear_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const WiperRear_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const WiperRear_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const WiperRear_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const WiperRear_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const WiperRear_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const WiperRear_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const WiperRear_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const WiperRear_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const WiperRear_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const WiperRear_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (WiperRear_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const WiperRear_& instance_data) = 0;

            protected:
                WiperRear_DataWriter () {};
                ~WiperRear_DataWriter () {};
            private:
                WiperRear_DataWriter (const WiperRear_DataWriter &);
                WiperRear_DataWriter & operator = (const WiperRear_DataWriter &);
            };

            class  WiperRear_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef WiperRear_DataReader_ptr _ptr_type;
                typedef WiperRear_DataReader_var _var_type;

                static WiperRear_DataReader_ptr _duplicate (WiperRear_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static WiperRear_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static WiperRear_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static WiperRear_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                WiperRear_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (WiperRear_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (WiperRear_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (WiperRear_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (WiperRear_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (WiperRear_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (WiperRear_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (WiperRear_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (WiperRear_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (WiperRear_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (WiperRear_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (WiperRear_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (WiperRear_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (WiperRear_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (WiperRear_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const WiperRear_& instance) = 0;

            protected:
                WiperRear_DataReader () {};
                ~WiperRear_DataReader () {};
            private:
                WiperRear_DataReader (const WiperRear_DataReader &);
                WiperRear_DataReader & operator = (const WiperRear_DataReader &);
            };

            class  WiperRear_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef WiperRear_DataReaderView_ptr _ptr_type;
                typedef WiperRear_DataReaderView_var _var_type;

                static WiperRear_DataReaderView_ptr _duplicate (WiperRear_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static WiperRear_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static WiperRear_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static WiperRear_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                WiperRear_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (WiperRear_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (WiperRear_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (WiperRear_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (WiperRear_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (WiperRear_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (WiperRear_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (WiperRear_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (WiperRear_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (WiperRear_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (WiperRear_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (WiperRear_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (WiperRear_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (WiperRear_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (WiperRear_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const WiperRear_& instance) = 0;

            protected:
                WiperRear_DataReaderView () {};
                ~WiperRear_DataReaderView () {};
            private:
                WiperRear_DataReaderView (const WiperRear_DataReaderView &);
                WiperRear_DataReaderView & operator = (const WiperRear_DataReaderView &);
            };
        }

    }

}

#endif
