#ifndef _H_1FA7B7FCE7520A758AA787BEE4562B72_AcceleratorPedalReport__H_
#define _H_1FA7B7FCE7520A758AA787BEE4562B72_AcceleratorPedalReport__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"
#include "raptor_dbw_msgs/msg/dds_opensplice/ActuatorControlMode_.h"


namespace raptor_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  AcceleratorPedalReport_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Float pedal_input_;
                ::DDS::Float pedal_output_;
                ::DDS::Boolean enabled_;
                ::DDS::Boolean ignore_driver_;
                ::DDS::Boolean driver_activity_;
                ::DDS::Boolean fault_accel_pedal_system_;
                ::DDS::Boolean fault_ch1_;
                ::DDS::Boolean fault_ch2_;
                ::DDS::Octet rolling_counter_;
                ::DDS::Float torque_actual_;
                ::raptor_dbw_msgs::msg::dds_::ActuatorControlMode_ control_type_;
            };

            typedef DDS_DCPSStruct_var<AcceleratorPedalReport_> AcceleratorPedalReport__var;
            typedef DDS_DCPSStruct_out < AcceleratorPedalReport_> AcceleratorPedalReport__out;

        }

    }

}

#endif /* _H_1FA7B7FCE7520A758AA787BEE4562B72_AcceleratorPedalReport__H_ */
