#ifndef _H_1FA7B7FCE7520A758AA787BEE4562B72_AcceleratorPedalReport_DCPS_H_
#define _H_1FA7B7FCE7520A758AA787BEE4562B72_AcceleratorPedalReport_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "AcceleratorPedalReport_.h"


namespace raptor_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class AcceleratorPedalReport_TypeSupportInterface;

            typedef AcceleratorPedalReport_TypeSupportInterface * AcceleratorPedalReport_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < AcceleratorPedalReport_TypeSupportInterface> AcceleratorPedalReport_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < AcceleratorPedalReport_TypeSupportInterface> AcceleratorPedalReport_TypeSupportInterface_out;


            class AcceleratorPedalReport_DataWriter;

            typedef AcceleratorPedalReport_DataWriter * AcceleratorPedalReport_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < AcceleratorPedalReport_DataWriter> AcceleratorPedalReport_DataWriter_var;
            typedef DDS_DCPSInterface_out < AcceleratorPedalReport_DataWriter> AcceleratorPedalReport_DataWriter_out;


            class AcceleratorPedalReport_DataReader;

            typedef AcceleratorPedalReport_DataReader * AcceleratorPedalReport_DataReader_ptr;
            typedef DDS_DCPSInterface_var < AcceleratorPedalReport_DataReader> AcceleratorPedalReport_DataReader_var;
            typedef DDS_DCPSInterface_out < AcceleratorPedalReport_DataReader> AcceleratorPedalReport_DataReader_out;


            class AcceleratorPedalReport_DataReaderView;

            typedef AcceleratorPedalReport_DataReaderView * AcceleratorPedalReport_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < AcceleratorPedalReport_DataReaderView> AcceleratorPedalReport_DataReaderView_var;
            typedef DDS_DCPSInterface_out < AcceleratorPedalReport_DataReaderView> AcceleratorPedalReport_DataReaderView_out;

            struct AcceleratorPedalReport_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < AcceleratorPedalReport_, struct AcceleratorPedalReport_Seq_uniq_> AcceleratorPedalReport_Seq;
            typedef DDS_DCPSSequence_var < AcceleratorPedalReport_Seq> AcceleratorPedalReport_Seq_var;
            typedef DDS_DCPSSequence_out < AcceleratorPedalReport_Seq> AcceleratorPedalReport_Seq_out;

            class  AcceleratorPedalReport_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef AcceleratorPedalReport_TypeSupportInterface_ptr _ptr_type;
                typedef AcceleratorPedalReport_TypeSupportInterface_var _var_type;

                static AcceleratorPedalReport_TypeSupportInterface_ptr _duplicate (AcceleratorPedalReport_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AcceleratorPedalReport_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static AcceleratorPedalReport_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AcceleratorPedalReport_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                AcceleratorPedalReport_TypeSupportInterface_ptr _this () { return this; }


            protected:
                AcceleratorPedalReport_TypeSupportInterface () {};
                ~AcceleratorPedalReport_TypeSupportInterface () {};
            private:
                AcceleratorPedalReport_TypeSupportInterface (const AcceleratorPedalReport_TypeSupportInterface &);
                AcceleratorPedalReport_TypeSupportInterface & operator = (const AcceleratorPedalReport_TypeSupportInterface &);
            };

            class  AcceleratorPedalReport_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef AcceleratorPedalReport_DataWriter_ptr _ptr_type;
                typedef AcceleratorPedalReport_DataWriter_var _var_type;

                static AcceleratorPedalReport_DataWriter_ptr _duplicate (AcceleratorPedalReport_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AcceleratorPedalReport_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static AcceleratorPedalReport_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AcceleratorPedalReport_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                AcceleratorPedalReport_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const AcceleratorPedalReport_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const AcceleratorPedalReport_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const AcceleratorPedalReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const AcceleratorPedalReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const AcceleratorPedalReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const AcceleratorPedalReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const AcceleratorPedalReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const AcceleratorPedalReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const AcceleratorPedalReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const AcceleratorPedalReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (AcceleratorPedalReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AcceleratorPedalReport_& instance_data) = 0;

            protected:
                AcceleratorPedalReport_DataWriter () {};
                ~AcceleratorPedalReport_DataWriter () {};
            private:
                AcceleratorPedalReport_DataWriter (const AcceleratorPedalReport_DataWriter &);
                AcceleratorPedalReport_DataWriter & operator = (const AcceleratorPedalReport_DataWriter &);
            };

            class  AcceleratorPedalReport_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef AcceleratorPedalReport_DataReader_ptr _ptr_type;
                typedef AcceleratorPedalReport_DataReader_var _var_type;

                static AcceleratorPedalReport_DataReader_ptr _duplicate (AcceleratorPedalReport_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AcceleratorPedalReport_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static AcceleratorPedalReport_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AcceleratorPedalReport_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                AcceleratorPedalReport_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (AcceleratorPedalReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AcceleratorPedalReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AcceleratorPedalReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AcceleratorPedalReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AcceleratorPedalReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AcceleratorPedalReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AcceleratorPedalReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AcceleratorPedalReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AcceleratorPedalReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AcceleratorPedalReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AcceleratorPedalReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AcceleratorPedalReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AcceleratorPedalReport_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AcceleratorPedalReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AcceleratorPedalReport_& instance) = 0;

            protected:
                AcceleratorPedalReport_DataReader () {};
                ~AcceleratorPedalReport_DataReader () {};
            private:
                AcceleratorPedalReport_DataReader (const AcceleratorPedalReport_DataReader &);
                AcceleratorPedalReport_DataReader & operator = (const AcceleratorPedalReport_DataReader &);
            };

            class  AcceleratorPedalReport_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef AcceleratorPedalReport_DataReaderView_ptr _ptr_type;
                typedef AcceleratorPedalReport_DataReaderView_var _var_type;

                static AcceleratorPedalReport_DataReaderView_ptr _duplicate (AcceleratorPedalReport_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static AcceleratorPedalReport_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static AcceleratorPedalReport_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static AcceleratorPedalReport_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                AcceleratorPedalReport_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (AcceleratorPedalReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (AcceleratorPedalReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (AcceleratorPedalReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (AcceleratorPedalReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (AcceleratorPedalReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (AcceleratorPedalReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (AcceleratorPedalReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (AcceleratorPedalReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (AcceleratorPedalReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (AcceleratorPedalReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (AcceleratorPedalReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (AcceleratorPedalReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (AcceleratorPedalReport_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (AcceleratorPedalReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const AcceleratorPedalReport_& instance) = 0;

            protected:
                AcceleratorPedalReport_DataReaderView () {};
                ~AcceleratorPedalReport_DataReaderView () {};
            private:
                AcceleratorPedalReport_DataReaderView (const AcceleratorPedalReport_DataReaderView &);
                AcceleratorPedalReport_DataReaderView & operator = (const AcceleratorPedalReport_DataReaderView &);
            };
        }

    }

}

#endif
