#ifndef _H_8B942F34C0439C7A30C29C7DE5D96570_BrakeReport__H_
#define _H_8B942F34C0439C7A30C29C7DE5D96570_BrakeReport__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"
#include "raptor_dbw_msgs/msg/dds_opensplice/ParkingBrake_.h"
#include "raptor_dbw_msgs/msg/dds_opensplice/ActuatorControlMode_.h"


namespace raptor_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  BrakeReport_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Float pedal_position_;
                ::DDS::Float pedal_output_;
                ::DDS::Boolean enabled_;
                ::DDS::Boolean driver_activity_;
                ::DDS::Boolean fault_brake_system_;
                ::DDS::Octet rolling_counter_;
                ::DDS::Float brake_torque_actual_;
                ::DDS::Boolean intervention_active_;
                ::DDS::Boolean intervention_ready_;
                ::raptor_dbw_msgs::msg::dds_::ParkingBrake_ parking_brake_;
                ::raptor_dbw_msgs::msg::dds_::ActuatorControlMode_ control_type_;
            };

            typedef DDS_DCPSStruct_var<BrakeReport_> BrakeReport__var;
            typedef DDS_DCPSStruct_out < BrakeReport_> BrakeReport__out;

        }

    }

}

#endif /* _H_8B942F34C0439C7A30C29C7DE5D96570_BrakeReport__H_ */
