#ifndef _H_12844FC290DB9950F9FAA674A865C0A3_DoorLock_DCPS_H_
#define _H_12844FC290DB9950F9FAA674A865C0A3_DoorLock_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "DoorLock_.h"


namespace raptor_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class DoorLock_TypeSupportInterface;

            typedef DoorLock_TypeSupportInterface * DoorLock_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < DoorLock_TypeSupportInterface> DoorLock_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < DoorLock_TypeSupportInterface> DoorLock_TypeSupportInterface_out;


            class DoorLock_DataWriter;

            typedef DoorLock_DataWriter * DoorLock_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < DoorLock_DataWriter> DoorLock_DataWriter_var;
            typedef DDS_DCPSInterface_out < DoorLock_DataWriter> DoorLock_DataWriter_out;


            class DoorLock_DataReader;

            typedef DoorLock_DataReader * DoorLock_DataReader_ptr;
            typedef DDS_DCPSInterface_var < DoorLock_DataReader> DoorLock_DataReader_var;
            typedef DDS_DCPSInterface_out < DoorLock_DataReader> DoorLock_DataReader_out;


            class DoorLock_DataReaderView;

            typedef DoorLock_DataReaderView * DoorLock_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < DoorLock_DataReaderView> DoorLock_DataReaderView_var;
            typedef DDS_DCPSInterface_out < DoorLock_DataReaderView> DoorLock_DataReaderView_out;

            struct DoorLock_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < DoorLock_, struct DoorLock_Seq_uniq_> DoorLock_Seq;
            typedef DDS_DCPSSequence_var < DoorLock_Seq> DoorLock_Seq_var;
            typedef DDS_DCPSSequence_out < DoorLock_Seq> DoorLock_Seq_out;

            class  DoorLock_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef DoorLock_TypeSupportInterface_ptr _ptr_type;
                typedef DoorLock_TypeSupportInterface_var _var_type;

                static DoorLock_TypeSupportInterface_ptr _duplicate (DoorLock_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DoorLock_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static DoorLock_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DoorLock_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                DoorLock_TypeSupportInterface_ptr _this () { return this; }


            protected:
                DoorLock_TypeSupportInterface () {};
                ~DoorLock_TypeSupportInterface () {};
            private:
                DoorLock_TypeSupportInterface (const DoorLock_TypeSupportInterface &);
                DoorLock_TypeSupportInterface & operator = (const DoorLock_TypeSupportInterface &);
            };

            class  DoorLock_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef DoorLock_DataWriter_ptr _ptr_type;
                typedef DoorLock_DataWriter_var _var_type;

                static DoorLock_DataWriter_ptr _duplicate (DoorLock_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DoorLock_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static DoorLock_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DoorLock_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                DoorLock_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const DoorLock_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const DoorLock_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const DoorLock_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const DoorLock_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const DoorLock_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const DoorLock_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const DoorLock_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const DoorLock_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const DoorLock_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const DoorLock_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (DoorLock_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DoorLock_& instance_data) = 0;

            protected:
                DoorLock_DataWriter () {};
                ~DoorLock_DataWriter () {};
            private:
                DoorLock_DataWriter (const DoorLock_DataWriter &);
                DoorLock_DataWriter & operator = (const DoorLock_DataWriter &);
            };

            class  DoorLock_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef DoorLock_DataReader_ptr _ptr_type;
                typedef DoorLock_DataReader_var _var_type;

                static DoorLock_DataReader_ptr _duplicate (DoorLock_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DoorLock_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static DoorLock_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DoorLock_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                DoorLock_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (DoorLock_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DoorLock_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DoorLock_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DoorLock_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DoorLock_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DoorLock_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DoorLock_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DoorLock_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DoorLock_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DoorLock_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DoorLock_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DoorLock_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DoorLock_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DoorLock_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DoorLock_& instance) = 0;

            protected:
                DoorLock_DataReader () {};
                ~DoorLock_DataReader () {};
            private:
                DoorLock_DataReader (const DoorLock_DataReader &);
                DoorLock_DataReader & operator = (const DoorLock_DataReader &);
            };

            class  DoorLock_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef DoorLock_DataReaderView_ptr _ptr_type;
                typedef DoorLock_DataReaderView_var _var_type;

                static DoorLock_DataReaderView_ptr _duplicate (DoorLock_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static DoorLock_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static DoorLock_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static DoorLock_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                DoorLock_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (DoorLock_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (DoorLock_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (DoorLock_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (DoorLock_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (DoorLock_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (DoorLock_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (DoorLock_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (DoorLock_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (DoorLock_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (DoorLock_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (DoorLock_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (DoorLock_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (DoorLock_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (DoorLock_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const DoorLock_& instance) = 0;

            protected:
                DoorLock_DataReaderView () {};
                ~DoorLock_DataReaderView () {};
            private:
                DoorLock_DataReaderView (const DoorLock_DataReaderView &);
                DoorLock_DataReaderView & operator = (const DoorLock_DataReaderView &);
            };
        }

    }

}

#endif
