#ifndef _H_B3735AF513CFC597AF5537DCBBC694D0_DriverInputReport__H_
#define _H_B3735AF513CFC597AF5537DCBBC694D0_DriverInputReport__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"
#include "raptor_dbw_msgs/msg/dds_opensplice/TurnSignal_.h"
#include "raptor_dbw_msgs/msg/dds_opensplice/HighBeam_.h"
#include "raptor_dbw_msgs/msg/dds_opensplice/WiperFront_.h"


namespace raptor_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  DriverInputReport_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::raptor_dbw_msgs::msg::dds_::TurnSignal_ turn_signal_;
                ::raptor_dbw_msgs::msg::dds_::HighBeam_ high_beam_headlights_;
                ::raptor_dbw_msgs::msg::dds_::WiperFront_ wiper_;
                ::DDS::Boolean cruise_resume_button_;
                ::DDS::Boolean cruise_cancel_button_;
                ::DDS::Boolean cruise_accel_button_;
                ::DDS::Boolean cruise_decel_button_;
                ::DDS::Boolean cruise_on_off_button_;
                ::DDS::Boolean adaptive_cruise_on_off_button_;
                ::DDS::Boolean adaptive_cruise_increase_distance_button_;
                ::DDS::Boolean adaptive_cruise_decrease_distance_button_;
                ::DDS::Boolean steer_wheel_button_a_;
                ::DDS::Boolean steer_wheel_button_b_;
                ::DDS::Boolean steer_wheel_button_c_;
                ::DDS::Boolean steer_wheel_button_d_;
                ::DDS::Boolean steer_wheel_button_e_;
                ::DDS::Boolean driver_door_ajar_;
                ::DDS::Boolean passenger_door_ajar_;
                ::DDS::Boolean rear_left_door_ajar_;
                ::DDS::Boolean rear_right_door_ajar_;
                ::DDS::Boolean liftgate_ajar_;
                ::DDS::Boolean any_seatbelt_unbuckled_;
                ::DDS::Boolean airbag_deployed_;
                ::DDS::Boolean door_or_hood_ajar_;
            };

            typedef DDS_DCPSStruct_var<DriverInputReport_> DriverInputReport__var;
            typedef DDS_DCPSStruct_out < DriverInputReport_> DriverInputReport__out;

        }

    }

}

#endif /* _H_B3735AF513CFC597AF5537DCBBC694D0_DriverInputReport__H_ */
