#ifndef H_B3735AF513CFC597AF5537DCBBC694D0_DriverInputReport_SPLTYPES_H
#define H_B3735AF513CFC597AF5537DCBBC694D0_DriverInputReport_SPLTYPES_H

#include <c_base.h>
#include <c_misc.h>
#include <c_sync.h>
#include <c_collection.h>
#include <c_field.h>
#include <v_copyIn.h>

#include "ccpp_DriverInputReport_.h"
#include "std_msgs/msg/dds_opensplice/Header_SplDcps.h"
#include "raptor_dbw_msgs/msg/dds_opensplice/TurnSignal_SplDcps.h"
#include "raptor_dbw_msgs/msg/dds_opensplice/HighBeam_SplDcps.h"
#include "raptor_dbw_msgs/msg/dds_opensplice/WiperFront_SplDcps.h"



extern c_metaObject __DriverInputReport__raptor_dbw_msgs__load (c_base base);

extern c_metaObject __DriverInputReport__raptor_dbw_msgs_msg__load (c_base base);

extern c_metaObject __DriverInputReport__raptor_dbw_msgs_msg_dds___load (c_base base);

extern const char *raptor_dbw_msgs_msg_dds__DriverInputReport__metaDescriptor[];
extern const int raptor_dbw_msgs_msg_dds__DriverInputReport__metaDescriptorArrLength;
extern const int raptor_dbw_msgs_msg_dds__DriverInputReport__metaDescriptorLength;
extern c_metaObject __raptor_dbw_msgs_msg_dds__DriverInputReport___load (c_base base);
struct _raptor_dbw_msgs_msg_dds__DriverInputReport_ ;
extern  v_copyin_result __raptor_dbw_msgs_msg_dds__DriverInputReport___copyIn(c_base base, const struct raptor_dbw_msgs::msg::dds_::DriverInputReport_ *from, struct _raptor_dbw_msgs_msg_dds__DriverInputReport_ *to);
extern  void __raptor_dbw_msgs_msg_dds__DriverInputReport___copyOut(const void *_from, void *_to);
struct _raptor_dbw_msgs_msg_dds__DriverInputReport_ {
    struct _std_msgs_msg_dds__Header_ header_;
    struct _raptor_dbw_msgs_msg_dds__TurnSignal_ turn_signal_;
    struct _raptor_dbw_msgs_msg_dds__HighBeam_ high_beam_headlights_;
    struct _raptor_dbw_msgs_msg_dds__WiperFront_ wiper_;
    c_bool cruise_resume_button_;
    c_bool cruise_cancel_button_;
    c_bool cruise_accel_button_;
    c_bool cruise_decel_button_;
    c_bool cruise_on_off_button_;
    c_bool adaptive_cruise_on_off_button_;
    c_bool adaptive_cruise_increase_distance_button_;
    c_bool adaptive_cruise_decrease_distance_button_;
    c_bool steer_wheel_button_a_;
    c_bool steer_wheel_button_b_;
    c_bool steer_wheel_button_c_;
    c_bool steer_wheel_button_d_;
    c_bool steer_wheel_button_e_;
    c_bool driver_door_ajar_;
    c_bool passenger_door_ajar_;
    c_bool rear_left_door_ajar_;
    c_bool rear_right_door_ajar_;
    c_bool liftgate_ajar_;
    c_bool any_seatbelt_unbuckled_;
    c_bool airbag_deployed_;
    c_bool door_or_hood_ajar_;
};

#undef OS_API
#endif
