#ifndef _H_19331608B487DBCBAC03E9BB4256FBBD_GearReport_DCPS_H_
#define _H_19331608B487DBCBAC03E9BB4256FBBD_GearReport_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "GearReport_.h"


namespace raptor_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class GearReport_TypeSupportInterface;

            typedef GearReport_TypeSupportInterface * GearReport_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GearReport_TypeSupportInterface> GearReport_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GearReport_TypeSupportInterface> GearReport_TypeSupportInterface_out;


            class GearReport_DataWriter;

            typedef GearReport_DataWriter * GearReport_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GearReport_DataWriter> GearReport_DataWriter_var;
            typedef DDS_DCPSInterface_out < GearReport_DataWriter> GearReport_DataWriter_out;


            class GearReport_DataReader;

            typedef GearReport_DataReader * GearReport_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GearReport_DataReader> GearReport_DataReader_var;
            typedef DDS_DCPSInterface_out < GearReport_DataReader> GearReport_DataReader_out;


            class GearReport_DataReaderView;

            typedef GearReport_DataReaderView * GearReport_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GearReport_DataReaderView> GearReport_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GearReport_DataReaderView> GearReport_DataReaderView_out;

            struct GearReport_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < GearReport_, struct GearReport_Seq_uniq_> GearReport_Seq;
            typedef DDS_DCPSSequence_var < GearReport_Seq> GearReport_Seq_var;
            typedef DDS_DCPSSequence_out < GearReport_Seq> GearReport_Seq_out;

            class  GearReport_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GearReport_TypeSupportInterface_ptr _ptr_type;
                typedef GearReport_TypeSupportInterface_var _var_type;

                static GearReport_TypeSupportInterface_ptr _duplicate (GearReport_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GearReport_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GearReport_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GearReport_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GearReport_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GearReport_TypeSupportInterface () {};
                ~GearReport_TypeSupportInterface () {};
            private:
                GearReport_TypeSupportInterface (const GearReport_TypeSupportInterface &);
                GearReport_TypeSupportInterface & operator = (const GearReport_TypeSupportInterface &);
            };

            class  GearReport_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GearReport_DataWriter_ptr _ptr_type;
                typedef GearReport_DataWriter_var _var_type;

                static GearReport_DataWriter_ptr _duplicate (GearReport_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GearReport_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GearReport_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GearReport_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GearReport_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GearReport_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GearReport_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GearReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GearReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GearReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GearReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GearReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GearReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GearReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GearReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GearReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GearReport_& instance_data) = 0;

            protected:
                GearReport_DataWriter () {};
                ~GearReport_DataWriter () {};
            private:
                GearReport_DataWriter (const GearReport_DataWriter &);
                GearReport_DataWriter & operator = (const GearReport_DataWriter &);
            };

            class  GearReport_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GearReport_DataReader_ptr _ptr_type;
                typedef GearReport_DataReader_var _var_type;

                static GearReport_DataReader_ptr _duplicate (GearReport_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GearReport_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GearReport_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GearReport_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GearReport_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GearReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GearReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GearReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GearReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GearReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GearReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GearReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GearReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GearReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GearReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GearReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GearReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GearReport_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GearReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GearReport_& instance) = 0;

            protected:
                GearReport_DataReader () {};
                ~GearReport_DataReader () {};
            private:
                GearReport_DataReader (const GearReport_DataReader &);
                GearReport_DataReader & operator = (const GearReport_DataReader &);
            };

            class  GearReport_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GearReport_DataReaderView_ptr _ptr_type;
                typedef GearReport_DataReaderView_var _var_type;

                static GearReport_DataReaderView_ptr _duplicate (GearReport_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GearReport_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GearReport_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GearReport_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GearReport_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GearReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GearReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GearReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GearReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GearReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GearReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GearReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GearReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GearReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GearReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GearReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GearReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GearReport_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GearReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GearReport_& instance) = 0;

            protected:
                GearReport_DataReaderView () {};
                ~GearReport_DataReaderView () {};
            private:
                GearReport_DataReaderView (const GearReport_DataReaderView &);
                GearReport_DataReaderView & operator = (const GearReport_DataReaderView &);
            };
        }

    }

}

#endif
