#ifndef _H_5760BFA83DE62EF58281DFAB3BEBEF03_Gear__H_
#define _H_5760BFA83DE62EF58281DFAB3BEBEF03_Gear__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace raptor_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace Gear_Constants
            {
                const ::DDS::Octet NONE_ = 0;

                const ::DDS::Octet PARK_ = 1;

                const ::DDS::Octet REVERSE_ = 2;

                const ::DDS::Octet NEUTRAL_ = 3;

                const ::DDS::Octet DRIVE_ = 4;

                const ::DDS::Octet LOW_ = 5;

                const ::DDS::Octet AUTO_HOLD_ = 6;

                const ::DDS::Octet AUTO_SHIFT_UP_ = 7;

                const ::DDS::Octet AUTO_SHIFT_DOWN_ = 8;

            }

            struct  Gear_
            {
                ::DDS::Octet gear_;
            };

            typedef DDS_DCPSStruct_var<Gear_> Gear__var;
            typedef Gear_& Gear__out;

        }

    }

}

#endif /* _H_5760BFA83DE62EF58281DFAB3BEBEF03_Gear__H_ */
