#ifndef _H_094ECF78C0D62AE2DBC774EFB8B1F2BF_GlobalEnableCmd_DCPS_H_
#define _H_094ECF78C0D62AE2DBC774EFB8B1F2BF_GlobalEnableCmd_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "GlobalEnableCmd_.h"


namespace raptor_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class GlobalEnableCmd_TypeSupportInterface;

            typedef GlobalEnableCmd_TypeSupportInterface * GlobalEnableCmd_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GlobalEnableCmd_TypeSupportInterface> GlobalEnableCmd_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GlobalEnableCmd_TypeSupportInterface> GlobalEnableCmd_TypeSupportInterface_out;


            class GlobalEnableCmd_DataWriter;

            typedef GlobalEnableCmd_DataWriter * GlobalEnableCmd_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GlobalEnableCmd_DataWriter> GlobalEnableCmd_DataWriter_var;
            typedef DDS_DCPSInterface_out < GlobalEnableCmd_DataWriter> GlobalEnableCmd_DataWriter_out;


            class GlobalEnableCmd_DataReader;

            typedef GlobalEnableCmd_DataReader * GlobalEnableCmd_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GlobalEnableCmd_DataReader> GlobalEnableCmd_DataReader_var;
            typedef DDS_DCPSInterface_out < GlobalEnableCmd_DataReader> GlobalEnableCmd_DataReader_out;


            class GlobalEnableCmd_DataReaderView;

            typedef GlobalEnableCmd_DataReaderView * GlobalEnableCmd_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GlobalEnableCmd_DataReaderView> GlobalEnableCmd_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GlobalEnableCmd_DataReaderView> GlobalEnableCmd_DataReaderView_out;

            struct GlobalEnableCmd_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < GlobalEnableCmd_, struct GlobalEnableCmd_Seq_uniq_> GlobalEnableCmd_Seq;
            typedef DDS_DCPSSequence_var < GlobalEnableCmd_Seq> GlobalEnableCmd_Seq_var;
            typedef DDS_DCPSSequence_out < GlobalEnableCmd_Seq> GlobalEnableCmd_Seq_out;

            class  GlobalEnableCmd_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GlobalEnableCmd_TypeSupportInterface_ptr _ptr_type;
                typedef GlobalEnableCmd_TypeSupportInterface_var _var_type;

                static GlobalEnableCmd_TypeSupportInterface_ptr _duplicate (GlobalEnableCmd_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GlobalEnableCmd_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GlobalEnableCmd_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GlobalEnableCmd_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GlobalEnableCmd_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GlobalEnableCmd_TypeSupportInterface () {};
                ~GlobalEnableCmd_TypeSupportInterface () {};
            private:
                GlobalEnableCmd_TypeSupportInterface (const GlobalEnableCmd_TypeSupportInterface &);
                GlobalEnableCmd_TypeSupportInterface & operator = (const GlobalEnableCmd_TypeSupportInterface &);
            };

            class  GlobalEnableCmd_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GlobalEnableCmd_DataWriter_ptr _ptr_type;
                typedef GlobalEnableCmd_DataWriter_var _var_type;

                static GlobalEnableCmd_DataWriter_ptr _duplicate (GlobalEnableCmd_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GlobalEnableCmd_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GlobalEnableCmd_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GlobalEnableCmd_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GlobalEnableCmd_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GlobalEnableCmd_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GlobalEnableCmd_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GlobalEnableCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GlobalEnableCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GlobalEnableCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GlobalEnableCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GlobalEnableCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GlobalEnableCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GlobalEnableCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GlobalEnableCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GlobalEnableCmd_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GlobalEnableCmd_& instance_data) = 0;

            protected:
                GlobalEnableCmd_DataWriter () {};
                ~GlobalEnableCmd_DataWriter () {};
            private:
                GlobalEnableCmd_DataWriter (const GlobalEnableCmd_DataWriter &);
                GlobalEnableCmd_DataWriter & operator = (const GlobalEnableCmd_DataWriter &);
            };

            class  GlobalEnableCmd_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GlobalEnableCmd_DataReader_ptr _ptr_type;
                typedef GlobalEnableCmd_DataReader_var _var_type;

                static GlobalEnableCmd_DataReader_ptr _duplicate (GlobalEnableCmd_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GlobalEnableCmd_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GlobalEnableCmd_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GlobalEnableCmd_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GlobalEnableCmd_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GlobalEnableCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GlobalEnableCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GlobalEnableCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GlobalEnableCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GlobalEnableCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GlobalEnableCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GlobalEnableCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GlobalEnableCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GlobalEnableCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GlobalEnableCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GlobalEnableCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GlobalEnableCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GlobalEnableCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GlobalEnableCmd_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GlobalEnableCmd_& instance) = 0;

            protected:
                GlobalEnableCmd_DataReader () {};
                ~GlobalEnableCmd_DataReader () {};
            private:
                GlobalEnableCmd_DataReader (const GlobalEnableCmd_DataReader &);
                GlobalEnableCmd_DataReader & operator = (const GlobalEnableCmd_DataReader &);
            };

            class  GlobalEnableCmd_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GlobalEnableCmd_DataReaderView_ptr _ptr_type;
                typedef GlobalEnableCmd_DataReaderView_var _var_type;

                static GlobalEnableCmd_DataReaderView_ptr _duplicate (GlobalEnableCmd_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GlobalEnableCmd_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GlobalEnableCmd_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GlobalEnableCmd_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GlobalEnableCmd_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GlobalEnableCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GlobalEnableCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GlobalEnableCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GlobalEnableCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GlobalEnableCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GlobalEnableCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GlobalEnableCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GlobalEnableCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GlobalEnableCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GlobalEnableCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GlobalEnableCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GlobalEnableCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GlobalEnableCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GlobalEnableCmd_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GlobalEnableCmd_& instance) = 0;

            protected:
                GlobalEnableCmd_DataReaderView () {};
                ~GlobalEnableCmd_DataReaderView () {};
            private:
                GlobalEnableCmd_DataReaderView (const GlobalEnableCmd_DataReaderView &);
                GlobalEnableCmd_DataReaderView & operator = (const GlobalEnableCmd_DataReaderView &);
            };
        }

    }

}

#endif
