#ifndef _H_EFC9F1533345CEF65FBD02DA298488E2_GpsRemainderReport_DCPS_H_
#define _H_EFC9F1533345CEF65FBD02DA298488E2_GpsRemainderReport_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "GpsRemainderReport_.h"


namespace raptor_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class GpsRemainderReport_TypeSupportInterface;

            typedef GpsRemainderReport_TypeSupportInterface * GpsRemainderReport_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < GpsRemainderReport_TypeSupportInterface> GpsRemainderReport_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < GpsRemainderReport_TypeSupportInterface> GpsRemainderReport_TypeSupportInterface_out;


            class GpsRemainderReport_DataWriter;

            typedef GpsRemainderReport_DataWriter * GpsRemainderReport_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < GpsRemainderReport_DataWriter> GpsRemainderReport_DataWriter_var;
            typedef DDS_DCPSInterface_out < GpsRemainderReport_DataWriter> GpsRemainderReport_DataWriter_out;


            class GpsRemainderReport_DataReader;

            typedef GpsRemainderReport_DataReader * GpsRemainderReport_DataReader_ptr;
            typedef DDS_DCPSInterface_var < GpsRemainderReport_DataReader> GpsRemainderReport_DataReader_var;
            typedef DDS_DCPSInterface_out < GpsRemainderReport_DataReader> GpsRemainderReport_DataReader_out;


            class GpsRemainderReport_DataReaderView;

            typedef GpsRemainderReport_DataReaderView * GpsRemainderReport_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < GpsRemainderReport_DataReaderView> GpsRemainderReport_DataReaderView_var;
            typedef DDS_DCPSInterface_out < GpsRemainderReport_DataReaderView> GpsRemainderReport_DataReaderView_out;

            struct GpsRemainderReport_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < GpsRemainderReport_, struct GpsRemainderReport_Seq_uniq_> GpsRemainderReport_Seq;
            typedef DDS_DCPSSequence_var < GpsRemainderReport_Seq> GpsRemainderReport_Seq_var;
            typedef DDS_DCPSSequence_out < GpsRemainderReport_Seq> GpsRemainderReport_Seq_out;

            class  GpsRemainderReport_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef GpsRemainderReport_TypeSupportInterface_ptr _ptr_type;
                typedef GpsRemainderReport_TypeSupportInterface_var _var_type;

                static GpsRemainderReport_TypeSupportInterface_ptr _duplicate (GpsRemainderReport_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GpsRemainderReport_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static GpsRemainderReport_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GpsRemainderReport_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                GpsRemainderReport_TypeSupportInterface_ptr _this () { return this; }


            protected:
                GpsRemainderReport_TypeSupportInterface () {};
                ~GpsRemainderReport_TypeSupportInterface () {};
            private:
                GpsRemainderReport_TypeSupportInterface (const GpsRemainderReport_TypeSupportInterface &);
                GpsRemainderReport_TypeSupportInterface & operator = (const GpsRemainderReport_TypeSupportInterface &);
            };

            class  GpsRemainderReport_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef GpsRemainderReport_DataWriter_ptr _ptr_type;
                typedef GpsRemainderReport_DataWriter_var _var_type;

                static GpsRemainderReport_DataWriter_ptr _duplicate (GpsRemainderReport_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GpsRemainderReport_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static GpsRemainderReport_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GpsRemainderReport_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                GpsRemainderReport_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const GpsRemainderReport_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const GpsRemainderReport_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const GpsRemainderReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const GpsRemainderReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const GpsRemainderReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const GpsRemainderReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const GpsRemainderReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const GpsRemainderReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const GpsRemainderReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const GpsRemainderReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (GpsRemainderReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GpsRemainderReport_& instance_data) = 0;

            protected:
                GpsRemainderReport_DataWriter () {};
                ~GpsRemainderReport_DataWriter () {};
            private:
                GpsRemainderReport_DataWriter (const GpsRemainderReport_DataWriter &);
                GpsRemainderReport_DataWriter & operator = (const GpsRemainderReport_DataWriter &);
            };

            class  GpsRemainderReport_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef GpsRemainderReport_DataReader_ptr _ptr_type;
                typedef GpsRemainderReport_DataReader_var _var_type;

                static GpsRemainderReport_DataReader_ptr _duplicate (GpsRemainderReport_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GpsRemainderReport_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static GpsRemainderReport_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GpsRemainderReport_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                GpsRemainderReport_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (GpsRemainderReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GpsRemainderReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GpsRemainderReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GpsRemainderReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GpsRemainderReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GpsRemainderReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GpsRemainderReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GpsRemainderReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GpsRemainderReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GpsRemainderReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GpsRemainderReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GpsRemainderReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GpsRemainderReport_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GpsRemainderReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GpsRemainderReport_& instance) = 0;

            protected:
                GpsRemainderReport_DataReader () {};
                ~GpsRemainderReport_DataReader () {};
            private:
                GpsRemainderReport_DataReader (const GpsRemainderReport_DataReader &);
                GpsRemainderReport_DataReader & operator = (const GpsRemainderReport_DataReader &);
            };

            class  GpsRemainderReport_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef GpsRemainderReport_DataReaderView_ptr _ptr_type;
                typedef GpsRemainderReport_DataReaderView_var _var_type;

                static GpsRemainderReport_DataReaderView_ptr _duplicate (GpsRemainderReport_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static GpsRemainderReport_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static GpsRemainderReport_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static GpsRemainderReport_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                GpsRemainderReport_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (GpsRemainderReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (GpsRemainderReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (GpsRemainderReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (GpsRemainderReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (GpsRemainderReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (GpsRemainderReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (GpsRemainderReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (GpsRemainderReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (GpsRemainderReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (GpsRemainderReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (GpsRemainderReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (GpsRemainderReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (GpsRemainderReport_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (GpsRemainderReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const GpsRemainderReport_& instance) = 0;

            protected:
                GpsRemainderReport_DataReaderView () {};
                ~GpsRemainderReport_DataReaderView () {};
            private:
                GpsRemainderReport_DataReaderView (const GpsRemainderReport_DataReaderView &);
                GpsRemainderReport_DataReaderView & operator = (const GpsRemainderReport_DataReaderView &);
            };
        }

    }

}

#endif
