#ifndef _H_BF26C2496D2EB9EE8009D229EF090D19_HighBeamState_DCPS_H_
#define _H_BF26C2496D2EB9EE8009D229EF090D19_HighBeamState_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "HighBeamState_.h"


namespace raptor_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class HighBeamState_TypeSupportInterface;

            typedef HighBeamState_TypeSupportInterface * HighBeamState_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < HighBeamState_TypeSupportInterface> HighBeamState_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < HighBeamState_TypeSupportInterface> HighBeamState_TypeSupportInterface_out;


            class HighBeamState_DataWriter;

            typedef HighBeamState_DataWriter * HighBeamState_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < HighBeamState_DataWriter> HighBeamState_DataWriter_var;
            typedef DDS_DCPSInterface_out < HighBeamState_DataWriter> HighBeamState_DataWriter_out;


            class HighBeamState_DataReader;

            typedef HighBeamState_DataReader * HighBeamState_DataReader_ptr;
            typedef DDS_DCPSInterface_var < HighBeamState_DataReader> HighBeamState_DataReader_var;
            typedef DDS_DCPSInterface_out < HighBeamState_DataReader> HighBeamState_DataReader_out;


            class HighBeamState_DataReaderView;

            typedef HighBeamState_DataReaderView * HighBeamState_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < HighBeamState_DataReaderView> HighBeamState_DataReaderView_var;
            typedef DDS_DCPSInterface_out < HighBeamState_DataReaderView> HighBeamState_DataReaderView_out;

            struct HighBeamState_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < HighBeamState_, struct HighBeamState_Seq_uniq_> HighBeamState_Seq;
            typedef DDS_DCPSSequence_var < HighBeamState_Seq> HighBeamState_Seq_var;
            typedef DDS_DCPSSequence_out < HighBeamState_Seq> HighBeamState_Seq_out;

            class  HighBeamState_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef HighBeamState_TypeSupportInterface_ptr _ptr_type;
                typedef HighBeamState_TypeSupportInterface_var _var_type;

                static HighBeamState_TypeSupportInterface_ptr _duplicate (HighBeamState_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HighBeamState_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static HighBeamState_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HighBeamState_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                HighBeamState_TypeSupportInterface_ptr _this () { return this; }


            protected:
                HighBeamState_TypeSupportInterface () {};
                ~HighBeamState_TypeSupportInterface () {};
            private:
                HighBeamState_TypeSupportInterface (const HighBeamState_TypeSupportInterface &);
                HighBeamState_TypeSupportInterface & operator = (const HighBeamState_TypeSupportInterface &);
            };

            class  HighBeamState_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef HighBeamState_DataWriter_ptr _ptr_type;
                typedef HighBeamState_DataWriter_var _var_type;

                static HighBeamState_DataWriter_ptr _duplicate (HighBeamState_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HighBeamState_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static HighBeamState_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HighBeamState_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                HighBeamState_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const HighBeamState_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const HighBeamState_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const HighBeamState_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const HighBeamState_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const HighBeamState_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const HighBeamState_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const HighBeamState_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const HighBeamState_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const HighBeamState_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const HighBeamState_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (HighBeamState_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const HighBeamState_& instance_data) = 0;

            protected:
                HighBeamState_DataWriter () {};
                ~HighBeamState_DataWriter () {};
            private:
                HighBeamState_DataWriter (const HighBeamState_DataWriter &);
                HighBeamState_DataWriter & operator = (const HighBeamState_DataWriter &);
            };

            class  HighBeamState_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef HighBeamState_DataReader_ptr _ptr_type;
                typedef HighBeamState_DataReader_var _var_type;

                static HighBeamState_DataReader_ptr _duplicate (HighBeamState_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HighBeamState_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static HighBeamState_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HighBeamState_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                HighBeamState_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (HighBeamState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (HighBeamState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (HighBeamState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (HighBeamState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (HighBeamState_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (HighBeamState_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (HighBeamState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (HighBeamState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (HighBeamState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (HighBeamState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (HighBeamState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (HighBeamState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (HighBeamState_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (HighBeamState_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const HighBeamState_& instance) = 0;

            protected:
                HighBeamState_DataReader () {};
                ~HighBeamState_DataReader () {};
            private:
                HighBeamState_DataReader (const HighBeamState_DataReader &);
                HighBeamState_DataReader & operator = (const HighBeamState_DataReader &);
            };

            class  HighBeamState_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef HighBeamState_DataReaderView_ptr _ptr_type;
                typedef HighBeamState_DataReaderView_var _var_type;

                static HighBeamState_DataReaderView_ptr _duplicate (HighBeamState_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HighBeamState_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static HighBeamState_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HighBeamState_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                HighBeamState_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (HighBeamState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (HighBeamState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (HighBeamState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (HighBeamState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (HighBeamState_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (HighBeamState_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (HighBeamState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (HighBeamState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (HighBeamState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (HighBeamState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (HighBeamState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (HighBeamState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (HighBeamState_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (HighBeamState_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const HighBeamState_& instance) = 0;

            protected:
                HighBeamState_DataReaderView () {};
                ~HighBeamState_DataReaderView () {};
            private:
                HighBeamState_DataReaderView (const HighBeamState_DataReaderView &);
                HighBeamState_DataReaderView & operator = (const HighBeamState_DataReaderView &);
            };
        }

    }

}

#endif
