#ifndef _H_A3E17A0A0609C2055620C897683C5707_HornState_DCPS_H_
#define _H_A3E17A0A0609C2055620C897683C5707_HornState_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "HornState_.h"


namespace raptor_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class HornState_TypeSupportInterface;

            typedef HornState_TypeSupportInterface * HornState_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < HornState_TypeSupportInterface> HornState_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < HornState_TypeSupportInterface> HornState_TypeSupportInterface_out;


            class HornState_DataWriter;

            typedef HornState_DataWriter * HornState_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < HornState_DataWriter> HornState_DataWriter_var;
            typedef DDS_DCPSInterface_out < HornState_DataWriter> HornState_DataWriter_out;


            class HornState_DataReader;

            typedef HornState_DataReader * HornState_DataReader_ptr;
            typedef DDS_DCPSInterface_var < HornState_DataReader> HornState_DataReader_var;
            typedef DDS_DCPSInterface_out < HornState_DataReader> HornState_DataReader_out;


            class HornState_DataReaderView;

            typedef HornState_DataReaderView * HornState_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < HornState_DataReaderView> HornState_DataReaderView_var;
            typedef DDS_DCPSInterface_out < HornState_DataReaderView> HornState_DataReaderView_out;

            struct HornState_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < HornState_, struct HornState_Seq_uniq_> HornState_Seq;
            typedef DDS_DCPSSequence_var < HornState_Seq> HornState_Seq_var;
            typedef DDS_DCPSSequence_out < HornState_Seq> HornState_Seq_out;

            class  HornState_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef HornState_TypeSupportInterface_ptr _ptr_type;
                typedef HornState_TypeSupportInterface_var _var_type;

                static HornState_TypeSupportInterface_ptr _duplicate (HornState_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HornState_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static HornState_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HornState_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                HornState_TypeSupportInterface_ptr _this () { return this; }


            protected:
                HornState_TypeSupportInterface () {};
                ~HornState_TypeSupportInterface () {};
            private:
                HornState_TypeSupportInterface (const HornState_TypeSupportInterface &);
                HornState_TypeSupportInterface & operator = (const HornState_TypeSupportInterface &);
            };

            class  HornState_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef HornState_DataWriter_ptr _ptr_type;
                typedef HornState_DataWriter_var _var_type;

                static HornState_DataWriter_ptr _duplicate (HornState_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HornState_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static HornState_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HornState_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                HornState_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const HornState_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const HornState_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const HornState_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const HornState_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const HornState_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const HornState_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const HornState_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const HornState_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const HornState_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const HornState_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (HornState_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const HornState_& instance_data) = 0;

            protected:
                HornState_DataWriter () {};
                ~HornState_DataWriter () {};
            private:
                HornState_DataWriter (const HornState_DataWriter &);
                HornState_DataWriter & operator = (const HornState_DataWriter &);
            };

            class  HornState_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef HornState_DataReader_ptr _ptr_type;
                typedef HornState_DataReader_var _var_type;

                static HornState_DataReader_ptr _duplicate (HornState_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HornState_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static HornState_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HornState_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                HornState_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (HornState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (HornState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (HornState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (HornState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (HornState_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (HornState_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (HornState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (HornState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (HornState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (HornState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (HornState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (HornState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (HornState_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (HornState_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const HornState_& instance) = 0;

            protected:
                HornState_DataReader () {};
                ~HornState_DataReader () {};
            private:
                HornState_DataReader (const HornState_DataReader &);
                HornState_DataReader & operator = (const HornState_DataReader &);
            };

            class  HornState_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef HornState_DataReaderView_ptr _ptr_type;
                typedef HornState_DataReaderView_var _var_type;

                static HornState_DataReaderView_ptr _duplicate (HornState_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static HornState_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static HornState_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static HornState_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                HornState_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (HornState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (HornState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (HornState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (HornState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (HornState_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (HornState_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (HornState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (HornState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (HornState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (HornState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (HornState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (HornState_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (HornState_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (HornState_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const HornState_& instance) = 0;

            protected:
                HornState_DataReaderView () {};
                ~HornState_DataReaderView () {};
            private:
                HornState_DataReaderView (const HornState_DataReaderView &);
                HornState_DataReaderView & operator = (const HornState_DataReaderView &);
            };
        }

    }

}

#endif
