#ifndef _H_9A8069B8CAE62CF7F7078CF4C20885A4_LowVoltageSystemReport_DCPS_H_
#define _H_9A8069B8CAE62CF7F7078CF4C20885A4_LowVoltageSystemReport_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "LowVoltageSystemReport_.h"


namespace raptor_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class LowVoltageSystemReport_TypeSupportInterface;

            typedef LowVoltageSystemReport_TypeSupportInterface * LowVoltageSystemReport_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < LowVoltageSystemReport_TypeSupportInterface> LowVoltageSystemReport_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < LowVoltageSystemReport_TypeSupportInterface> LowVoltageSystemReport_TypeSupportInterface_out;


            class LowVoltageSystemReport_DataWriter;

            typedef LowVoltageSystemReport_DataWriter * LowVoltageSystemReport_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < LowVoltageSystemReport_DataWriter> LowVoltageSystemReport_DataWriter_var;
            typedef DDS_DCPSInterface_out < LowVoltageSystemReport_DataWriter> LowVoltageSystemReport_DataWriter_out;


            class LowVoltageSystemReport_DataReader;

            typedef LowVoltageSystemReport_DataReader * LowVoltageSystemReport_DataReader_ptr;
            typedef DDS_DCPSInterface_var < LowVoltageSystemReport_DataReader> LowVoltageSystemReport_DataReader_var;
            typedef DDS_DCPSInterface_out < LowVoltageSystemReport_DataReader> LowVoltageSystemReport_DataReader_out;


            class LowVoltageSystemReport_DataReaderView;

            typedef LowVoltageSystemReport_DataReaderView * LowVoltageSystemReport_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < LowVoltageSystemReport_DataReaderView> LowVoltageSystemReport_DataReaderView_var;
            typedef DDS_DCPSInterface_out < LowVoltageSystemReport_DataReaderView> LowVoltageSystemReport_DataReaderView_out;

            struct LowVoltageSystemReport_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < LowVoltageSystemReport_, struct LowVoltageSystemReport_Seq_uniq_> LowVoltageSystemReport_Seq;
            typedef DDS_DCPSSequence_var < LowVoltageSystemReport_Seq> LowVoltageSystemReport_Seq_var;
            typedef DDS_DCPSSequence_out < LowVoltageSystemReport_Seq> LowVoltageSystemReport_Seq_out;

            class  LowVoltageSystemReport_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef LowVoltageSystemReport_TypeSupportInterface_ptr _ptr_type;
                typedef LowVoltageSystemReport_TypeSupportInterface_var _var_type;

                static LowVoltageSystemReport_TypeSupportInterface_ptr _duplicate (LowVoltageSystemReport_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LowVoltageSystemReport_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static LowVoltageSystemReport_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LowVoltageSystemReport_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                LowVoltageSystemReport_TypeSupportInterface_ptr _this () { return this; }


            protected:
                LowVoltageSystemReport_TypeSupportInterface () {};
                ~LowVoltageSystemReport_TypeSupportInterface () {};
            private:
                LowVoltageSystemReport_TypeSupportInterface (const LowVoltageSystemReport_TypeSupportInterface &);
                LowVoltageSystemReport_TypeSupportInterface & operator = (const LowVoltageSystemReport_TypeSupportInterface &);
            };

            class  LowVoltageSystemReport_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef LowVoltageSystemReport_DataWriter_ptr _ptr_type;
                typedef LowVoltageSystemReport_DataWriter_var _var_type;

                static LowVoltageSystemReport_DataWriter_ptr _duplicate (LowVoltageSystemReport_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LowVoltageSystemReport_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static LowVoltageSystemReport_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LowVoltageSystemReport_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                LowVoltageSystemReport_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const LowVoltageSystemReport_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const LowVoltageSystemReport_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const LowVoltageSystemReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const LowVoltageSystemReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const LowVoltageSystemReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const LowVoltageSystemReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const LowVoltageSystemReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const LowVoltageSystemReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const LowVoltageSystemReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const LowVoltageSystemReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (LowVoltageSystemReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LowVoltageSystemReport_& instance_data) = 0;

            protected:
                LowVoltageSystemReport_DataWriter () {};
                ~LowVoltageSystemReport_DataWriter () {};
            private:
                LowVoltageSystemReport_DataWriter (const LowVoltageSystemReport_DataWriter &);
                LowVoltageSystemReport_DataWriter & operator = (const LowVoltageSystemReport_DataWriter &);
            };

            class  LowVoltageSystemReport_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef LowVoltageSystemReport_DataReader_ptr _ptr_type;
                typedef LowVoltageSystemReport_DataReader_var _var_type;

                static LowVoltageSystemReport_DataReader_ptr _duplicate (LowVoltageSystemReport_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LowVoltageSystemReport_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static LowVoltageSystemReport_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LowVoltageSystemReport_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                LowVoltageSystemReport_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (LowVoltageSystemReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (LowVoltageSystemReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (LowVoltageSystemReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (LowVoltageSystemReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (LowVoltageSystemReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (LowVoltageSystemReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (LowVoltageSystemReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (LowVoltageSystemReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (LowVoltageSystemReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (LowVoltageSystemReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (LowVoltageSystemReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (LowVoltageSystemReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (LowVoltageSystemReport_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (LowVoltageSystemReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LowVoltageSystemReport_& instance) = 0;

            protected:
                LowVoltageSystemReport_DataReader () {};
                ~LowVoltageSystemReport_DataReader () {};
            private:
                LowVoltageSystemReport_DataReader (const LowVoltageSystemReport_DataReader &);
                LowVoltageSystemReport_DataReader & operator = (const LowVoltageSystemReport_DataReader &);
            };

            class  LowVoltageSystemReport_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef LowVoltageSystemReport_DataReaderView_ptr _ptr_type;
                typedef LowVoltageSystemReport_DataReaderView_var _var_type;

                static LowVoltageSystemReport_DataReaderView_ptr _duplicate (LowVoltageSystemReport_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LowVoltageSystemReport_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static LowVoltageSystemReport_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LowVoltageSystemReport_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                LowVoltageSystemReport_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (LowVoltageSystemReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (LowVoltageSystemReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (LowVoltageSystemReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (LowVoltageSystemReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (LowVoltageSystemReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (LowVoltageSystemReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (LowVoltageSystemReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (LowVoltageSystemReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (LowVoltageSystemReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (LowVoltageSystemReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (LowVoltageSystemReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (LowVoltageSystemReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (LowVoltageSystemReport_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (LowVoltageSystemReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LowVoltageSystemReport_& instance) = 0;

            protected:
                LowVoltageSystemReport_DataReaderView () {};
                ~LowVoltageSystemReport_DataReaderView () {};
            private:
                LowVoltageSystemReport_DataReaderView (const LowVoltageSystemReport_DataReaderView &);
                LowVoltageSystemReport_DataReaderView & operator = (const LowVoltageSystemReport_DataReaderView &);
            };
        }

    }

}

#endif
