#ifndef H_8FCE6EE21CD59528432E9D6E09608209_MiscCmd_SPLTYPES_H
#define H_8FCE6EE21CD59528432E9D6E09608209_MiscCmd_SPLTYPES_H

#include <c_base.h>
#include <c_misc.h>
#include <c_sync.h>
#include <c_collection.h>
#include <c_field.h>
#include <v_copyIn.h>

#include "ccpp_MiscCmd_.h"
#include "raptor_dbw_msgs/msg/dds_opensplice/TurnSignal_SplDcps.h"
#include "raptor_dbw_msgs/msg/dds_opensplice/DoorRequest_SplDcps.h"
#include "raptor_dbw_msgs/msg/dds_opensplice/HighBeam_SplDcps.h"
#include "raptor_dbw_msgs/msg/dds_opensplice/WiperFront_SplDcps.h"
#include "raptor_dbw_msgs/msg/dds_opensplice/WiperRear_SplDcps.h"
#include "raptor_dbw_msgs/msg/dds_opensplice/Ignition_SplDcps.h"
#include "raptor_dbw_msgs/msg/dds_opensplice/DoorLock_SplDcps.h"
#include "raptor_dbw_msgs/msg/dds_opensplice/LowBeam_SplDcps.h"



extern c_metaObject __MiscCmd__raptor_dbw_msgs__load (c_base base);

extern c_metaObject __MiscCmd__raptor_dbw_msgs_msg__load (c_base base);

extern c_metaObject __MiscCmd__raptor_dbw_msgs_msg_dds___load (c_base base);

extern const char *raptor_dbw_msgs_msg_dds__MiscCmd__metaDescriptor[];
extern const int raptor_dbw_msgs_msg_dds__MiscCmd__metaDescriptorArrLength;
extern const int raptor_dbw_msgs_msg_dds__MiscCmd__metaDescriptorLength;
extern c_metaObject __raptor_dbw_msgs_msg_dds__MiscCmd___load (c_base base);
struct _raptor_dbw_msgs_msg_dds__MiscCmd_ ;
extern  v_copyin_result __raptor_dbw_msgs_msg_dds__MiscCmd___copyIn(c_base base, const struct raptor_dbw_msgs::msg::dds_::MiscCmd_ *from, struct _raptor_dbw_msgs_msg_dds__MiscCmd_ *to);
extern  void __raptor_dbw_msgs_msg_dds__MiscCmd___copyOut(const void *_from, void *_to);
struct _raptor_dbw_msgs_msg_dds__MiscCmd_ {
    struct _raptor_dbw_msgs_msg_dds__TurnSignal_ cmd_;
    struct _raptor_dbw_msgs_msg_dds__DoorRequest_ door_request_right_rear_;
    c_octet rolling_counter_;
    struct _raptor_dbw_msgs_msg_dds__HighBeam_ high_beam_cmd_;
    struct _raptor_dbw_msgs_msg_dds__WiperFront_ front_wiper_cmd_;
    struct _raptor_dbw_msgs_msg_dds__WiperRear_ rear_wiper_cmd_;
    struct _raptor_dbw_msgs_msg_dds__Ignition_ ignition_cmd_;
    struct _raptor_dbw_msgs_msg_dds__DoorRequest_ door_request_left_rear_;
    struct _raptor_dbw_msgs_msg_dds__DoorRequest_ door_request_lift_gate_;
    struct _raptor_dbw_msgs_msg_dds__DoorLock_ door_lock_cmd_;
    c_bool block_standard_cruise_buttons_;
    c_bool block_adaptive_cruise_buttons_;
    c_bool block_turn_signal_stalk_;
    c_bool horn_cmd_;
    struct _raptor_dbw_msgs_msg_dds__LowBeam_ low_beam_cmd_;
};

#undef OS_API
#endif
