#ifndef _H_3D97F370934608A2A52098B390AA49BE_MiscReport__H_
#define _H_3D97F370934608A2A52098B390AA49BE_MiscReport__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace raptor_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  MiscReport_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Float fuel_level_;
                ::DDS::Boolean drive_by_wire_enabled_;
                ::DDS::Float vehicle_speed_;
                ::DDS::UShort software_build_number_;
                ::DDS::Boolean general_actuator_fault_;
                ::DDS::Boolean by_wire_ready_;
                ::DDS::Boolean general_driver_activity_;
                ::DDS::Boolean comms_fault_;
                ::DDS::Float ambient_temp_;
            };

            typedef DDS_DCPSStruct_var<MiscReport_> MiscReport__var;
            typedef DDS_DCPSStruct_out < MiscReport_> MiscReport__out;

        }

    }

}

#endif /* _H_3D97F370934608A2A52098B390AA49BE_MiscReport__H_ */
