#ifndef _H_3D97F370934608A2A52098B390AA49BE_MiscReport_DCPS_H_
#define _H_3D97F370934608A2A52098B390AA49BE_MiscReport_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "MiscReport_.h"


namespace raptor_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class MiscReport_TypeSupportInterface;

            typedef MiscReport_TypeSupportInterface * MiscReport_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < MiscReport_TypeSupportInterface> MiscReport_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < MiscReport_TypeSupportInterface> MiscReport_TypeSupportInterface_out;


            class MiscReport_DataWriter;

            typedef MiscReport_DataWriter * MiscReport_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < MiscReport_DataWriter> MiscReport_DataWriter_var;
            typedef DDS_DCPSInterface_out < MiscReport_DataWriter> MiscReport_DataWriter_out;


            class MiscReport_DataReader;

            typedef MiscReport_DataReader * MiscReport_DataReader_ptr;
            typedef DDS_DCPSInterface_var < MiscReport_DataReader> MiscReport_DataReader_var;
            typedef DDS_DCPSInterface_out < MiscReport_DataReader> MiscReport_DataReader_out;


            class MiscReport_DataReaderView;

            typedef MiscReport_DataReaderView * MiscReport_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < MiscReport_DataReaderView> MiscReport_DataReaderView_var;
            typedef DDS_DCPSInterface_out < MiscReport_DataReaderView> MiscReport_DataReaderView_out;

            struct MiscReport_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < MiscReport_, struct MiscReport_Seq_uniq_> MiscReport_Seq;
            typedef DDS_DCPSSequence_var < MiscReport_Seq> MiscReport_Seq_var;
            typedef DDS_DCPSSequence_out < MiscReport_Seq> MiscReport_Seq_out;

            class  MiscReport_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef MiscReport_TypeSupportInterface_ptr _ptr_type;
                typedef MiscReport_TypeSupportInterface_var _var_type;

                static MiscReport_TypeSupportInterface_ptr _duplicate (MiscReport_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MiscReport_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static MiscReport_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MiscReport_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                MiscReport_TypeSupportInterface_ptr _this () { return this; }


            protected:
                MiscReport_TypeSupportInterface () {};
                ~MiscReport_TypeSupportInterface () {};
            private:
                MiscReport_TypeSupportInterface (const MiscReport_TypeSupportInterface &);
                MiscReport_TypeSupportInterface & operator = (const MiscReport_TypeSupportInterface &);
            };

            class  MiscReport_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef MiscReport_DataWriter_ptr _ptr_type;
                typedef MiscReport_DataWriter_var _var_type;

                static MiscReport_DataWriter_ptr _duplicate (MiscReport_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MiscReport_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static MiscReport_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MiscReport_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                MiscReport_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const MiscReport_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const MiscReport_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const MiscReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const MiscReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const MiscReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const MiscReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const MiscReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const MiscReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const MiscReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const MiscReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (MiscReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MiscReport_& instance_data) = 0;

            protected:
                MiscReport_DataWriter () {};
                ~MiscReport_DataWriter () {};
            private:
                MiscReport_DataWriter (const MiscReport_DataWriter &);
                MiscReport_DataWriter & operator = (const MiscReport_DataWriter &);
            };

            class  MiscReport_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef MiscReport_DataReader_ptr _ptr_type;
                typedef MiscReport_DataReader_var _var_type;

                static MiscReport_DataReader_ptr _duplicate (MiscReport_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MiscReport_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static MiscReport_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MiscReport_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                MiscReport_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (MiscReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MiscReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MiscReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MiscReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MiscReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MiscReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MiscReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MiscReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MiscReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MiscReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MiscReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MiscReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MiscReport_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MiscReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MiscReport_& instance) = 0;

            protected:
                MiscReport_DataReader () {};
                ~MiscReport_DataReader () {};
            private:
                MiscReport_DataReader (const MiscReport_DataReader &);
                MiscReport_DataReader & operator = (const MiscReport_DataReader &);
            };

            class  MiscReport_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef MiscReport_DataReaderView_ptr _ptr_type;
                typedef MiscReport_DataReaderView_var _var_type;

                static MiscReport_DataReaderView_ptr _duplicate (MiscReport_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static MiscReport_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static MiscReport_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static MiscReport_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                MiscReport_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (MiscReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (MiscReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (MiscReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (MiscReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (MiscReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (MiscReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (MiscReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (MiscReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (MiscReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (MiscReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (MiscReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (MiscReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (MiscReport_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (MiscReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const MiscReport_& instance) = 0;

            protected:
                MiscReport_DataReaderView () {};
                ~MiscReport_DataReaderView () {};
            private:
                MiscReport_DataReaderView (const MiscReport_DataReaderView &);
                MiscReport_DataReaderView & operator = (const MiscReport_DataReaderView &);
            };
        }

    }

}

#endif
