#ifndef _H_A99F9946507D0922F86D5E664F4AA707_OtherActuatorsReport_DCPS_H_
#define _H_A99F9946507D0922F86D5E664F4AA707_OtherActuatorsReport_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "OtherActuatorsReport_.h"


namespace raptor_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class OtherActuatorsReport_TypeSupportInterface;

            typedef OtherActuatorsReport_TypeSupportInterface * OtherActuatorsReport_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < OtherActuatorsReport_TypeSupportInterface> OtherActuatorsReport_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < OtherActuatorsReport_TypeSupportInterface> OtherActuatorsReport_TypeSupportInterface_out;


            class OtherActuatorsReport_DataWriter;

            typedef OtherActuatorsReport_DataWriter * OtherActuatorsReport_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < OtherActuatorsReport_DataWriter> OtherActuatorsReport_DataWriter_var;
            typedef DDS_DCPSInterface_out < OtherActuatorsReport_DataWriter> OtherActuatorsReport_DataWriter_out;


            class OtherActuatorsReport_DataReader;

            typedef OtherActuatorsReport_DataReader * OtherActuatorsReport_DataReader_ptr;
            typedef DDS_DCPSInterface_var < OtherActuatorsReport_DataReader> OtherActuatorsReport_DataReader_var;
            typedef DDS_DCPSInterface_out < OtherActuatorsReport_DataReader> OtherActuatorsReport_DataReader_out;


            class OtherActuatorsReport_DataReaderView;

            typedef OtherActuatorsReport_DataReaderView * OtherActuatorsReport_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < OtherActuatorsReport_DataReaderView> OtherActuatorsReport_DataReaderView_var;
            typedef DDS_DCPSInterface_out < OtherActuatorsReport_DataReaderView> OtherActuatorsReport_DataReaderView_out;

            struct OtherActuatorsReport_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < OtherActuatorsReport_, struct OtherActuatorsReport_Seq_uniq_> OtherActuatorsReport_Seq;
            typedef DDS_DCPSSequence_var < OtherActuatorsReport_Seq> OtherActuatorsReport_Seq_var;
            typedef DDS_DCPSSequence_out < OtherActuatorsReport_Seq> OtherActuatorsReport_Seq_out;

            class  OtherActuatorsReport_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef OtherActuatorsReport_TypeSupportInterface_ptr _ptr_type;
                typedef OtherActuatorsReport_TypeSupportInterface_var _var_type;

                static OtherActuatorsReport_TypeSupportInterface_ptr _duplicate (OtherActuatorsReport_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static OtherActuatorsReport_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static OtherActuatorsReport_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static OtherActuatorsReport_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                OtherActuatorsReport_TypeSupportInterface_ptr _this () { return this; }


            protected:
                OtherActuatorsReport_TypeSupportInterface () {};
                ~OtherActuatorsReport_TypeSupportInterface () {};
            private:
                OtherActuatorsReport_TypeSupportInterface (const OtherActuatorsReport_TypeSupportInterface &);
                OtherActuatorsReport_TypeSupportInterface & operator = (const OtherActuatorsReport_TypeSupportInterface &);
            };

            class  OtherActuatorsReport_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef OtherActuatorsReport_DataWriter_ptr _ptr_type;
                typedef OtherActuatorsReport_DataWriter_var _var_type;

                static OtherActuatorsReport_DataWriter_ptr _duplicate (OtherActuatorsReport_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static OtherActuatorsReport_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static OtherActuatorsReport_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static OtherActuatorsReport_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                OtherActuatorsReport_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const OtherActuatorsReport_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const OtherActuatorsReport_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const OtherActuatorsReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const OtherActuatorsReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const OtherActuatorsReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const OtherActuatorsReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const OtherActuatorsReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const OtherActuatorsReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const OtherActuatorsReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const OtherActuatorsReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (OtherActuatorsReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const OtherActuatorsReport_& instance_data) = 0;

            protected:
                OtherActuatorsReport_DataWriter () {};
                ~OtherActuatorsReport_DataWriter () {};
            private:
                OtherActuatorsReport_DataWriter (const OtherActuatorsReport_DataWriter &);
                OtherActuatorsReport_DataWriter & operator = (const OtherActuatorsReport_DataWriter &);
            };

            class  OtherActuatorsReport_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef OtherActuatorsReport_DataReader_ptr _ptr_type;
                typedef OtherActuatorsReport_DataReader_var _var_type;

                static OtherActuatorsReport_DataReader_ptr _duplicate (OtherActuatorsReport_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static OtherActuatorsReport_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static OtherActuatorsReport_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static OtherActuatorsReport_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                OtherActuatorsReport_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (OtherActuatorsReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (OtherActuatorsReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (OtherActuatorsReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (OtherActuatorsReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (OtherActuatorsReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (OtherActuatorsReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (OtherActuatorsReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (OtherActuatorsReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (OtherActuatorsReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (OtherActuatorsReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (OtherActuatorsReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (OtherActuatorsReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (OtherActuatorsReport_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (OtherActuatorsReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const OtherActuatorsReport_& instance) = 0;

            protected:
                OtherActuatorsReport_DataReader () {};
                ~OtherActuatorsReport_DataReader () {};
            private:
                OtherActuatorsReport_DataReader (const OtherActuatorsReport_DataReader &);
                OtherActuatorsReport_DataReader & operator = (const OtherActuatorsReport_DataReader &);
            };

            class  OtherActuatorsReport_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef OtherActuatorsReport_DataReaderView_ptr _ptr_type;
                typedef OtherActuatorsReport_DataReaderView_var _var_type;

                static OtherActuatorsReport_DataReaderView_ptr _duplicate (OtherActuatorsReport_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static OtherActuatorsReport_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static OtherActuatorsReport_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static OtherActuatorsReport_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                OtherActuatorsReport_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (OtherActuatorsReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (OtherActuatorsReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (OtherActuatorsReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (OtherActuatorsReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (OtherActuatorsReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (OtherActuatorsReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (OtherActuatorsReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (OtherActuatorsReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (OtherActuatorsReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (OtherActuatorsReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (OtherActuatorsReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (OtherActuatorsReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (OtherActuatorsReport_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (OtherActuatorsReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const OtherActuatorsReport_& instance) = 0;

            protected:
                OtherActuatorsReport_DataReaderView () {};
                ~OtherActuatorsReport_DataReaderView () {};
            private:
                OtherActuatorsReport_DataReaderView (const OtherActuatorsReport_DataReaderView &);
                OtherActuatorsReport_DataReaderView & operator = (const OtherActuatorsReport_DataReaderView &);
            };
        }

    }

}

#endif
