#ifndef H_A99F9946507D0922F86D5E664F4AA707_OtherActuatorsReport_SPLTYPES_H
#define H_A99F9946507D0922F86D5E664F4AA707_OtherActuatorsReport_SPLTYPES_H

#include <c_base.h>
#include <c_misc.h>
#include <c_sync.h>
#include <c_collection.h>
#include <c_field.h>
#include <v_copyIn.h>

#include "ccpp_OtherActuatorsReport_.h"
#include "std_msgs/msg/dds_opensplice/Header_SplDcps.h"
#include "raptor_dbw_msgs/msg/dds_opensplice/Ignition_SplDcps.h"
#include "raptor_dbw_msgs/msg/dds_opensplice/HornState_SplDcps.h"
#include "raptor_dbw_msgs/msg/dds_opensplice/TurnSignal_SplDcps.h"
#include "raptor_dbw_msgs/msg/dds_opensplice/HighBeamState_SplDcps.h"
#include "raptor_dbw_msgs/msg/dds_opensplice/LowBeam_SplDcps.h"
#include "raptor_dbw_msgs/msg/dds_opensplice/WiperFront_SplDcps.h"
#include "raptor_dbw_msgs/msg/dds_opensplice/WiperRear_SplDcps.h"
#include "raptor_dbw_msgs/msg/dds_opensplice/DoorState_SplDcps.h"
#include "raptor_dbw_msgs/msg/dds_opensplice/DoorLock_SplDcps.h"



extern c_metaObject __OtherActuatorsReport__raptor_dbw_msgs__load (c_base base);

extern c_metaObject __OtherActuatorsReport__raptor_dbw_msgs_msg__load (c_base base);

extern c_metaObject __OtherActuatorsReport__raptor_dbw_msgs_msg_dds___load (c_base base);

extern const char *raptor_dbw_msgs_msg_dds__OtherActuatorsReport__metaDescriptor[];
extern const int raptor_dbw_msgs_msg_dds__OtherActuatorsReport__metaDescriptorArrLength;
extern const int raptor_dbw_msgs_msg_dds__OtherActuatorsReport__metaDescriptorLength;
extern c_metaObject __raptor_dbw_msgs_msg_dds__OtherActuatorsReport___load (c_base base);
struct _raptor_dbw_msgs_msg_dds__OtherActuatorsReport_ ;
extern  v_copyin_result __raptor_dbw_msgs_msg_dds__OtherActuatorsReport___copyIn(c_base base, const struct raptor_dbw_msgs::msg::dds_::OtherActuatorsReport_ *from, struct _raptor_dbw_msgs_msg_dds__OtherActuatorsReport_ *to);
extern  void __raptor_dbw_msgs_msg_dds__OtherActuatorsReport___copyOut(const void *_from, void *_to);
struct _raptor_dbw_msgs_msg_dds__OtherActuatorsReport_ {
    struct _std_msgs_msg_dds__Header_ header_;
    struct _raptor_dbw_msgs_msg_dds__Ignition_ ignition_state_;
    struct _raptor_dbw_msgs_msg_dds__HornState_ horn_state_;
    struct _raptor_dbw_msgs_msg_dds__TurnSignal_ turn_signal_state_;
    c_bool turn_signal_sync_;
    struct _raptor_dbw_msgs_msg_dds__HighBeamState_ high_beam_state_;
    struct _raptor_dbw_msgs_msg_dds__LowBeam_ low_beam_state_;
    struct _raptor_dbw_msgs_msg_dds__WiperFront_ front_wiper_state_;
    struct _raptor_dbw_msgs_msg_dds__WiperRear_ rear_wiper_state_;
    struct _raptor_dbw_msgs_msg_dds__DoorState_ right_rear_door_state_;
    struct _raptor_dbw_msgs_msg_dds__DoorState_ left_rear_door_state_;
    struct _raptor_dbw_msgs_msg_dds__DoorState_ liftgate_door_state_;
    struct _raptor_dbw_msgs_msg_dds__DoorLock_ door_lock_state_;
    c_octet rolling_counter_;
};

#undef OS_API
#endif
