#ifndef _H_62EF939043A1192BF0244982F275F495_SteeringCmd_DCPS_H_
#define _H_62EF939043A1192BF0244982F275F495_SteeringCmd_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SteeringCmd_.h"


namespace raptor_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class SteeringCmd_TypeSupportInterface;

            typedef SteeringCmd_TypeSupportInterface * SteeringCmd_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SteeringCmd_TypeSupportInterface> SteeringCmd_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SteeringCmd_TypeSupportInterface> SteeringCmd_TypeSupportInterface_out;


            class SteeringCmd_DataWriter;

            typedef SteeringCmd_DataWriter * SteeringCmd_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SteeringCmd_DataWriter> SteeringCmd_DataWriter_var;
            typedef DDS_DCPSInterface_out < SteeringCmd_DataWriter> SteeringCmd_DataWriter_out;


            class SteeringCmd_DataReader;

            typedef SteeringCmd_DataReader * SteeringCmd_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SteeringCmd_DataReader> SteeringCmd_DataReader_var;
            typedef DDS_DCPSInterface_out < SteeringCmd_DataReader> SteeringCmd_DataReader_out;


            class SteeringCmd_DataReaderView;

            typedef SteeringCmd_DataReaderView * SteeringCmd_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SteeringCmd_DataReaderView> SteeringCmd_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SteeringCmd_DataReaderView> SteeringCmd_DataReaderView_out;

            struct SteeringCmd_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < SteeringCmd_, struct SteeringCmd_Seq_uniq_> SteeringCmd_Seq;
            typedef DDS_DCPSSequence_var < SteeringCmd_Seq> SteeringCmd_Seq_var;
            typedef DDS_DCPSSequence_out < SteeringCmd_Seq> SteeringCmd_Seq_out;

            class  SteeringCmd_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SteeringCmd_TypeSupportInterface_ptr _ptr_type;
                typedef SteeringCmd_TypeSupportInterface_var _var_type;

                static SteeringCmd_TypeSupportInterface_ptr _duplicate (SteeringCmd_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SteeringCmd_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SteeringCmd_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SteeringCmd_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SteeringCmd_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SteeringCmd_TypeSupportInterface () {};
                ~SteeringCmd_TypeSupportInterface () {};
            private:
                SteeringCmd_TypeSupportInterface (const SteeringCmd_TypeSupportInterface &);
                SteeringCmd_TypeSupportInterface & operator = (const SteeringCmd_TypeSupportInterface &);
            };

            class  SteeringCmd_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SteeringCmd_DataWriter_ptr _ptr_type;
                typedef SteeringCmd_DataWriter_var _var_type;

                static SteeringCmd_DataWriter_ptr _duplicate (SteeringCmd_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SteeringCmd_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SteeringCmd_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SteeringCmd_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SteeringCmd_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SteeringCmd_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SteeringCmd_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SteeringCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SteeringCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SteeringCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SteeringCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SteeringCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SteeringCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SteeringCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SteeringCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SteeringCmd_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SteeringCmd_& instance_data) = 0;

            protected:
                SteeringCmd_DataWriter () {};
                ~SteeringCmd_DataWriter () {};
            private:
                SteeringCmd_DataWriter (const SteeringCmd_DataWriter &);
                SteeringCmd_DataWriter & operator = (const SteeringCmd_DataWriter &);
            };

            class  SteeringCmd_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SteeringCmd_DataReader_ptr _ptr_type;
                typedef SteeringCmd_DataReader_var _var_type;

                static SteeringCmd_DataReader_ptr _duplicate (SteeringCmd_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SteeringCmd_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SteeringCmd_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SteeringCmd_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SteeringCmd_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SteeringCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SteeringCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SteeringCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SteeringCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SteeringCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SteeringCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SteeringCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SteeringCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SteeringCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SteeringCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SteeringCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SteeringCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SteeringCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SteeringCmd_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SteeringCmd_& instance) = 0;

            protected:
                SteeringCmd_DataReader () {};
                ~SteeringCmd_DataReader () {};
            private:
                SteeringCmd_DataReader (const SteeringCmd_DataReader &);
                SteeringCmd_DataReader & operator = (const SteeringCmd_DataReader &);
            };

            class  SteeringCmd_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SteeringCmd_DataReaderView_ptr _ptr_type;
                typedef SteeringCmd_DataReaderView_var _var_type;

                static SteeringCmd_DataReaderView_ptr _duplicate (SteeringCmd_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SteeringCmd_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SteeringCmd_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SteeringCmd_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SteeringCmd_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SteeringCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SteeringCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SteeringCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SteeringCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SteeringCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SteeringCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SteeringCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SteeringCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SteeringCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SteeringCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SteeringCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SteeringCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SteeringCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SteeringCmd_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SteeringCmd_& instance) = 0;

            protected:
                SteeringCmd_DataReaderView () {};
                ~SteeringCmd_DataReaderView () {};
            private:
                SteeringCmd_DataReaderView (const SteeringCmd_DataReaderView &);
                SteeringCmd_DataReaderView & operator = (const SteeringCmd_DataReaderView &);
            };
        }

    }

}

#endif
