#ifndef H_1E4E9D6B506B26DC80967F294F288A85_SteeringReport_SPLTYPES_H
#define H_1E4E9D6B506B26DC80967F294F288A85_SteeringReport_SPLTYPES_H

#include <c_base.h>
#include <c_misc.h>
#include <c_sync.h>
#include <c_collection.h>
#include <c_field.h>
#include <v_copyIn.h>

#include "ccpp_SteeringReport_.h"
#include "std_msgs/msg/dds_opensplice/Header_SplDcps.h"
#include "raptor_dbw_msgs/msg/dds_opensplice/ActuatorControlMode_SplDcps.h"



extern c_metaObject __SteeringReport__raptor_dbw_msgs__load (c_base base);

extern c_metaObject __SteeringReport__raptor_dbw_msgs_msg__load (c_base base);

extern c_metaObject __SteeringReport__raptor_dbw_msgs_msg_dds___load (c_base base);

extern const char *raptor_dbw_msgs_msg_dds__SteeringReport__metaDescriptor[];
extern const int raptor_dbw_msgs_msg_dds__SteeringReport__metaDescriptorArrLength;
extern const int raptor_dbw_msgs_msg_dds__SteeringReport__metaDescriptorLength;
extern c_metaObject __raptor_dbw_msgs_msg_dds__SteeringReport___load (c_base base);
struct _raptor_dbw_msgs_msg_dds__SteeringReport_ ;
extern  v_copyin_result __raptor_dbw_msgs_msg_dds__SteeringReport___copyIn(c_base base, const struct raptor_dbw_msgs::msg::dds_::SteeringReport_ *from, struct _raptor_dbw_msgs_msg_dds__SteeringReport_ *to);
extern  void __raptor_dbw_msgs_msg_dds__SteeringReport___copyOut(const void *_from, void *_to);
struct _raptor_dbw_msgs_msg_dds__SteeringReport_ {
    struct _std_msgs_msg_dds__Header_ header_;
    c_float steering_wheel_angle_;
    c_float steering_wheel_angle_cmd_;
    c_float steering_wheel_torque_;
    c_bool enabled_;
    c_bool driver_activity_;
    c_bool fault_steering_system_;
    c_bool overheat_prevention_mode_;
    c_octet rolling_counter_;
    struct _raptor_dbw_msgs_msg_dds__ActuatorControlMode_ control_type_;
    c_bool steering_overheat_warning_;
};

#undef OS_API
#endif
