#ifndef H_CC55B9808B7A630AC32816223829AD1F_SurroundReport_SPLTYPES_H
#define H_CC55B9808B7A630AC32816223829AD1F_SurroundReport_SPLTYPES_H

#include <c_base.h>
#include <c_misc.h>
#include <c_sync.h>
#include <c_collection.h>
#include <c_field.h>
#include <v_copyIn.h>

#include "ccpp_SurroundReport_.h"
#include "std_msgs/msg/dds_opensplice/Header_SplDcps.h"
#include "raptor_dbw_msgs/msg/dds_opensplice/SonarArcNum_SplDcps.h"



extern c_metaObject __SurroundReport__raptor_dbw_msgs__load (c_base base);

extern c_metaObject __SurroundReport__raptor_dbw_msgs_msg__load (c_base base);

extern c_metaObject __SurroundReport__raptor_dbw_msgs_msg_dds___load (c_base base);

extern const char *raptor_dbw_msgs_msg_dds__SurroundReport__metaDescriptor[];
extern const int raptor_dbw_msgs_msg_dds__SurroundReport__metaDescriptorArrLength;
extern const int raptor_dbw_msgs_msg_dds__SurroundReport__metaDescriptorLength;
extern c_metaObject __raptor_dbw_msgs_msg_dds__SurroundReport___load (c_base base);
struct _raptor_dbw_msgs_msg_dds__SurroundReport_ ;
extern  v_copyin_result __raptor_dbw_msgs_msg_dds__SurroundReport___copyIn(c_base base, const struct raptor_dbw_msgs::msg::dds_::SurroundReport_ *from, struct _raptor_dbw_msgs_msg_dds__SurroundReport_ *to);
extern  void __raptor_dbw_msgs_msg_dds__SurroundReport___copyOut(const void *_from, void *_to);
struct _raptor_dbw_msgs_msg_dds__SurroundReport_ {
    struct _std_msgs_msg_dds__Header_ header_;
    c_float front_radar_object_distance_;
    c_float rear_radar_object_distance_;
    struct _raptor_dbw_msgs_msg_dds__SonarArcNum_ rear_right_;
    struct _raptor_dbw_msgs_msg_dds__SonarArcNum_ rear_left_;
    struct _raptor_dbw_msgs_msg_dds__SonarArcNum_ rear_center_;
    struct _raptor_dbw_msgs_msg_dds__SonarArcNum_ front_right_;
    struct _raptor_dbw_msgs_msg_dds__SonarArcNum_ front_left_;
    struct _raptor_dbw_msgs_msg_dds__SonarArcNum_ front_center_;
    c_bool front_radar_distance_valid_;
    c_bool parking_sonar_data_valid_;
};

#undef OS_API
#endif
