#ifndef _H_4DB58D4B4F2E39DE646BBF4C3F08541E_TwistCmd_DCPS_H_
#define _H_4DB58D4B4F2E39DE646BBF4C3F08541E_TwistCmd_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "TwistCmd_.h"


namespace raptor_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class TwistCmd_TypeSupportInterface;

            typedef TwistCmd_TypeSupportInterface * TwistCmd_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < TwistCmd_TypeSupportInterface> TwistCmd_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < TwistCmd_TypeSupportInterface> TwistCmd_TypeSupportInterface_out;


            class TwistCmd_DataWriter;

            typedef TwistCmd_DataWriter * TwistCmd_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < TwistCmd_DataWriter> TwistCmd_DataWriter_var;
            typedef DDS_DCPSInterface_out < TwistCmd_DataWriter> TwistCmd_DataWriter_out;


            class TwistCmd_DataReader;

            typedef TwistCmd_DataReader * TwistCmd_DataReader_ptr;
            typedef DDS_DCPSInterface_var < TwistCmd_DataReader> TwistCmd_DataReader_var;
            typedef DDS_DCPSInterface_out < TwistCmd_DataReader> TwistCmd_DataReader_out;


            class TwistCmd_DataReaderView;

            typedef TwistCmd_DataReaderView * TwistCmd_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < TwistCmd_DataReaderView> TwistCmd_DataReaderView_var;
            typedef DDS_DCPSInterface_out < TwistCmd_DataReaderView> TwistCmd_DataReaderView_out;

            struct TwistCmd_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < TwistCmd_, struct TwistCmd_Seq_uniq_> TwistCmd_Seq;
            typedef DDS_DCPSSequence_var < TwistCmd_Seq> TwistCmd_Seq_var;
            typedef DDS_DCPSSequence_out < TwistCmd_Seq> TwistCmd_Seq_out;

            class  TwistCmd_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef TwistCmd_TypeSupportInterface_ptr _ptr_type;
                typedef TwistCmd_TypeSupportInterface_var _var_type;

                static TwistCmd_TypeSupportInterface_ptr _duplicate (TwistCmd_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TwistCmd_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static TwistCmd_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TwistCmd_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                TwistCmd_TypeSupportInterface_ptr _this () { return this; }


            protected:
                TwistCmd_TypeSupportInterface () {};
                ~TwistCmd_TypeSupportInterface () {};
            private:
                TwistCmd_TypeSupportInterface (const TwistCmd_TypeSupportInterface &);
                TwistCmd_TypeSupportInterface & operator = (const TwistCmd_TypeSupportInterface &);
            };

            class  TwistCmd_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef TwistCmd_DataWriter_ptr _ptr_type;
                typedef TwistCmd_DataWriter_var _var_type;

                static TwistCmd_DataWriter_ptr _duplicate (TwistCmd_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TwistCmd_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static TwistCmd_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TwistCmd_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                TwistCmd_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const TwistCmd_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const TwistCmd_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const TwistCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const TwistCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const TwistCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const TwistCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const TwistCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const TwistCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const TwistCmd_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const TwistCmd_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (TwistCmd_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TwistCmd_& instance_data) = 0;

            protected:
                TwistCmd_DataWriter () {};
                ~TwistCmd_DataWriter () {};
            private:
                TwistCmd_DataWriter (const TwistCmd_DataWriter &);
                TwistCmd_DataWriter & operator = (const TwistCmd_DataWriter &);
            };

            class  TwistCmd_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef TwistCmd_DataReader_ptr _ptr_type;
                typedef TwistCmd_DataReader_var _var_type;

                static TwistCmd_DataReader_ptr _duplicate (TwistCmd_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TwistCmd_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static TwistCmd_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TwistCmd_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                TwistCmd_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (TwistCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TwistCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TwistCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TwistCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TwistCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TwistCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TwistCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TwistCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TwistCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TwistCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TwistCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TwistCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TwistCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TwistCmd_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TwistCmd_& instance) = 0;

            protected:
                TwistCmd_DataReader () {};
                ~TwistCmd_DataReader () {};
            private:
                TwistCmd_DataReader (const TwistCmd_DataReader &);
                TwistCmd_DataReader & operator = (const TwistCmd_DataReader &);
            };

            class  TwistCmd_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef TwistCmd_DataReaderView_ptr _ptr_type;
                typedef TwistCmd_DataReaderView_var _var_type;

                static TwistCmd_DataReaderView_ptr _duplicate (TwistCmd_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static TwistCmd_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static TwistCmd_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static TwistCmd_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                TwistCmd_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (TwistCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (TwistCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (TwistCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (TwistCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (TwistCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (TwistCmd_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (TwistCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (TwistCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (TwistCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (TwistCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (TwistCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (TwistCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (TwistCmd_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (TwistCmd_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const TwistCmd_& instance) = 0;

            protected:
                TwistCmd_DataReaderView () {};
                ~TwistCmd_DataReaderView () {};
            private:
                TwistCmd_DataReaderView (const TwistCmd_DataReaderView &);
                TwistCmd_DataReaderView & operator = (const TwistCmd_DataReaderView &);
            };
        }

    }

}

#endif
