#ifndef _H_4EB0DCAB3543B64696971A2FE373DC03_WatchdogStatus__H_
#define _H_4EB0DCAB3543B64696971A2FE373DC03_WatchdogStatus__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace raptor_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace WatchdogStatus_Constants
            {
                const ::DDS::Octet NONE_ = 0;

                const ::DDS::Octet OTHER_BRAKE_ = 1;

                const ::DDS::Octet OTHER_ACCELERATOR_PEDAL_ = 2;

                const ::DDS::Octet OTHER_STEERING_ = 3;

                const ::DDS::Octet BRAKE_COUNTER_ = 4;

                const ::DDS::Octet BRAKE_DISABLED_ = 5;

                const ::DDS::Octet BRAKE_COMMAND_ = 6;

                const ::DDS::Octet BRAKE_REPORT_ = 7;

                const ::DDS::Octet ACCELERATOR_PEDAL_COUNTER_ = 8;

                const ::DDS::Octet ACCELERATOR_PEDAL_DISABLED_ = 9;

                const ::DDS::Octet ACCELERATOR_PEDAL_COMMAND_ = 10;

                const ::DDS::Octet ACCELERATOR_PEDAL_REPORT_ = 11;

                const ::DDS::Octet STEERING_COUNTER_ = 12;

                const ::DDS::Octet STEERING_DISABLED_ = 13;

                const ::DDS::Octet STEERING_COMMAND_ = 14;

                const ::DDS::Octet STEERING_REPORT_ = 15;

            }

            struct  WatchdogStatus_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Octet source_;
            };

            typedef DDS_DCPSStruct_var<WatchdogStatus_> WatchdogStatus__var;
            typedef DDS_DCPSStruct_out < WatchdogStatus_> WatchdogStatus__out;

        }

    }

}

#endif /* _H_4EB0DCAB3543B64696971A2FE373DC03_WatchdogStatus__H_ */
