#ifndef _H_4EB0DCAB3543B64696971A2FE373DC03_WatchdogStatus_DCPS_H_
#define _H_4EB0DCAB3543B64696971A2FE373DC03_WatchdogStatus_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "WatchdogStatus_.h"


namespace raptor_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class WatchdogStatus_TypeSupportInterface;

            typedef WatchdogStatus_TypeSupportInterface * WatchdogStatus_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < WatchdogStatus_TypeSupportInterface> WatchdogStatus_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < WatchdogStatus_TypeSupportInterface> WatchdogStatus_TypeSupportInterface_out;


            class WatchdogStatus_DataWriter;

            typedef WatchdogStatus_DataWriter * WatchdogStatus_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < WatchdogStatus_DataWriter> WatchdogStatus_DataWriter_var;
            typedef DDS_DCPSInterface_out < WatchdogStatus_DataWriter> WatchdogStatus_DataWriter_out;


            class WatchdogStatus_DataReader;

            typedef WatchdogStatus_DataReader * WatchdogStatus_DataReader_ptr;
            typedef DDS_DCPSInterface_var < WatchdogStatus_DataReader> WatchdogStatus_DataReader_var;
            typedef DDS_DCPSInterface_out < WatchdogStatus_DataReader> WatchdogStatus_DataReader_out;


            class WatchdogStatus_DataReaderView;

            typedef WatchdogStatus_DataReaderView * WatchdogStatus_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < WatchdogStatus_DataReaderView> WatchdogStatus_DataReaderView_var;
            typedef DDS_DCPSInterface_out < WatchdogStatus_DataReaderView> WatchdogStatus_DataReaderView_out;

            struct WatchdogStatus_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < WatchdogStatus_, struct WatchdogStatus_Seq_uniq_> WatchdogStatus_Seq;
            typedef DDS_DCPSSequence_var < WatchdogStatus_Seq> WatchdogStatus_Seq_var;
            typedef DDS_DCPSSequence_out < WatchdogStatus_Seq> WatchdogStatus_Seq_out;

            class  WatchdogStatus_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef WatchdogStatus_TypeSupportInterface_ptr _ptr_type;
                typedef WatchdogStatus_TypeSupportInterface_var _var_type;

                static WatchdogStatus_TypeSupportInterface_ptr _duplicate (WatchdogStatus_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static WatchdogStatus_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static WatchdogStatus_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static WatchdogStatus_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                WatchdogStatus_TypeSupportInterface_ptr _this () { return this; }


            protected:
                WatchdogStatus_TypeSupportInterface () {};
                ~WatchdogStatus_TypeSupportInterface () {};
            private:
                WatchdogStatus_TypeSupportInterface (const WatchdogStatus_TypeSupportInterface &);
                WatchdogStatus_TypeSupportInterface & operator = (const WatchdogStatus_TypeSupportInterface &);
            };

            class  WatchdogStatus_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef WatchdogStatus_DataWriter_ptr _ptr_type;
                typedef WatchdogStatus_DataWriter_var _var_type;

                static WatchdogStatus_DataWriter_ptr _duplicate (WatchdogStatus_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static WatchdogStatus_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static WatchdogStatus_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static WatchdogStatus_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                WatchdogStatus_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const WatchdogStatus_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const WatchdogStatus_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const WatchdogStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const WatchdogStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const WatchdogStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const WatchdogStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const WatchdogStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const WatchdogStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const WatchdogStatus_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const WatchdogStatus_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (WatchdogStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const WatchdogStatus_& instance_data) = 0;

            protected:
                WatchdogStatus_DataWriter () {};
                ~WatchdogStatus_DataWriter () {};
            private:
                WatchdogStatus_DataWriter (const WatchdogStatus_DataWriter &);
                WatchdogStatus_DataWriter & operator = (const WatchdogStatus_DataWriter &);
            };

            class  WatchdogStatus_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef WatchdogStatus_DataReader_ptr _ptr_type;
                typedef WatchdogStatus_DataReader_var _var_type;

                static WatchdogStatus_DataReader_ptr _duplicate (WatchdogStatus_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static WatchdogStatus_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static WatchdogStatus_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static WatchdogStatus_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                WatchdogStatus_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (WatchdogStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (WatchdogStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (WatchdogStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (WatchdogStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (WatchdogStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (WatchdogStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (WatchdogStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (WatchdogStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (WatchdogStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (WatchdogStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (WatchdogStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (WatchdogStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (WatchdogStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (WatchdogStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const WatchdogStatus_& instance) = 0;

            protected:
                WatchdogStatus_DataReader () {};
                ~WatchdogStatus_DataReader () {};
            private:
                WatchdogStatus_DataReader (const WatchdogStatus_DataReader &);
                WatchdogStatus_DataReader & operator = (const WatchdogStatus_DataReader &);
            };

            class  WatchdogStatus_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef WatchdogStatus_DataReaderView_ptr _ptr_type;
                typedef WatchdogStatus_DataReaderView_var _var_type;

                static WatchdogStatus_DataReaderView_ptr _duplicate (WatchdogStatus_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static WatchdogStatus_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static WatchdogStatus_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static WatchdogStatus_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                WatchdogStatus_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (WatchdogStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (WatchdogStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (WatchdogStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (WatchdogStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (WatchdogStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (WatchdogStatus_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (WatchdogStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (WatchdogStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (WatchdogStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (WatchdogStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (WatchdogStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (WatchdogStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (WatchdogStatus_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (WatchdogStatus_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const WatchdogStatus_& instance) = 0;

            protected:
                WatchdogStatus_DataReaderView () {};
                ~WatchdogStatus_DataReaderView () {};
            private:
                WatchdogStatus_DataReaderView (const WatchdogStatus_DataReaderView &);
                WatchdogStatus_DataReaderView & operator = (const WatchdogStatus_DataReaderView &);
            };
        }

    }

}

#endif
