#ifndef _H_F95B75DFEF52FD282179683A06303AA4_WheelPositionReport__H_
#define _H_F95B75DFEF52FD282179683A06303AA4_WheelPositionReport__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"
#include "std_msgs/msg/dds_opensplice/Header_.h"


namespace raptor_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            struct  WheelPositionReport_
            {
                ::std_msgs::msg::dds_::Header_ header_;
                ::DDS::Short front_left_;
                ::DDS::Short front_right_;
                ::DDS::Short rear_left_;
                ::DDS::Short rear_right_;
                ::DDS::Float wheel_pulses_per_rev_;
            };

            typedef DDS_DCPSStruct_var<WheelPositionReport_> WheelPositionReport__var;
            typedef DDS_DCPSStruct_out < WheelPositionReport_> WheelPositionReport__out;

        }

    }

}

#endif /* _H_F95B75DFEF52FD282179683A06303AA4_WheelPositionReport__H_ */
