#ifndef _H_F95B75DFEF52FD282179683A06303AA4_WheelPositionReport_DCPS_H_
#define _H_F95B75DFEF52FD282179683A06303AA4_WheelPositionReport_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "WheelPositionReport_.h"


namespace raptor_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class WheelPositionReport_TypeSupportInterface;

            typedef WheelPositionReport_TypeSupportInterface * WheelPositionReport_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < WheelPositionReport_TypeSupportInterface> WheelPositionReport_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < WheelPositionReport_TypeSupportInterface> WheelPositionReport_TypeSupportInterface_out;


            class WheelPositionReport_DataWriter;

            typedef WheelPositionReport_DataWriter * WheelPositionReport_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < WheelPositionReport_DataWriter> WheelPositionReport_DataWriter_var;
            typedef DDS_DCPSInterface_out < WheelPositionReport_DataWriter> WheelPositionReport_DataWriter_out;


            class WheelPositionReport_DataReader;

            typedef WheelPositionReport_DataReader * WheelPositionReport_DataReader_ptr;
            typedef DDS_DCPSInterface_var < WheelPositionReport_DataReader> WheelPositionReport_DataReader_var;
            typedef DDS_DCPSInterface_out < WheelPositionReport_DataReader> WheelPositionReport_DataReader_out;


            class WheelPositionReport_DataReaderView;

            typedef WheelPositionReport_DataReaderView * WheelPositionReport_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < WheelPositionReport_DataReaderView> WheelPositionReport_DataReaderView_var;
            typedef DDS_DCPSInterface_out < WheelPositionReport_DataReaderView> WheelPositionReport_DataReaderView_out;

            struct WheelPositionReport_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < WheelPositionReport_, struct WheelPositionReport_Seq_uniq_> WheelPositionReport_Seq;
            typedef DDS_DCPSSequence_var < WheelPositionReport_Seq> WheelPositionReport_Seq_var;
            typedef DDS_DCPSSequence_out < WheelPositionReport_Seq> WheelPositionReport_Seq_out;

            class  WheelPositionReport_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef WheelPositionReport_TypeSupportInterface_ptr _ptr_type;
                typedef WheelPositionReport_TypeSupportInterface_var _var_type;

                static WheelPositionReport_TypeSupportInterface_ptr _duplicate (WheelPositionReport_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static WheelPositionReport_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static WheelPositionReport_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static WheelPositionReport_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                WheelPositionReport_TypeSupportInterface_ptr _this () { return this; }


            protected:
                WheelPositionReport_TypeSupportInterface () {};
                ~WheelPositionReport_TypeSupportInterface () {};
            private:
                WheelPositionReport_TypeSupportInterface (const WheelPositionReport_TypeSupportInterface &);
                WheelPositionReport_TypeSupportInterface & operator = (const WheelPositionReport_TypeSupportInterface &);
            };

            class  WheelPositionReport_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef WheelPositionReport_DataWriter_ptr _ptr_type;
                typedef WheelPositionReport_DataWriter_var _var_type;

                static WheelPositionReport_DataWriter_ptr _duplicate (WheelPositionReport_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static WheelPositionReport_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static WheelPositionReport_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static WheelPositionReport_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                WheelPositionReport_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const WheelPositionReport_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const WheelPositionReport_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const WheelPositionReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const WheelPositionReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const WheelPositionReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const WheelPositionReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const WheelPositionReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const WheelPositionReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const WheelPositionReport_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const WheelPositionReport_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (WheelPositionReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const WheelPositionReport_& instance_data) = 0;

            protected:
                WheelPositionReport_DataWriter () {};
                ~WheelPositionReport_DataWriter () {};
            private:
                WheelPositionReport_DataWriter (const WheelPositionReport_DataWriter &);
                WheelPositionReport_DataWriter & operator = (const WheelPositionReport_DataWriter &);
            };

            class  WheelPositionReport_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef WheelPositionReport_DataReader_ptr _ptr_type;
                typedef WheelPositionReport_DataReader_var _var_type;

                static WheelPositionReport_DataReader_ptr _duplicate (WheelPositionReport_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static WheelPositionReport_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static WheelPositionReport_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static WheelPositionReport_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                WheelPositionReport_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (WheelPositionReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (WheelPositionReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (WheelPositionReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (WheelPositionReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (WheelPositionReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (WheelPositionReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (WheelPositionReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (WheelPositionReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (WheelPositionReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (WheelPositionReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (WheelPositionReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (WheelPositionReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (WheelPositionReport_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (WheelPositionReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const WheelPositionReport_& instance) = 0;

            protected:
                WheelPositionReport_DataReader () {};
                ~WheelPositionReport_DataReader () {};
            private:
                WheelPositionReport_DataReader (const WheelPositionReport_DataReader &);
                WheelPositionReport_DataReader & operator = (const WheelPositionReport_DataReader &);
            };

            class  WheelPositionReport_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef WheelPositionReport_DataReaderView_ptr _ptr_type;
                typedef WheelPositionReport_DataReaderView_var _var_type;

                static WheelPositionReport_DataReaderView_ptr _duplicate (WheelPositionReport_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static WheelPositionReport_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static WheelPositionReport_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static WheelPositionReport_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                WheelPositionReport_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (WheelPositionReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (WheelPositionReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (WheelPositionReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (WheelPositionReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (WheelPositionReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (WheelPositionReport_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (WheelPositionReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (WheelPositionReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (WheelPositionReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (WheelPositionReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (WheelPositionReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (WheelPositionReport_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (WheelPositionReport_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (WheelPositionReport_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const WheelPositionReport_& instance) = 0;

            protected:
                WheelPositionReport_DataReaderView () {};
                ~WheelPositionReport_DataReaderView () {};
            private:
                WheelPositionReport_DataReaderView (const WheelPositionReport_DataReaderView &);
                WheelPositionReport_DataReaderView & operator = (const WheelPositionReport_DataReaderView &);
            };
        }

    }

}

#endif
