#ifndef _H_B1E6FC1D8AFF72B94D439187A352F7AC_WiperFront__H_
#define _H_B1E6FC1D8AFF72B94D439187A352F7AC_WiperFront__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace raptor_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace WiperFront_Constants
            {
                const ::DDS::Octet OFF_ = 0;

                const ::DDS::Octet INTERVAL_1_ = 1;

                const ::DDS::Octet INTERVAL_2_ = 2;

                const ::DDS::Octet INTERVAL_3_ = 3;

                const ::DDS::Octet INTERVAL_4_ = 4;

                const ::DDS::Octet INTERVAL_5_ = 5;

                const ::DDS::Octet INTERVAL_6_ = 6;

                const ::DDS::Octet CONSTANT_LOW_ = 11;

                const ::DDS::Octet CONSTANT_HIGH_ = 12;

                const ::DDS::Octet WASH_BRIEF_ = 13;

                const ::DDS::Octet WASH_CONTINUOUS_ = 14;

                const ::DDS::Octet SNA_ = 15;

            }

            struct  WiperFront_
            {
                ::DDS::Octet status_;
            };

            typedef DDS_DCPSStruct_var<WiperFront_> WiperFront__var;
            typedef WiperFront_& WiperFront__out;

        }

    }

}

#endif /* _H_B1E6FC1D8AFF72B94D439187A352F7AC_WiperFront__H_ */
