#ifndef _H_B1E6FC1D8AFF72B94D439187A352F7AC_WiperFront_DCPS_H_
#define _H_B1E6FC1D8AFF72B94D439187A352F7AC_WiperFront_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "WiperFront_.h"


namespace raptor_dbw_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class WiperFront_TypeSupportInterface;

            typedef WiperFront_TypeSupportInterface * WiperFront_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < WiperFront_TypeSupportInterface> WiperFront_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < WiperFront_TypeSupportInterface> WiperFront_TypeSupportInterface_out;


            class WiperFront_DataWriter;

            typedef WiperFront_DataWriter * WiperFront_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < WiperFront_DataWriter> WiperFront_DataWriter_var;
            typedef DDS_DCPSInterface_out < WiperFront_DataWriter> WiperFront_DataWriter_out;


            class WiperFront_DataReader;

            typedef WiperFront_DataReader * WiperFront_DataReader_ptr;
            typedef DDS_DCPSInterface_var < WiperFront_DataReader> WiperFront_DataReader_var;
            typedef DDS_DCPSInterface_out < WiperFront_DataReader> WiperFront_DataReader_out;


            class WiperFront_DataReaderView;

            typedef WiperFront_DataReaderView * WiperFront_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < WiperFront_DataReaderView> WiperFront_DataReaderView_var;
            typedef DDS_DCPSInterface_out < WiperFront_DataReaderView> WiperFront_DataReaderView_out;

            struct WiperFront_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < WiperFront_, struct WiperFront_Seq_uniq_> WiperFront_Seq;
            typedef DDS_DCPSSequence_var < WiperFront_Seq> WiperFront_Seq_var;
            typedef DDS_DCPSSequence_out < WiperFront_Seq> WiperFront_Seq_out;

            class  WiperFront_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef WiperFront_TypeSupportInterface_ptr _ptr_type;
                typedef WiperFront_TypeSupportInterface_var _var_type;

                static WiperFront_TypeSupportInterface_ptr _duplicate (WiperFront_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static WiperFront_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static WiperFront_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static WiperFront_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                WiperFront_TypeSupportInterface_ptr _this () { return this; }


            protected:
                WiperFront_TypeSupportInterface () {};
                ~WiperFront_TypeSupportInterface () {};
            private:
                WiperFront_TypeSupportInterface (const WiperFront_TypeSupportInterface &);
                WiperFront_TypeSupportInterface & operator = (const WiperFront_TypeSupportInterface &);
            };

            class  WiperFront_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef WiperFront_DataWriter_ptr _ptr_type;
                typedef WiperFront_DataWriter_var _var_type;

                static WiperFront_DataWriter_ptr _duplicate (WiperFront_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static WiperFront_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static WiperFront_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static WiperFront_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                WiperFront_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const WiperFront_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const WiperFront_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const WiperFront_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const WiperFront_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const WiperFront_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const WiperFront_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const WiperFront_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const WiperFront_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const WiperFront_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const WiperFront_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (WiperFront_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const WiperFront_& instance_data) = 0;

            protected:
                WiperFront_DataWriter () {};
                ~WiperFront_DataWriter () {};
            private:
                WiperFront_DataWriter (const WiperFront_DataWriter &);
                WiperFront_DataWriter & operator = (const WiperFront_DataWriter &);
            };

            class  WiperFront_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef WiperFront_DataReader_ptr _ptr_type;
                typedef WiperFront_DataReader_var _var_type;

                static WiperFront_DataReader_ptr _duplicate (WiperFront_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static WiperFront_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static WiperFront_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static WiperFront_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                WiperFront_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (WiperFront_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (WiperFront_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (WiperFront_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (WiperFront_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (WiperFront_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (WiperFront_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (WiperFront_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (WiperFront_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (WiperFront_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (WiperFront_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (WiperFront_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (WiperFront_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (WiperFront_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (WiperFront_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const WiperFront_& instance) = 0;

            protected:
                WiperFront_DataReader () {};
                ~WiperFront_DataReader () {};
            private:
                WiperFront_DataReader (const WiperFront_DataReader &);
                WiperFront_DataReader & operator = (const WiperFront_DataReader &);
            };

            class  WiperFront_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef WiperFront_DataReaderView_ptr _ptr_type;
                typedef WiperFront_DataReaderView_var _var_type;

                static WiperFront_DataReaderView_ptr _duplicate (WiperFront_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static WiperFront_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static WiperFront_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static WiperFront_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                WiperFront_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (WiperFront_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (WiperFront_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (WiperFront_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (WiperFront_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (WiperFront_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (WiperFront_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (WiperFront_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (WiperFront_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (WiperFront_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (WiperFront_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (WiperFront_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (WiperFront_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (WiperFront_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (WiperFront_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const WiperFront_& instance) = 0;

            protected:
                WiperFront_DataReaderView () {};
                ~WiperFront_DataReaderView () {};
            private:
                WiperFront_DataReaderView (const WiperFront_DataReaderView &);
                WiperFront_DataReaderView & operator = (const WiperFront_DataReaderView &);
            };
        }

    }

}

#endif
